  BITS 16                      ; 16-Bit, Realmode.
  ORG 0h                       ; Bootsektor.
;ͻ
; START                                                                     
;  Funktion       : Einsprungspunkt fr die Bios-Routine, mu bei 0h sein.  
;  Parameter      : DL=Quelllaufwerk                                        
;ͼ
START:
  JMP SHORT BOOT               ; 4 Bytes fr JMPs.
  NOP
  NOP
  DISKSYSID DD 'RS3D'          ; Datentrgersystem (DMAN)
  STARTSEC DD 0
  _BOOTBLOCKSIZE DD 0 ; Ignore !
; Variablen fr den internen gebrauch.
  STARTA DW 0                  ; Aufruf-Struktur fr den Bootblock.
         DW 1000h
  AKTSEG DW 1000h              ; Segmentzeiger fr den Ladevorgang.
  BOOTDRV DB 0                 ; Bootlaufwerk (Bios-Nummer).
BOOT:
  CLD                          ; links, rechts dann geradeaus...
  XOR AX,AX
  MOV SS,AX
  MOV SP,7C00h
  MOV AX,07C0h                 ; Datensegment fr Bootsektor.
  MOV DS,AX
  MOV [BOOTDRV],DL             ; Bootlaufwerk sichern.
  CALL 07C0h:BOOT7C0           ; Codesegment normen (7C0).
 BOOT7C0:
  MOV AX,3                     ; Bios-Textmodus 3 setzen.
  INT 10h
  XOR AX,AX                    ; Diskettenlaufwerk reseten.
  INT 13h
  MOV AH,8h                    ; 
  MOV DL,[BOOTDRV]             ;  Informationen ber das Bootlaufwerk
  INT 13h                      ;  ermitteln.
  MOV [LASTPAGE],DH            ;  (Die oberen 2 Bits von CL (Sektor),
  MOV AL,CL                    ;  werden fr die Bits 8 und 9 vom Track
  AND AL,00111111b             ;  benutzt.
  MOV [LASTSEC],AL             ; 
  MOV [LASTTRACK],CH           ; 
  SHR CL,6                     ; 
  MOV [LASTTRACK+1],CL         ; 
  INC DWORD [STARTSEC]
  MOV EDI,[STARTSEC]
  CALL READSEKTOR
  MOV AX,[AKTSEG]
  MOV FS,AX  
  MOV ECX,[FS:4]
  MOV EAX,ECX
  SHR ECX,9                 ; Hard wired to 512 (!!!)
  OR ECX,ECX
  JZ CALLLOADER
  TEST EAX,511              ; again
  JNZ HASHALFSEC
  DEC ECX
 HASHALFSEC:
  OR ECX,ECX
  JZ CALLLOADER
 RD_LP:
  ADD [AKTSEG],WORD 32
  INC DWORD [STARTSEC]
  MOV EDI,[STARTSEC]
  PUSH ECX
  CALL READSEKTOR
  POP ECX
  DEC ECX                      ; Weitere Sektoren bentigt ?
  JNE RD_LP
 CALLLOADER:
  MOV DL,[BOOTDRV]
  MOV EDI,[STARTSEC]
  INC EDI
  CALL FAR [STARTA]            ; Loader aufrufen
  MOV BP,BS_TERMMSG
  MOV CX,59
  CALL PRINTSTR
 TERM:                         ; Endlosschleife...
  JMP TERM
 SECTORERR:
  MOV AX,3
  INT 10h
  MOV BP,SECTORERR_MSG
  MOV CX,25
  CALL PRINTSTR
  JMP TERM
SECTORERR_MSG DB 'Diskette ist beschdigt !'
BS_TERMMSG DB 'STRG+ALT+ENTF startet den Computer neu. Abschalten erlaubt.'
PRINTSTR:
  MOV AX,CS                    ; 
  MOV ES,AX                    ;  Zeichenkette ausgeben.
  MOV AL,0h                    ; 
  MOV AH,13h                   ; 
  MOV BX,14                    ; 
  XOR DX,DX                    ; 
  INT 10h                      ; 
  RET
;ͻ
; READSEKTOR                                                                
;  Funktion       : Liest einen Sektor von Diskette.                        
;  Parameter      : EDI=Sektornummer (0..x)                                 
;ͼ
READSEKTOR:
  XOR EDX,EDX                  ; 
  MOV EAX,EDI                  ;  Sektor entschlsseln.
  MOV EBX,[LASTSEC]            ; 
  DIV EBX                      ; 
  INC EDX                      ; 
  MOV [SEKTOR_SE],EDX          ; 
  XOR EDX,EDX                  ; 
  MOV EBX,[LASTPAGE]           ;  Kopf entschlsseln.
  INC EBX                      ; 
  DIV EBX                      ; 
  MOV [SEKTOR_PG],EDX          ; 
  XOR EDX,EDX                  ; 
  MOV EBX,[LASTTRACK]          ;  Track entschlsseln.
  INC EBX                      ; 
  DIV EBX                      ; 
  MOV [SEKTOR_TR],EDX          ; 
  MOV [READSEKTOR_TRY],BYTE 20 ; Anzahl versuche.
 READSEKTOR_LP:
  MOV AX,201h                  ; 
  MOV DL,[BOOTDRV]             ;  Versuchen den Sektor zu lesen.
  MOV DH,[SEKTOR_PG]           ;  (Sektor/Track Patch :
  MOV CH,[SEKTOR_TR]           ;   Die obersten 2 Bits von CL (Sektor),
  MOV CL,[SEKTOR_SE]           ;   werden fr die Bits 8 und 9 vom Track
  MOV BL,[SEKTOR_TR+1]         ;   benutzt !)
  SHL BL,6                     ; 
  OR CL,BL                     ; 
  MOV ES,[AKTSEG]              ; 
  XOR BX,BX                    ; 
  PUSH DS                      ; 
  INT 13h                      ; 
  POP DS                       ; 
  JNC READSEKTOR_SUCCES        ; Konnte der Sektor gelesen werden ?
  DEC BYTE [READSEKTOR_TRY]    ; Ein Versuch weniger...
  JZ NEAR SECTORERR            ; Noch welche da ?
  XOR AX,AX
  MOV DL,[BOOTDRV]
  INT 13h
  JMP READSEKTOR_LP
 READSEKTOR_SUCCES:
  RET                          ; Fertig ?
READSEKTOR_TRY: DB 0           ; Zhler fr die Leseversuche auf Diskette.
SEKTOR_PG: DD 0                ; Entschlsselter Kopf.
SEKTOR_TR: DD 0                ; Entschlsselter Track.
SEKTOR_SE: DD 0                ; Entschlsselter Sektor.
LASTPAGE: DD 0                 ; Letzter Kopf.
LASTTRACK: DD 0                ; Letzter Track.
LASTSEC: DD 0                  ; Letzter Sektor.
