#define PASCAL __attribute__((stdcall))
#define DWORD unsigned long
/* Parameter vom STUB */
DWORD PARABLOCK;
DWORD PARABLOCKSIZE;
DWORD PROG_BASE;
DWORD PROG_SIZE;
DWORD PROG_BSS;
/* Standard-Typen */
typedef struct
{
  DWORD next;
  DWORD last;
  DWORD typ;
  DWORD id;
  void * (*getprot)(DWORD)PASCAL;
  char desc[256];
} system_tdriver;
/* bergebene Funktion */
void (*EXPLSHUTDOWN)()PASCAL;
void ** (*INITDRVSYS)(DWORD nr)PASCAL;
/* Gewhlte Treiber */
system_tdriver * system_tasks_driver;
system_tdriver * system_debug_driver;
system_tdriver * system_mem_driver;
/* PProzeduren von DRIVER */
system_tdriver * (*system_finddriver)(DWORD typ,DWORD id,DWORD * group)PASCAL;
system_tdriver * (*system_findadriver)(DWORD typ,DWORD *group)PASCAL;
system_tdriver * (*system_findnextadriver)(system_tdriver * p,DWORD typ)PASCAL;
void (*system_findclosedriver)(DWORD group)PASCAL;
void (*system_adddriverc)(system_tdriver *p)PASCAL;
system_tdriver * (*system_getfirstdriver)()PASCAL;
void (*system_startreadingdriverlist)(DWORD *)PASCAL;
void (*system_stopreadingdriverlist)(DWORD)PASCAL;
void (*system_shutdown)(system_tdriver *)PASCAL;
void (*system_reboot)()PASCAL;
void (*system_signalshutdownok)()PASCAL;
void (*system_startdriverinitialization)()PASCAL;
void (*system_stopdriverinitialization)()PASCAL;
/* PProzeduren fr TASKS */
void (*system_schedule)()PASCAL;
void * (*system_createprocess)(DWORD * father,DWORD maxp,char desc [256])PASCAL;
void * (*system_createtask)(DWORD * process,void * ofs,DWORD prio,char desc [256])PASCAL;
void (*system_destroyprocess)(DWORD *process,DWORD *cb)PASCAL;
void (*system_destroytask)(DWORD *process,DWORD *cb)PASCAL;
DWORD * (*system_gettaskhandle)()PASCAL;
DWORD * (*system_getprocesshandle)()PASCAL;
void (*system_settaskprio)(DWORD *task,DWORD prio)PASCAL;
void (*system_enabletask)(DWORD *task)PASCAL;
void (*system_disabletask)(DWORD *task)PASCAL;
void (*system_destroydriver)(DWORD *base,DWORD size,DWORD *process)PASCAL;
void (*system_senabletask)(DWORD *task)PASCAL;
void (*system_sdisabletask)(DWORD *task)PASCAL;
void (*system_changeprocessdesc)(DWORD *process,char [256])PASCAL;
void (*system_changetaskdesc)(DWORD *task,char [256])PASCAL;
DWORD * (*system_getsystemprocess)()PASCAL;
void (*system_destroydrivertask)(DWORD *base,DWORD size,DWORD *task)PASCAL;
/* PProzeduren von DEBUG */
void (*printstrc)(char str [256])PASCAL;
void (*printstrlnc)(char str [256])PASCAL;
void (*printhex)(DWORD w)PASCAL;
void (*printhexln)(DWORD w)PASCAL;
void (*system_setdebugflag)(DWORD nr,DWORD w)PASCAL;
DWORD (*system_getdebugflag)(DWORD nr)PASCAL;
/* PProzeduren von MEM */
void * (*allocmem)(DWORD size)PASCAL;
void (*releasemem)(void *p,DWORD size)PASCAL;
DWORD (*system_getpagebits)()PASCAL;
void * (*system_mapspace)(DWORD base,DWORD size)PASCAL;
void (*system_unmapspace)(void *,DWORD size)PASCAL;
DWORD (*system_getpageframe)(DWORD)PASCAL;
/* Prozeduren von DRIVER */
void **system_searchadriver(DWORD typ,DWORD prot,system_tdriver ** p)
{
 DWORD group;
 void * x;
 (*p)=system_findadriver(typ,&group);
 do{
  if (!(*p))
  {
   system_findclosedriver(group);
   return 0;
  }
  x=(*p)->getprot(prot);
  if (!x) (*p)=system_findnextadriver((*p),typ);
 } while (!x);
 system_findclosedriver(group);
 return (void **)x;
}
void **system_waitforadriver(DWORD typ,DWORD prot,system_tdriver ** p)
{
 void *x;
 do{
  x=(void *)system_searchadriver(typ,prot,p);
  if(!x) system_schedule();
 } while (!x);
 return (void **)x;
}
void system_init_drv()
{
 void **p;
 p=INITDRVSYS(1);
 system_finddriver=(system_tdriver * PASCAL (*)(DWORD,DWORD,DWORD *))p[0];
 system_findadriver=(system_tdriver * PASCAL (*)(DWORD,DWORD *))p[1];
 system_findnextadriver=(system_tdriver * PASCAL (*)(system_tdriver *,DWORD))p[2];
 system_findclosedriver=(void PASCAL (*)(DWORD))p[3];
 system_adddriverc=(void PASCAL (*)(system_tdriver *))p[4];
 system_getfirstdriver=(system_tdriver * PASCAL (*)())p[5];
 system_startreadingdriverlist=(void PASCAL (*)(DWORD *))p[6];
 system_stopreadingdriverlist=(void PASCAL (*)(DWORD))p[7];
 system_shutdown=(void PASCAL (*)(system_tdriver *))p[8];
 system_signalshutdownok=(void PASCAL (*)())p[9];
 system_startdriverinitialization=(void PASCAL (*)())p[10];
 system_stopdriverinitialization=(void PASCAL (*)())p[11];
 system_reboot=(void PASCAL (*)())p[12];
}
/* Prozedur von TASKS */
void system_init_tasks()
{
 void **p;
 p=system_searchadriver(1,1,&system_tasks_driver);
 system_schedule=(void PASCAL (*)())p[0];
 system_createprocess=(void * PASCAL (*)(DWORD *,DWORD,char [256]))p[1];
 system_createtask=(void * PASCAL (*)(DWORD *,void *,DWORD prio,char [256]))p[2];
 system_destroyprocess=(void PASCAL (*)(DWORD *,DWORD *))p[3];
 system_destroytask=(void PASCAL (*)(DWORD *,DWORD *))p[4];
 system_getprocesshandle=(DWORD * PASCAL (*)())p[5];
 system_gettaskhandle=(DWORD * PASCAL (*)())p[6];
 system_settaskprio=(void PASCAL (*)(DWORD *,DWORD))p[7];
 system_enabletask=(void PASCAL (*)(DWORD *))p[8];
 system_disabletask=(void PASCAL (*)(DWORD *))p[9];
 system_destroydriver=(void PASCAL (*)(DWORD *,DWORD,DWORD *))p[10];
 system_senabletask=(void PASCAL (*)(DWORD *))p[11];
 system_sdisabletask=(void PASCAL (*)(DWORD *))p[12];
 system_changeprocessdesc=(void PASCAL (*)(DWORD *,char [256]))p[13];
 system_changetaskdesc=(void PASCAL (*)(DWORD *,char [256]))p[14];
 system_getsystemprocess=(DWORD * PASCAL (*)())p[15];
 system_destroydrivertask=(void PASCAL (*)(DWORD *,DWORD,DWORD *))p[16];
}
/* Prozeduren DEBUG */
void printstrln(char x[256])
{
 unsigned char l;
 unsigned char i;
 i=0;
 l=0;
 while (i<255)
 {
  if (x[i]==0) break;
  l++;
  i++;
 }
 for (i=l-1;i!=255;i--) x[i+1]=x[i];
 x[0]=l;
 printstrlnc(x);
}
void printstr(char x[256])
{
 unsigned char l=0;
 unsigned char i=0;
 while (i<255)
 {
  if (x[i]==0) break;
  l++;
  i++;
 }
 for (i=l-1;i!=255;i--) x[i+1]=x[i];
 x[0]=l;
 printstrc(x);
}
void system_init_debug()
{
 void **p;
 p=system_searchadriver(3,1,&system_debug_driver);
 printstrc=(void PASCAL (*)(char [256]))p[0];
 printstrlnc=(void PASCAL (*)(char [256]))p[1];
 printhex=(void PASCAL (*)(DWORD))p[2];
 printhexln=(void PASCAL (*)(DWORD))p[3];
 system_setdebugflag=(void PASCAL (*)(DWORD,DWORD))p[4];
 system_getdebugflag=(DWORD PASCAL (*)(DWORD))p[5];
}
/* Prozeduren von MEM */
void system_init_mem()
{
 void **p;
 p=system_searchadriver(2,1,&system_mem_driver);
 allocmem=(void * PASCAL (*)(DWORD size))p[0];
 releasemem=(void PASCAL (*)(void *p,DWORD size))p[1];
 system_getpagebits=(DWORD PASCAL (*)())p[2];
 system_mapspace=(void * PASCAL (*)(DWORD,DWORD))p[3];
 system_unmapspace=(void PASCAL (*)(void *,DWORD))p[4];
 system_getpageframe=(DWORD PASCAL (*)(DWORD))p[5];
}
/* SYSTEMPROZEDURE */
void system_init()
{
 system_init_drv();
 system_init_tasks();
 system_init_debug();
 system_init_mem();
}
void system_signalexit(system_tdriver *p,DWORD nr)
{
 void **x;
 x=(void **)(p->getprot(0));
 if (x) ((void PASCAL (*)(DWORD))(x[1]))(nr);
}
void system_done()
{
 system_signalexit(system_mem_driver,1);
 system_signalexit(system_tasks_driver,1);
 system_signalexit(system_debug_driver,1);
 system_signalexit(system_mem_driver,1);
}
