UNIT DISK;
{$I-,R-}
{$ASMMODE INTEL}
INTERFACE
USES DOS,GO32;
PROCEDURE GETINFO;
FUNCTION READSECTOR(ADDR:DWORD;BUF:POINTER):BOOLEAN;
FUNCTION WRITESECTOR(ADDR:DWORD;BUF:POINTER):BOOLEAN;
FUNCTION SECCOUNT:LONGINT;
VAR DRV:BYTE;
    LASTSEC,LASTPAGE,LASTTRACK:DWORD;
    BUFFER:DWORD;
    BUFSEG,BUFOFS:DWORD;
IMPLEMENTATION
VAR REGS:REGISTERS;
FUNCTION SECCOUNT:LONGINT;
BEGIN
 SECCOUNT:=LONGINT(LASTSEC)*(LONGINT(LASTPAGE)+1)*(LONGINT(LASTTRACK)+1);
END;
PROCEDURE GETINFO;ASSEMBLER;
ASM
  XOR AX,AX
  MOV DL,[DRV]
  INT 13h
  MOV AH,8h
  MOV DL,[DRV]
  INT 13h
  MOV BYTE PTR [LASTPAGE],DH
  MOV BYTE PTR [LASTTRACK],CH
  MOV AL,CL
  AND AL,00111111b
  MOV BYTE PTR [LASTSEC],AL
  SHR CL,6
  MOV BYTE PTR [LASTTRACK+1],CL
END;
FUNCTION READSECTOR(ADDR:DWORD;BUF:POINTER):BOOLEAN;
VAR SECTOR_SE,SECTOR_PG,SECTOR_TR:DWORD;
    READSECTOR_TRY:BYTE;
BEGIN
 SECTOR_SE:=(ADDR MOD LASTSEC)+1;
 ADDR:=ADDR DIV LASTSEC;
 SECTOR_PG:=(ADDR MOD (LASTPAGE+1));
 ADDR:=ADDR DIV (LASTPAGE+1);
 SECTOR_TR:=(ADDR MOD (LASTTRACK+1));
 ADDR:=ADDR DIV (LASTTRACK+1);
 READSECTOR_TRY:=11;
 REPEAT
  DEC(READSECTOR_TRY);
  IF READSECTOR_TRY=0 THEN
  BEGIN
   READSECTOR:=FALSE;
   EXIT;
  END;
  REGS.AX:=$0201;
  REGS.DL:=DRV;
  REGS.DH:=SECTOR_PG;
  REGS.CH:=(SECTOR_TR) AND $FF;
  REGS.CL:=SECTOR_SE+DWORD((SECTOR_TR AND $300) SHR 2);
  REGS.BX:=BUFOFS;
  REGS.ES:=BUFSEG;
  INTR($13,REGS);
 UNTIL (REGS.FLAGS AND FCARRY=0);
 DOSMEMGET(BUFSEG,BUFOFS,BUF^,512);
 READSECTOR:=TRUE;
END;
FUNCTION WRITESECTOR(ADDR:DWORD;BUF:POINTER):BOOLEAN;
VAR SECTOR_SE,SECTOR_PG,SECTOR_TR:DWORD;
    READSECTOR_TRY:BYTE;
BEGIN
 DOSMEMPUT(BUFSEG,BUFOFS,BUF^,512);
 SECTOR_SE:=(ADDR MOD LASTSEC)+1;
 ADDR:=ADDR DIV LASTSEC;
 SECTOR_PG:=(ADDR MOD (LASTPAGE+1));
 ADDR:=ADDR DIV (LASTPAGE+1);
 SECTOR_TR:=(ADDR MOD (LASTTRACK+1));
 ADDR:=ADDR DIV (LASTTRACK+1);
 READSECTOR_TRY:=11;
 REPEAT
  DEC(READSECTOR_TRY);
  IF READSECTOR_TRY=0 THEN
  BEGIN
   WRITESECTOR:=FALSE;
   EXIT;
  END;
  REGS.AX:=$0301;
  REGS.DL:=DRV;
  REGS.DH:=SECTOR_PG;
  REGS.CH:=(SECTOR_TR) AND $FF;
  REGS.CL:=SECTOR_SE+DWORD((SECTOR_TR AND $300) SHR 2);
  REGS.BX:=BUFOFS;
  REGS.ES:=BUFSEG;
  INTR($13,REGS);
 UNTIL (REGS.FLAGS AND FCARRY=0);
 WRITESECTOR:=TRUE;
END;
INITIALIZATION
 BUFFER:=GLOBAL_DOS_ALLOC(512);
 BUFSEG:=BUFFER SHR 16;
 BUFOFS:=BUFFER AND $FFFF;
FINALIZATION
 GLOBAL_DOS_FREE(BUFFER);
END.