PROGRAM CMOS;
{$ASMMODE INTEL}
USES PORTS;
CONST PORTINTV1:TPORTINTV=(NEXT:NIL;LAST:NIL;START:$70;ENDE:$71);
FUNCTION GETSECOND:DWORD;ASSEMBLER;
ASM
  PUSHFD
  CLI
  MOV AL,0Bh
  OUT 70h,AL
  IN AL,71h
  OR AL,128
  OUT 71h,AL
  XOR EAX,EAX
  OUT 70h,AL
  IN AL,71h
  MOV EBX,EAX
  MOV AL,0Bh
  OUT 70h,AL
  IN AL,71h
  AND AL,127
  OUT 71h,AL
  POPFD
  MOV CL,BL
  SHR CL,4
  MOV AL,10
  MUL CL
  AND BL,0Fh
  ADD AL,BL
END;
FUNCTION GETMINUTE:DWORD;ASSEMBLER;
ASM
  PUSHFD
  CLI
  MOV AL,0Bh
  OUT 70h,AL
  IN AL,71h
  OR AL,128
  OUT 71h,AL
  MOV EAX,2
  OUT 70h,AL
  IN AL,71h
  MOV EBX,EAX
  MOV AL,0Bh
  OUT 70h,AL
  IN AL,71h
  AND AL,127
  OUT 71h,AL
  POPFD
  MOV CL,BL
  SHR CL,4
  MOV AL,10
  MUL CL
  AND BL,0Fh
  ADD AL,BL
END;
VAR CMOS_USERS:DWORD;
    CMOS_SHUTDOWNMODE:BOOLEAN;
    CMOS_SHUTDOWNTASK:POINTER;
PROCEDURE DEINITIALIZECMOSDRV;
BEGIN
 CMOS_SHUTDOWNTASK:=GETTASKHANDLE();
 CMOS_SHUTDOWNMODE:=TRUE;
 IF CMOS_USERS<>0 THEN DISABLETASK(CMOS_SHUTDOWNTASK);
 REMOVEPORTINTV(@PORTINTV1);
 SIGNALSHUTDOWNOK;
 HALT;
END;
PROCEDURE FREECMOSPROT(NR:DWORD);
BEGIN
 CASE NR OF
  1:
  BEGIN
   DECATOM(@CMOS_USERS);
   IF (CMOS_SHUTDOWNMODE) AND (CMOS_USERS=0) THEN ENABLETASK(CMOS_SHUTDOWNTASK);
  END;
 END;
END;
CONST CMOS_PROT0:ARRAY[0..1] OF POINTER=(
       @DEINITIALIZECMOSDRV,
       @FREECMOSPROT);
CONST CMOS_PROT1:ARRAY[0..1] OF POINTER=(
       @GETSECOND,
       @GETMINUTE);
FUNCTION DOCK_CMOS(NR:DWORD):POINTER;
BEGIN
 CASE NR OF
  0:DOCK_CMOS:=@CMOS_PROT0;
  1:
  BEGIN
   INCATOM(@CMOS_USERS);
   DOCK_CMOS:=@CMOS_PROT1;
  END;
  ELSE DOCK_CMOS:=NIL;
 END;
END;
CONST DRVCMOS:TDRIVER=(NEXT:NIL;LAST:NIL;TYP:$B;ID:0;GETPROT:@DOCK_CMOS;
                       DESC:'CMOS driver (1)');
BEGIN
 STARTDRIVERINITIALIZATION;
 IF NOT ADDPORTINTV(@PORTINTV1) THEN HALT('CMOS\Ports $70..$71 are not free');
 ADDDRIVER(@DRVCMOS);
 STOPDRIVERINITIALIZATION;
END.
