PROGRAM DISKS;
USES MEMORY;
{$I ..\INCLUDE\DISKS.DEF}
TYPE PLDISK=^TLDISK;
     PDISK=^TDISK;
     TLDISK=RECORD
      DISK:PDISK;
      NEXT,LAST:PLDISK;
      PRTYP:DWORD;
      DATAP:POINTER;
      CALLP:PPOINTERARRAY;
      STATE:DWORD;
      DESC:STRING;
      READING:LONGBOOL;
      DELETE:LONGBOOL;
     END;
     TDISK=RECORD
      NEXT,LAST:PDISK;
      PRTYP:DWORD;
      DATAP:POINTER;
      CALLP:PPOINTERARRAY;
      DESC:STRING;
      MOUNTABLE:LONGBOOL;
      USERS:DWORD;
      BLOCKSIZE:DWORD;
      BLOCKS:DWORD;
      LOCK:TLOCK;
      READ:TREADSTAT;
      LDISKS:PLDISK;
      SHUTDOWNMODE:LONGBOOL;
      SHUTDOWNTASK:POINTER;
     END;
VAR FIRSTDISK:PDISK;
    DISK_LOCK:TLOCK;
    DISK_READ:TREADSTAT;
{ ADDLDISK2 wird nur dann ausgefhrt, wenn ein MOUNT-Vorgang gestartet
  wurde, daher kann DISK als vorhanden akzeptiert werden ! }
FUNCTION ADDLDISK2(DISK:PDISK;CALLP,DATAP:POINTER;DESC:STRING):PLDISK;
BEGIN
 GETLOCK(@DISK^.LOCK);
 NEW(ADDLDISK2);
 ADDLDISK2^.NEXT:=DISK^.LDISKS;
 ADDLDISK2^.LAST:=NIL;
 IF ADDLDISK2^.NEXT<>NIL THEN ADDLDISK2^.NEXT^.LAST:=ADDLDISK2;
 ADDLDISK2^.PRTYP:=2;
 ADDLDISK2^.CALLP:=CALLP;
 ADDLDISK2^.DATAP:=DATAP;
 ADDLDISK2^.STATE:=0; { Vorhanden. }
 FREELOCK(@DISK^.LOCK);
END;
FUNCTION REMOVELDISK(LDISK:PLDISK):BOOLEAN;
VAR DISK:PDISK;
    DEL:BOOLEAN;
BEGIN
 DISK:=LDISK^.DISK;
 GETLOCK(@DISK^.LOCK);
 DEL:=NOT LDISK^.READING;
 IF LDISK^.LAST<>NIL THEN LDISK^.LAST^.NEXT:=LDISK^.NEXT ELSE DISK^.LDISKS:=LDISK^.NEXT;
 IF LDISK^.NEXT<>NIL THEN LDISK^.NEXT^.LAST:=LDISK^.LAST;
 IF NOT DEL THEN LDISK^.DELETE:=TRUE ELSE
 BEGIN
  IF (DISK^.SHUTDOWNMODE) AND (DISK^.USERS=0) AND (DISK^.LDISKS=NIL) THEN ENABLETASK(DISK^.SHUTDOWNTASK);
 END;
 FREELOCK(@DISK^.LOCK);
 IF DEL THEN
 BEGIN
  WAITFORREADCYCL(@DISK^.READ);
  DISPOSE(LDISK);
 END;
END;
FUNCTION ADDDISK1(CALLP,DATA:POINTER;BLOCKS,BLOCKSIZE:DWORD;S:STRING):PDISK;
BEGIN
 NEW(ADDDISK1);
 GETLOCK(@DISK_LOCK);
 ADDDISK1^.PRTYP:=1;
 ADDDISK1^.DATAP:=DATA;
 ADDDISK1^.CALLP:=CALLP;
 ADDDISK1^.LDISKS:=NIL;
 ADDDISK1^.DESC:=S;
 ADDDISK1^.MOUNTABLE:=TRUE;
 ADDDISK1^.BLOCKS:=BLOCKS;
 ADDDISK1^.BLOCKSIZE:=BLOCKSIZE;
 ADDDISK1^.USERS:=0;
 RESETATOM(@ADDDISK1^.LOCK);
 RESETREAD(@ADDDISK1^.READ);
 ADDDISK1^.LAST:=NIL;
 ADDDISK1^.NEXT:=FIRSTDISK;
 IF FIRSTDISK<>NIL THEN FIRSTDISK^.LAST:=ADDDISK1;
 FIRSTDISK:=ADDDISK1;
 FREELOCK(@DISK_LOCK);
END;
{ Diese Prozedur darf nur einmal aufgerufen werden ! }
{ Es wird angenommen, da P gltig ist ! }
{ Hier mu eine Cache-Flush-Funktion hinein ! }
PROCEDURE SIGNALUMOUNT(P:PDISK);
VAR L,N:PLDISK;
    GR:DWORD;
BEGIN
 GR:=STARTREAD(@P^.READ);
 L:=P^.LDISKS;
 WHILE L<>NIL DO
 BEGIN
  L^.READING:=TRUE;
  N:=L^.NEXT;
  { Hier Aufruf einfgen ! }
  GETLOCK(@P^.LOCK);
  IF L^.DELETE THEN DISPOSE(L);
  FREELOCK(@P^.LOCK);
  L:=N;
 END;
 STOPREAD(@P^.READ,GR);
END;
PROCEDURE REMOVEDISK(P:PDISK);
BEGIN
 P^.SHUTDOWNTASK:=GETTASKHANDLE();
 P^.SHUTDOWNMODE:=TRUE;
 P^.MOUNTABLE:=FALSE;
 SIGNALUMOUNT(P);
 GETLOCK(@DISK_LOCK);
 IF P^.NEXT<>NIL THEN P^.NEXT^.LAST:=P^.LAST;
 IF P^.LAST<>NIL THEN P^.LAST^.NEXT:=P^.NEXT ELSE FIRSTDISK:=P^.NEXT;
 WAITFORREADCYCL(@DISK_READ);
 IF (P^.USERS<>0) OR (P^.LDISKS<>NIL) THEN DISABLETASK(P^.SHUTDOWNTASK);
 DISPOSE(P);
 FREELOCK(@DISK_LOCK);
END;
FUNCTION STARTREADDISKLIST:DWORD;
BEGIN
 STARTREADDISKLIST:=STARTREAD(@DISK_READ);
END;
PROCEDURE STOPREADDISKLIST(GR:DWORD);
BEGIN
 STOPREAD(@DISK_READ,GR);
END;
FUNCTION GETFIRSTDISK:PDISK;
BEGIN
 GETFIRSTDISK:=FIRSTDISK;
END;
FUNCTION GETNEXTDISK(P:PDISK):PDISK;
BEGIN
 GETNEXTDISK:=P^.NEXT;
END;
FUNCTION GETDISKDESC(P:PDISK):STRING;
BEGIN
 GETDISKDESC:=P^.DESC;
END;
FUNCTION GETDISKSIZE(P:PDISK):DWORD;
BEGIN
 GETDISKSIZE:=P^.BLOCKS;
END;
FUNCTION GETDISKBLOCKSIZE(P:PDISK):DWORD;
BEGIN
 GETDISKBLOCKSIZE:=P^.BLOCKSIZE;
END;
FUNCTION ALLOCDISK4(P:PDISK):BOOLEAN;
VAR Z:PDISK;
    GR:DWORD;
BEGIN
 GR:=STARTREAD(@DISK_READ);
 Z:=FIRSTDISK;
 WHILE (Z<>NIL) AND (Z<>P) DO Z:=Z^.NEXT;
 IF (Z=NIL) OR (NOT P^.MOUNTABLE) THEN
 BEGIN
  STOPREAD(@DISK_READ,GR);
  ALLOCDISK4:=FALSE;
  EXIT;
 END;
 INCATOM(@P^.USERS);
 STOPREAD(@DISK_READ,GR);
END;
PROCEDURE RELEASEDISK4(P:PDISK);
BEGIN
 GETLOCK(@P^.LOCK);
 DECATOM(@P^.USERS);
 IF (P^.SHUTDOWNMODE) AND (P^.USERS=0) AND (P^.LDISKS=NIL) THEN ENABLETASK(P^.SHUTDOWNTASK);
 FREELOCK(@P^.LOCK);
END;
TYPE PCD1_READBLOCK=PROCEDURE(D:POINTER;H:PDRVDISKHAND1);
TYPE PCD1_WRITEBLOCK=PROCEDURE(D:POINTER;H:PDRVDISKHAND1);
PROCEDURE READBLOCK(PAR:PDIRDISKHAND5);
VAR P:PDISK;
    H1:PDRVDISKHAND1;
BEGIN
 PAR^.PROT:=5;
 P:=PAR^.DISK;
 CASE P^.PRTYP OF
  1:
  BEGIN
   H1:=@PAR^.DRVDISKHAND;
   H1^.ADDR:=PAR^.ADDR;
   H1^.DATA:=PAR^.DATA;
   H1^.DIRDISKHAND:=PAR;
   PCD1_READBLOCK(P^.CALLP^[0])(P^.DATAP,H1);
  END;
 END;
END;
PROCEDURE WRITEBLOCK(PAR:PDIRDISKHAND5);
VAR P:PDISK;
    H1:PDRVDISKHAND1;
BEGIN
 PAR^.PROT:=5;
 P:=PAR^.DISK;
 CASE P^.PRTYP OF
  1:
  BEGIN
   H1:=@PAR^.DRVDISKHAND;
   H1^.ADDR:=PAR^.ADDR;
   H1^.DATA:=PAR^.DATA;
   H1^.DIRDISKHAND:=PAR;
   PCD1_WRITEBLOCK(P^.CALLP^[0])(P^.DATAP,H1);
  END;
 END;
END;
PROCEDURE SIGNALOPDONE(H:PDRVDISKHAND1);
BEGIN
 CASE PDWORD(H^.DIRDISKHAND)^ OF
  5:
  BEGIN
   WITH PDIRDISKHAND5(H^.DIRDISKHAND)^ DO
   BEGIN
    STATE:=1;
    IF TSS<>NIL THEN ENABLETASK(TSS);
   END;
  END;
 END;
END;
CONST DISKS_PROT5:ARRAY[0..1] OF POINTER=(
       @READBLOCK,
       @WRITEBLOCK);
CONST DISKS_PROT4:ARRAY[0..1] OF POINTER=(
       @ALLOCDISK4,
       @RELEASEDISK4);
CONST DISKS_PROT3:ARRAY[0..6] OF POINTER=(
       @STARTREADDISKLIST,
       @STOPREADDISKLIST,
       @GETFIRSTDISK,
       @GETNEXTDISK,
       @GETDISKDESC,
       @GETDISKSIZE,
       @GETDISKBLOCKSIZE);
CONST DISKS_PROT2:ARRAY[0..1] OF POINTER=(
       @ADDLDISK2,
       @REMOVELDISK);
CONST DISKS_PROT1:ARRAY[0..2] OF POINTER=(
       @ADDDISK1,
       @REMOVEDISK,
       @SIGNALOPDONE);
VAR DISKS_USERS:DWORD;
    SHUTDOWNTASK:POINTER;
    SHUTDOWNMODE:LONGBOOL;
PROCEDURE DEINITIALIZEDISKDRV;
BEGIN
 SHUTDOWNTASK:=GETTASKHANDLE();
 SHUTDOWNMODE:=TRUE;
 IF DISKS_USERS<>0 THEN DISABLETASK(SHUTDOWNTASK);
 SIGNALSHUTDOWNOK;
 HALT;
END;
PROCEDURE FREEDISKPROT(NR:DWORD);
BEGIN
 CASE NR OF
  1,2,3,4,5:
  BEGIN
   DECATOM(@DISKS_USERS);
   IF SHUTDOWNMODE AND (DISKS_USERS=0) THEN ENABLETASK(SHUTDOWNTASK);
  END;
 END;
END;
CONST DISKS_PROT0:ARRAY[0..1] OF POINTER=(
       @DEINITIALIZEDISKDRV,
       @FREEDISKPROT);
FUNCTION DOCK_DISKS(NR:DWORD):POINTER;
BEGIN
 CASE NR OF
  0:DOCK_DISKS:=@DISKS_PROT0;
  1:
  BEGIN
   INCATOM(@DISKS_USERS);
   DOCK_DISKS:=@DISKS_PROT1;
  END;
  2:
  BEGIN
   INCATOM(@DISKS_USERS);
   DOCK_DISKS:=@DISKS_PROT2;
  END;
  3:
  BEGIN
   INCATOM(@DISKS_USERS);
   DOCK_DISKS:=@DISKS_PROT3;
  END;
  4:
  BEGIN
   INCATOM(@DISKS_USERS);
   DOCK_DISKS:=@DISKS_PROT4;
  END;
  5:
  BEGIN
   INCATOM(@DISKS_USERS);
   DOCK_DISKS:=@DISKS_PROT5;
  END;
  ELSE DOCK_DISKS:=NIL;
 END;
END;
CONST DISKSDRV:TDRIVER=(NEXT:NIL;LAST:NIL;TYP:$11;ID:0;GETPROT:@DOCK_DISKS;
                        DESC:'Diskmanager (1,2,3,4,5)');
BEGIN
 STARTDRIVERINITIALIZATION;
 ADDDRIVER(@DISKSDRV);
 STOPDRIVERINITIALIZATION;
END.
