PROGRAM FONTSERV;
{$I ..\INCLUDE\FONTS.DEF}
VAR FIRSTFONT:PFONTENTRY;
    FONTLOCK:TLOCK;
    FONTREAD:TREADSTAT;
FUNCTION USEFONT(NAME:STRING):PFONTENTRY;
VAR RH:DWORD;
    P:PFONTENTRY;
BEGIN
 RH:=STARTREAD(@FONTREAD);
 P:=FIRSTFONT;
 WHILE P<>NIL DO
 BEGIN
  IF P^.NAME=NAME THEN
  BEGIN
   INC(P^.USERS);
   USEFONT:=P;
   STOPREAD(@FONTREAD,RH);
   EXIT;
  END;
 END;
 STOPREAD(@FONTREAD,RH);
 USEFONT:=NIL;
END;
PROCEDURE RELEASEFONT(P:PFONTENTRY);
BEGIN
 DEC(P^.USERS);
END;
PROCEDURE ADDFONT(P:PFONTENTRY);
BEGIN
 GETLOCK(@FONTLOCK);
 P^.NEXT:=FIRSTFONT;
 P^.LAST:=NIL;
 IF FIRSTFONT<>NIL THEN FIRSTFONT^.LAST:=P;
 FIRSTFONT:=P;
 FREELOCK(@FONTLOCK);
END;
PROCEDURE REMOVEFONT(P:PFONTENTRY);
BEGIN
 GETLOCK(@FONTLOCK);
 IF P^.LAST<>NIL THEN P^.LAST^.NEXT:=P ELSE FIRSTFONT:=P^.NEXT;
 IF P^.NEXT<>NIL THEN P^.NEXT^.LAST:=P;
 FREELOCK(@FONTLOCK);
 WAITFORREADCYCL(@FONTREAD);
END;
CONST FONTSERV_PROT1:ARRAY[0..3] OF POINTER=(
       @USEFONT,
       @RELEASEFONT,
       @ADDFONT,
       @REMOVEFONT);
VAR FONTSERV_USERS:DWORD;
    SHUTDOWNMODE:BOOLEAN;
    SHUTDOWNTASK:POINTER;
PROCEDURE DEINITIALIZEFONTSERV;
BEGIN
 SHUTDOWNTASK:=GETTASKHANDLE();
 SHUTDOWNMODE:=TRUE;
 IF FONTSERV_USERS<>0 THEN DISABLETASK(SHUTDOWNTASK);
 WRITELNSTR('FONTSERV DONE.');
 SIGNALSHUTDOWNOK;
 HALT;
END;
PROCEDURE FREEFONTSERVPROT(NR:DWORD);
BEGIN
 CASE NR OF
  1:
  BEGIN
   DECATOM(@FONTSERV_USERS);
   IF SHUTDOWNMODE AND (FONTSERV_USERS=0) THEN ENABLETASK(SHUTDOWNTASK);
  END;
 END;
END;
CONST FONTSERV_PROT0:ARRAY[0..1] OF POINTER=(
       @DEINITIALIZEFONTSERV,
       @FREEFONTSERVPROT);
FUNCTION DOCK_FONTSERV(NR:DWORD):POINTER;
BEGIN
 CASE NR OF
  0:DOCK_FONTSERV:=@FONTSERV_PROT0;
  1:
  BEGIN
   INCATOM(@FONTSERV_USERS);
   DOCK_FONTSERV:=@FONTSERV_PROT1;
  END;
  ELSE DOCK_FONTSERV:=NIL;
 END;
END;
CONST FONTSERVDRV:TDRIVER=(NEXT:NIL;LAST:NIL;TYP:$F;ID:0;GETPROT:@DOCK_FONTSERV;
                           DESC:'FONT Server (1)');
BEGIN
 STARTDRIVERINITIALIZATION;
 ADDDRIVER(@FONTSERVDRV);
 STOPDRIVERINITIALIZATION;
END.
