PROGRAM IDEHD;
{$ASMMODE INTEL}
USES PORTS,IRQS,DISKS;
CONST READBLOCKSIZE=256;
CONST WRITEBLOCKSIZE=256;
{$I HARDWARE.INC}
TYPE PIOLBADISK=^TIOLBADISK;
     TIOLBADISK=OBJECT(TDISK)
      CONSTRUCTOR INIT(BAS,PIRQ,BLOCKS,BLOCKSIZE:DWORD);
      PROCEDURE HANDLEIRQ(PIRQ:DWORD);VIRTUAL;
      PROCEDURE EXECUTE;VIRTUAL;
      PROCEDURE WRITEBLOCK(START:DWORD;SOU:POINTER);
      PROCEDURE READBLOCK(START:DWORD;TAR:POINTER);
      PRIVATE
      REG_DATA:DWORD;
      REG_ERR:DWORD;
      REG_SECCOUNT:DWORD;
      REG_SECNUM:DWORD;
      REG_CYLLOW:DWORD;
      REG_CYLHIGH:DWORD;
      REG_DRVHEAD:DWORD;
      REG_CMD:DWORD;
      BASE:DWORD;
      PORTINTV:TPORTINTV;
      IRQ:DWORD;
     END;
PROCEDURE TIOLBADISK.WRITEBLOCK(START:DWORD;SOU:POINTER);
BEGIN
 WHILE INPORTB(REG_CMD) AND 128<>0 DO SCHEDULE;
 OUTPORTB(REG_SECCOUNT,1);
 OUTPORTB(REG_SECNUM,START);
 OUTPORTB(REG_CYLLOW,START SHR 8);
 OUTPORTB(REG_CYLHIGH,START SHR 16);
 OUTPORTB(REG_DRVHEAD,$E0 OR (START SHR 24 AND $F));
 OUTPORTB(REG_CMD,$30);
 WHILE INPORTB(REG_CMD) AND 128<>0 DO SCHEDULE;
 ASM
   MOV ECX,256
   MOV EDX,REG_DATA
   MOV ESI,SOU
   CLD
   REP OUTSW
 END;
  { Jetzt sollte doch ein IRQ auftreten...wenn er fertig ist. }
  { Naja }
END;
PROCEDURE TIOLBADISK.READBLOCK(START:DWORD;TAR:POINTER);
BEGIN
 WHILE INPORTB(REG_CMD) AND 128<>0 DO SCHEDULE;
 WRITELNSTR(HEXSTR(REG_DATA));
 OUTPORTB(REG_SECCOUNT,1);
 OUTPORTB(REG_SECNUM,START);
 OUTPORTB(REG_CYLLOW,START SHR 8);
 OUTPORTB(REG_CYLHIGH,START SHR 16);
 OUTPORTB(REG_DRVHEAD,$E0 OR (START SHR 24 AND $F));
 OUTPORTB(REG_CMD,$20);
 { IRQ-Warten ? }
 WHILE INPORTB(REG_CMD) AND 8=0 DO SCHEDULE;
 ASM
   MOV ECX,256
   MOV EDX,REG_DATA
   MOV EDI,TAR
   CLD
   REP INSW
 END;
END;
PROCEDURE TIOLBADISK.EXECUTE;
VAR START,CMD:DWORD;
    TAR:POINTER;
    I:DWORD;
BEGIN
 CMD:=GETWORK(START,TAR);
 CASE CMD OF
  1:
  BEGIN
   WRITELNSTR('Readblock '+INTSTR(START)+' nach '+INTSTR(DWORD(TAR)));
   READBLOCK(START,TAR);
   WRITELNSTR('TSS');
   SIGNALTASK;
  END;
  2:
  BEGIN
   WRITELNSTR('Writeblock '+INTSTR(START)+' nach '+INTSTR(DWORD(TAR)));
   WRITEBLOCK(START,TAR);
   WRITELNSTR('TSS');
   SIGNALTASK;
  END;
 END;
END;
PROCEDURE TIOLBADISK.HANDLEIRQ(PIRQ:DWORD);
BEGIN
 IF PIRQ=IRQ THEN
 BEGIN
 END;
END;
CONSTRUCTOR TIOLBADISK.INIT(BAS,PIRQ,BLOCKS,BLOCKSIZE:DWORD);
BEGIN
 PORTINTV.START:=BASE;
 PORTINTV.ENDE:=BASE+7;
 IF NOT ADDPORTINTV(@PORTINTV) THEN FAIL;
 IF NOT INSTALLIRQ(PIRQ) THEN
 BEGIN
  REMOVEPORTINTV(@PORTINTV);
  FAIL;
 END;
 BASE:=BAS;
 IRQ:=PIRQ;
 REG_DATA:=BAS;
 REG_ERR:=BAS+1;
 REG_SECCOUNT:=BAS+2;
 REG_SECNUM:=BAS+3;
 REG_CYLLOW:=BAS+4;
 REG_CYLHIGH:=BAS+5;
 REG_DRVHEAD:=BAS+6;
 REG_CMD:=BAS+7;
 INHERITED INIT('IDE DISK ('+INTSTR(BAS)+','+INTSTR(IRQ)+',IO,LBA)',BLOCKS,BLOCKSIZE);
END;
VAR DET_BASE:DWORD;
    DET_TASK:POINTER;
    DET_INFO:THDID;
PROCEDURE DET_DETHAND(P:POINTER);ASSEMBLER;
ASM
  MOV EDX,DET_BASE
  ADD EDX,HDISK_STAT
  IN AL,DX
  TEST AL,8
  JZ @EXT
  CLD
  MOV AX,DS
  MOV ES,AX
  MOV EDX,DET_BASE
  ADD EDX,HDISK_DATA
  MOV EDI,OFFSET DET_INFO
  MOV ECX,256
  REP INSW
  PUSH DET_TASK
  CALL ENABLETASK
 @EXT:
END;
CONST DET_HANDP:TIRQHANDLER=(NEXT:NIL;LAST:NIL;DATA:NIL;PROC:@DET_DETHAND);
PROCEDURE DETLBATYPE(BAS,IRQ:DWORD);
VAR PIODISK:PIOLBADISK;
BEGIN
 NEW(PIODISK,INIT(BAS,IRQ,DET_INFO.LBASECS,512));
END;
PROCEDURE DETDISKTYPE(BAS,IRQ:DWORD);
VAR PORTINTV:TPORTINTV;    
BEGIN
 IF NOT GETIRQ(IRQ) THEN EXIT;
 PORTINTV.START:=BAS;
 PORTINTV.ENDE:=BAS+7;
 IF NOT ADDPORTINTV(@PORTINTV) THEN
 BEGIN
  FREEIRQ(IRQ);
  EXIT;
 END;
 ADDIRQHANDLER(IRQ,@DET_HANDP);
 ENABLEIRQ(IRQ);
 DET_TASK:=GETTASKHANDLE();
 DET_BASE:=BAS;
 OUTPORTB(BAS+HDISK_CMD,$EC); 
 DISABLETASK(DET_TASK);
 REMOVEIRQHANDLER(IRQ,@DET_HANDP);
 REMOVEPORTINTV(@PORTINTV);
 FREEIRQ(IRQ);
 { Hier die Informationen auswerten... }
 IF DET_INFO.LBASECS<>0 THEN DETLBATYPE(BAS,IRQ);
END;
PROCEDURE DEINITIALIZEIDEHDDRV;
BEGIN
 SIGNALSHUTDOWNOK;
 HALT;
END;
PROCEDURE FREEIDEHDPROT(NR:DWORD);
BEGIN
END;
CONST IDEHD_PROT0:ARRAY[0..1] OF POINTER=(
       @DEINITIALIZEIDEHDDRV,
       @FREEIDEHDPROT);
FUNCTION DOCK_IDEHD(NR:DWORD):POINTER;
BEGIN
 CASE NR OF
  0:DOCK_IDEHD:=@IDEHD_PROT0;
  ELSE DOCK_IDEHD:=NIL;
 END;
END;
CONST IDEHDDRV:TDRIVER=(NEXT:NIL;LAST:NIL;TYP:$10;ID:0;GETPROT:@DOCK_IDEHD;
                        DESC:'IDE HD driver');
BEGIN
 STARTDRIVERINITIALIZATION;
 DETDISKTYPE($1F0,14);
 ADDDRIVER(@IDEHDDRV);
 STOPDRIVERINITIALIZATION;
END.
