UNIT ALLBAS;
INTERFACE
USES MEMORY;
TYPE PSTRINGITEM=^TSTRINGITEM;
     TSTRINGITEM=OBJECT
      NEXT,LAST:PSTRINGITEM;
      FLAG:DWORD;
      S:STRING;
     END;
TYPE PSTRINGLIST=^TSTRINGLIST;
     TSTRINGLIST=OBJECT
      CONSTRUCTOR INIT;
      DESTRUCTOR DONE;
      FUNCTION SEARCH(S:STRING):BOOLEAN;
      PROCEDURE GOTOLINE(NR:DWORD);
      FUNCTION READLINE:STRING;
      FUNCTION GETLINE(NR:DWORD):PSTRINGITEM;
      FUNCTION GETLINE:PSTRINGITEM;
      FUNCTION READLINE(NR:DWORD):STRING;
      PROCEDURE INSERT(LNR,COL:DWORD;S:STRING);
      PROCEDURE INSERT(LNR,COL:DWORD;S:STRING;FL:DWORD);
      PROCEDURE DELETE(LNR,COL:DWORD);
      PROCEDURE DELETELAST(LNR,COL:DWORD);
      FUNCTION LINELEN(NR:DWORD):DWORD;
      PROCEDURE INSERTLINE(LNR,COL:DWORD);
      FUNCTION LINECOUNT:DWORD;
      PROCEDURE CLEAR;
      PROCEDURE SORT;
      PROCEDURE REMOVESTR(S:STRING);
      PRIVATE
      FIRST:PSTRINGITEM;
      AKTL:PSTRINGITEM;
      LINEC:DWORD;
     END;
TYPE PSTRTREENODE=^TSTRTREENODE;
     TSTRTREENODE=RECORD
      NEXT,LAST,OVER,UNDER:PSTRTREENODE;
      STR:STRING;
      FLAG:DWORD;
      EXP:BOOLEAN;
     END;
TYPE PSTRTREE=^TSTRTREE;
     TSTRTREE=OBJECT
      ROOT:PSTRTREENODE;
      CONSTRUCTOR INIT(RN:STRING;FL:DWORD);
      DESTRUCTOR DONE;
      FUNCTION ADDCHILD(P:PSTRTREENODE;N:STRING;FL:DWORD):PSTRTREENODE;
      FUNCTION GETNEXT(VAR LEV:DWORD;P:PSTRTREENODE):PSTRTREENODE;
      FUNCTION GETLAST(VAR LEV:DWORD;P:PSTRTREENODE):PSTRTREENODE;
      FUNCTION GETLINE(VAR LEV:DWORD;NR:DWORD):PSTRTREENODE;
      FUNCTION GETLINECOUNT:DWORD;
      PROCEDURE EXPAND(P:PSTRTREENODE);
      PROCEDURE REDUCE(S:PSTRTREENODE);
      PROCEDURE CHANGE(P:PSTRTREENODE);
      FUNCTION EXTRLINE(P:PSTRTREENODE):DWORD;
      PROCEDURE CLEAR;
      PROCEDURE SORT;
      PROCEDURE CORRECTSEL(VAR P:PSTRTREENODE);
      PRIVATE      
      LINEC:DWORD;
      PROCEDURE CLEARL(P:PSTRTREENODE);
      PROCEDURE SORTL(P:PSTRTREENODE);
     END;
FUNCTION UPSTR(S:STRING):STRING;
FUNCTION READWORD(VAR P:DWORD;S:STRING):STRING;
FUNCTION COUNTBITS(W:DWORD):DWORD;
FUNCTION NEEDBITS(LEN:DWORD):DWORD;
IMPLEMENTATION
PROCEDURE TSTRINGLIST.REMOVESTR(S:STRING);
VAR P:PSTRINGITEM;
BEGIN
 P:=FIRST;
 WHILE P<>NIL DO
 BEGIN
  IF P^.S=S THEN
  BEGIN
   IF P^.LAST<>NIL THEN P^.LAST^.NEXT:=P^.NEXT ELSE FIRST:=P^.NEXT;
   IF P^.NEXT<>NIL THEN P^.NEXT^.LAST:=P^.LAST;
   DISPOSE(P);
   DEC(LINEC);
   EXIT;
  END;
  P:=P^.NEXT;
 END;
 AKTL:=NIL;
END;
FUNCTION TSTRINGLIST.SEARCH(S:STRING):BOOLEAN;
VAR P:PSTRINGITEM;
BEGIN
 P:=FIRST;
 WHILE P<>NIL DO
 BEGIN
  IF P^.S=S THEN
  BEGIn
   SEARCH:=TRUE;
   EXIT;
  END;
  P:=P^.NEXT;
 END;
 SEARCH:=FALSE;
END;
FUNCTION NEEDBITS(LEN:DWORD):DWORD;
VAR BITS:DWORD;
BEGIN
 IF LEN=1 THEN
 BEGIN
  NEEDBITS:=0;
  EXIT;
 END;
 BITS:=1;
 DEC(LEN);
 WHILE LEN>1 DO
 BEGIN
  LEN:=LEN SHR 1;
  INC(BITS);
 END;
 NEEDBITS:=BITS;
END;
FUNCTION TSTRINGLIST.GETLINE(NR:DWORD):PSTRINGITEM;
BEGIN
 GOTOLINE(NR);
 GETLINE:=AKTL;
END;
FUNCTION TSTRINGLIST.READLINE(NR:DWORD):STRING;
BEGIN
 GOTOLINE(NR);
 READLINE:=SELF.READLINE;
END;
PROCEDURE TSTRTREE.CORRECTSEL(VAR P:PSTRTREENODE);
VAR E:PSTRTREENODE;
BEGIN
 IF P=NIL THEN EXIT;
 E:=P^.OVER;
 WHILE E<>NIL DO
 BEGIN
  IF NOT E^.EXP THEN P:=E;
  E:=E^.OVER;
 END;
END;
PROCEDURE TSTRTREE.SORTL(P:PSTRTREENODE);
VAR Q,N:PSTRTREENODE;
    FL:BOOLEAN;
    BSTR:STRING;
    BFLAG:DWORD;
    BEXP:BOOLEAN;
BEGIN
 IF P^.UNDER<>NIL THEN
 BEGIN
  REPEAT
   FL:=FALSE;
   Q:=P^.UNDER;
   IF Q<>NIL THEN
   BEGIN
    WHILE Q^.NEXT<>NIL DO
    BEGIN
     N:=Q^.NEXT;
     IF Q^.STR>N^.STR THEN
     BEGIN
      Q^.NEXT:=N^.NEXT;
      N^.LAST:=Q^.LAST;
      IF Q^.NEXT<>NIL THEN Q^.NEXT^.LAST:=Q;
      IF N^.LAST<>NIL THEN N^.LAST^.NEXT:=N ELSE P^.UNDER:=N;
      Q^.LAST:=N;
      N^.NEXT:=Q;
      FL:=TRUE;
     END;
     Q:=N;
    END;
   END;
  UNTIL NOT FL;
 END;
 P:=P^.UNDER;
 WHILE P<>NIL DO
 BEGIN
  SORTL(P);
  P:=P^.NEXT;
 END;
END;
PROCEDURE TSTRTREE.SORT;
BEGIN
 SORTL(ROOT);
END;
DESTRUCTOR TSTRTREE.DONE;
BEGIN
 CLEARL(ROOT);
END;
PROCEDURE TSTRTREE.CLEARL(P:PSTRTREENODE);
VAR P2:PSTRTREENODE;
BEGIN
 WHILE P<>NIL DO
 BEGIN
  P2:=P^.NEXT;
  CLEARL(P^.UNDER);
  DISPOSE(P);
  P:=P2;
 END;
END;
PROCEDURE TSTRTREE.CLEAR;
BEGIN
 CLEARL(ROOT^.UNDER);
END;
FUNCTION TSTRTREE.EXTRLINE(P:PSTRTREENODE):DWORD;
VAR LEV:DWORD;
BEGIN
 EXTRLINE:=DWORD(-1);
 WHILE (P<>NIL) DO
 BEGIN
  P:=GETLAST(LEV,P);
  INC(EXTRLINE);
 END;
END;
PROCEDURE TSTRTREE.CHANGE(P:PSTRTREENODE);
BEGIN
 IF P^.EXP THEN REDUCE(P) ELSE EXPAND(P);
END;
PROCEDURE TSTRTREE.REDUCE(S:PSTRTREENODE);
VAR LEV:DWORD;
    P,E:PSTRTREENODE;
    FL:BOOLEAN;
BEGIN
 IF S^.EXP THEN
 BEGIN
  E:=S^.OVER;
  FL:=FALSE;
  WHILE E<>NIL DO
  BEGIN
   IF NOT E^.EXP THEN FL:=TRUE;
   E:=E^.OVER;
  END;
  IF NOT FL THEN
  BEGIN
   LEV:=0;
   P:=GETNEXT(LEV,S);
   WHILE (P<>NIL) AND (LONGINT(LEV)>0) DO
   BEGIN
    DEC(LINEC);
    P:=GETNEXT(LEV,P);
   END;
  END;
  S^.EXP:=FALSE;
 END;
END;
PROCEDURE TSTRTREE.EXPAND(P:PSTRTREENODE);
VAR LEV:DWORD;
    E:PSTRTREENODE;
    FL:BOOLEAN;
BEGIN
 IF NOT P^.EXP THEN
 BEGIN
  E:=P^.OVER;
  FL:=FALSE;
  WHILE E<>NIL DO
  BEGIN
   IF NOT E^.EXP THEN FL:=TRUE;
   E:=E^.OVER;
  END;
  P^.EXP:=TRUE;
  IF NOT FL THEN
  BEGIN
   LEV:=0;
   P:=GETNEXT(LEV,P);
   WHILE (P<>NIL) AND (LONGINT(LEV)>0) DO
   BEGIN
    INC(LINEC);
    P:=GETNEXT(LEV,P);
   END;
  END;
 END;
END;
FUNCTION TSTRTREE.GETLINECOUNT:DWORD;
BEGIN
 GETLINECOUNT:=LINEC;
END;
FUNCTION TSTRTREE.GETLINE(VAR LEV:DWORD;NR:DWORD):PSTRTREENODE;
BEGIN
 GETLINE:=ROOT;
 LEV:=0;
 WHILE (NR>0) AND (GETLINE<>NIL) DO
 BEGIN
  GETLINE:=GETNEXT(LEV,GETLINE);
  DEC(NR);
 END;
END;
FUNCTION TSTRTREE.GETNEXT(VAR LEV:DWORD;P:PSTRTREENODE):PSTRTREENODE;
BEGIN
 IF P^.EXP AND (P^.UNDER<>NIL) THEN
 BEGIN
  GETNEXT:=P^.UNDER;
  INC(LEV);
 END ELSE IF P^.NEXT<>NIL THEN
 BEGIN
  GETNEXT:=P^.NEXT;
 END
 ELSE
 BEGIN
  WHILE (P^.OVER<>NIL) DO
  BEGIN
   DEC(LEV);
   P:=P^.OVER;
   IF P^.NEXT<>NIL THEN
   BEGIN
    GETNEXT:=P^.NEXT;
    EXIT;
   END;
  END;
  GETNEXT:=NIL;
 END;
END;
FUNCTION TSTRTREE.GETLAST(VAR LEV:DWORD;P:PSTRTREENODE):PSTRTREENODE;
BEGIN
 IF P^.LAST<>NIL THEN
 BEGIN
  P:=P^.LAST;
  WHILE P^.EXP AND (P^.UNDER<>NIL) DO
  BEGIN
   P:=P^.UNDER;
   WHILE P^.NEXT<>NIL DO P:=P^.NEXT;
   INC(LEV);
  END;
  GETLAST:=P;
 END
 ELSE IF P^.OVER<>NIL THEN
 BEGIN
  GETLAST:=P^.OVER;
  DEC(LEV);
 END ELSE GETLAST:=NIL;
END;
FUNCTION TSTRTREE.ADDCHILD(P:PSTRTREENODE;N:STRING;FL:DWORD):PSTRTREENODE;
VAR A:PSTRTREENODE;
    FLA:BOOLEAN;
BEGIN
 IF P=NIL THEN P:=ROOT;
 A:=P;
 FLA:=FALSE;
 WHILE A<>NIL DO
 BEGIN
  IF NOT A^.EXP THEN FLA:=TRUE;
  A:=A^.OVER;
 END;
 IF NOT FLA THEN INC(LINEC);
 NEW(A);
 A^.NEXT:=P^.UNDER;
 A^.LAST:=NIL;
 A^.UNDER:=NIL;
 A^.OVER:=P;
 IF A^.NEXT<>NIL THEN A^.NEXT^.LAST:=A;
 A^.STR:=N;
 A^.FLAG:=FL;
 A^.EXP:=FALSE;
 P^.UNDER:=A;
 ADDCHILD:=A;
END;
CONSTRUCTOR TSTRTREE.INIT(RN:STRING;FL:DWORD);
BEGIN
 NEW(ROOT);
 ROOT^.OVER:=NIL;
 ROOT^.UNDER:=NIL;
 ROOT^.NEXT:=NIL;
 ROOT^.LAST:=NIL;
 ROOT^.STR:=RN;
 ROOT^.FLAG:=FL;
 ROOT^.EXP:=TRUE;
 LINEC:=1;
END;
FUNCTION COUNTBITS(W:DWORD):DWORD;
VAR I:DWORD;
    A:DWORD;
BEGIN
 A:=0;
 FOR I:=0 TO 31 DO
 BEGIN
  IF W SHR I AND 1<>0 THEN INC(A);
 END;
 COUNTBITS:=A;
END;
PROCEDURE TSTRINGLIST.SORT;
VAR F:BOOLEAN;
    P:PSTRINGITEM;
    S:STRING;
    FL:DWORD;
BEGIN
 REPEAT
  F:=FALSE;
  P:=FIRST;
  IF P<>NIL THEN
  BEGIN
   WHILE P^.NEXT<>NIL DO
   BEGIN
    IF P^.S>P^.NEXT^.S THEN
    BEGIN
     S:=P^.S;
     FL:=P^.FLAG;
     P^.S:=P^.NEXT^.S;
     P^.FLAG:=P^.NEXT^.FLAG;
     P^.NEXT^.S:=S;
     P^.NEXT^.FLAG:=FL;
     F:=TRUE;
    END;
    P:=P^.NEXT;
   END;
  END;
 UNTIL NOT F;
END;
PROCEDURE TSTRINGLIST.CLEAR;
VAR P,P2:PSTRINGITEM;
BEGIN
 P:=FIRST;
 WHILE P<>NIL DO
 BEGIN
  P2:=P^.NEXT;
  DISPOSE(P);
  P:=P2;
 END;
 FIRST:=NIL;
 AKTL:=NIL;
 LINEC:=0;
END;
FUNCTION TSTRINGLIST.LINECOUNT:DWORD;
BEGIN
 LINECOUNT:=LINEC;
END;
PROCEDURE TSTRINGLIST.INSERTLINE(LNR,COL:DWORD);
VAR P:PSTRINGITEM;
BEGIN
 GOTOLINE(LNR);
 INC(COL);
 NEW(P);
 P^.S:=STR_COPY(AKTL^.S,COL,255);
 STR_DELETE(AKTL^.S,COL,255);
 P^.LAST:=AKTL;
 P^.NEXT:=AKTL^.NEXT;
 AKTL^.NEXT:=P;
 IF P^.NEXT<>NIL THEN P^.NEXT^.LAST:=P;
 INC(LINEC);
END;
FUNCTION TSTRINGLIST.LINELEN(NR:DWORD):DWORD;
BEGIN
 GOTOLINE(NR);
 LINELEN:=BYTE(AKTL^.S[0]);
END;
PROCEDURE TSTRINGLIST.DELETELAST(LNR,COL:DWORD);
BEGIN
 GOTOLINE(LNR);
 IF COL=0 THEN
 BEGIN
  IF AKTL^.LAST<>NIL THEN
  BEGIN
   AKTL^.LAST^.S:=AKTL^.LAST^.S+AKTL^.S;
   AKTL^.LAST^.NEXT:=AKTL^.NEXT;
   IF AKTL^.NEXT<>NIL THEN AKTL^.NEXT^.LAST:=AKTL^.LAST;
   DISPOSE(AKTL);
   DEC(LINEC);
  END;
 END ELSE STR_DELETE(AKTL^.S,COL,1);
END;
PROCEDURE TSTRINGLIST.DELETE(LNR,COL:DWORD);
BEGIN
 GOTOLINE(LNR);
 INC(COL);
 IF COL<=BYTE(AKTL^.S[0]) THEN STR_DELETE(AKTL^.S,COL,1) ELSE
 BEGIN
  IF AKTL^.NEXT<>NIL THEN
  BEGIN
   AKTL^.S:=AKTL^.S+AKTL^.NEXT^.S;
   AKTL:=AKTL^.NEXT;
   AKTL^.LAST^.NEXT:=AKTL^.NEXT;
   IF AKTL^.NEXT<>NIL THEN AKTL^.NEXT^.LAST:=AKTL^.LAST;
   DISPOSE(AKTL);
   DEC(LINEC);
  END;
 END;
END;
PROCEDURE TSTRINGLIST.INSERT(LNR,COL:DWORD;S:STRING;FL:DWORD);
BEGIN
 INSERT(LNR,COL,S);
 AKTL^.FLAG:=FL;
END;
PROCEDURE TSTRINGLIST.INSERT(LNR,COL:DWORD;S:STRING);
BEGIN
 GOTOLINE(LNR);
 STR_INSERT(S,AKTL^.S,COL+1);
END;
FUNCTION TSTRINGLIST.GETLINE:PSTRINGITEM;
BEGIN
 GETLINE:=AKTL;
 IF AKTL<>NIL THEN AKTL:=AKTL^.NEXT;
END;
FUNCTION TSTRINGLIST.READLINE:STRING;
BEGIN
 IF AKTL<>NIL THEN
 BEGIN
  READLINE:=AKTL^.S;
  AKTL:=AKTL^.NEXT;
 END ELSE READLINE:='';
END;
PROCEDURE TSTRINGLIST.GOTOLINE(NR:DWORD);
BEGIN
 AKTL:=FIRST;
 IF AKTL=NIL THEN
 BEGIN
  LINEC:=1;
  NEW(AKTL);
  FIRST:=AKTL;
  AKTL^.LAST:=NIL;
  AKTL^.NEXT:=NIL;
  AKTL^.S:='';
 END;
 WHILE (NR>0) AND (AKTL^.NEXT<>NIL) DO
 BEGIN
  AKTL:=AKTL^.NEXT;
  DEC(NR);
 END;
 IF NR>0 THEN
 BEGIN
  WHILE (NR>0) DO
  BEGIN
   INC(LINEC);
   NEW(AKTL^.NEXT);
   AKTL^.NEXT^.LAST:=AKTL;
   AKTL:=AKTL^.NEXT;
   AKTL^.S:='';
   DEC(NR);
  END;
  AKTL^.NEXT:=NIL;
 END;
END;
DESTRUCTOR TSTRINGLIST.DONE;
VAR P,P2:PSTRINGITEM;
BEGIN
 P:=FIRST;
 WHILE P<>NIL DO
 BEGIN
  P2:=P^.NEXT;
  DISPOSE(P);
  P:=P2;
 END;
END;
CONSTRUCTOR TSTRINGLIST.INIT;
BEGIN
 FIRST:=NIL;
 LINEC:=0;
END;
FUNCTION READWORD(VAR P:DWORD;S:STRING):STRING;
VAR F:BOOLEAN;
BEGIN
 READWORD:='';
 F:=FALSE;
 WHILE P<=BYTE(S[0]) DO
 BEGIN
  IF S[P]=#32 THEN
  BEGIN
   IF READWORD<>'' THEN EXIT;
  END ELSE READWORD:=READWORD+S[P];
  INC(P);
 END;
END;
FUNCTION UPSTR(S:STRING):STRING;
VAR I:DWORD;
BEGIN
 FOR I:=1 TO BYTE(S[0]) DO S[I]:=UPCASE(S[I]);
 UPSTR:=S;
END;
END.
