UNIT DEBUG;
INTERFACE
USES GUI,GUIOBJ,GRAPH,PICSERV;
TYPE PKERNELDEBUGF=^TKERNELDEBUGF;
     PKERNELDEBUGV=^TKERNELDEBUGV;
     PKERNELDEBUGH=^TKERNELDEBUGH;
     PKERNELDEBUG=^TKERNELDEBUG;
     TKERNELDEBUGH=OBJECT(THSCROLLBAR)
      CONSTRUCTOR INIT(BAS:PKERNELDEBUG);
      PROCEDURE ONCHANGE(POS:DWORD);VIRTUAL;
      KERNELDEBUG:PKERNELDEBUG;
     END;
     TKERNELDEBUGV=OBJECT(TVSCROLLBAR)
      CONSTRUCTOR INIT(BAS:PKERNELDEBUG);
      PROCEDURE ONCHANGE(POS:DWORD);VIRTUAL;
      PRIVATE      
      KERNELDEBUG:PKERNELDEBUG;
     END;
     TKERNELDEBUGF=OBJECT(TOBJ)
      CONSTRUCTOR INIT(BAS:PKERNELDEBUG);
      PROCEDURE ONPAINT;VIRTUAL;
      PRIVATE
      KERNELDEBUG:PKERNELDEBUG;
     END;
     TKERNELDEBUG=OBJECT(TOBJ)
      CONSTRUCTOR INIT(BAS:POBJ;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN);
      PROCEDURE ONSIZE;VIRTUAL;
      PRIVATE
      SCV:PKERNELDEBUGV;
      SCH:PKERNELDEBUGH;
      SURF:PKERNELDEBUGF;
      CHECK:PCHECKBOX;
      FONTS:DWORD;
      FONTH:DWORD;
      FONT:PSTRING;
     END;
TYPE PKERNELDEBUGWINDOW=^TKERNELDEBUGWINDOW;
     TKERNELDEBUGWINDOW=OBJECT(TWINDOW)
      CONSTRUCTOR INIT(BAS:POBJ;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN);
      PROCEDURE ONSIZE;VIRTUAL;
      PROCEDURE CHECKSIZE;VIRTUAL;
      PRIVATE
      KDB:PKERNELDEBUG;
     END;
VAR ALLOCDEBUGSYS:FUNCTION:BOOLEAN;
    RELEASEDEBUGSYS:PROCEDURE;
    INSTALLNEWDEBUGHANDLER:PROCEDURE(P:POINTER);
    GETDEBUGLINECOUNT:FUNCTION:DWORD;
    COPYDEBUGBUFFER:PROCEDURE(START,COUNT:DWORD;Z:PSTRINGARRAY);
PROCEDURE DEBUGHANDLER;
IMPLEMENTATION
VAR DEBUGDRV:PDRIVER;
    DEBUGPROT:PPOINTERARRAY;
    DEBUGOBJ:PKERNELDEBUG;
PROCEDURE TKERNELDEBUGWINDOW.CHECKSIZE;
BEGIN
 INHERITED CHECKSIZE;
 IF LONGINT(HI)<93 THEN HI:=93;
 IF LONGINT(WI)<68 THEN WI:=68; 
END;
PROCEDURE TKERNELDEBUGWINDOW.ONSIZE;
BEGIN
 INHERITED ONSIZE;
 KDB^.SIZE(GETAFH,GETAFB);
END;
CONSTRUCTOR TKERNELDEBUGWINDOW.INIT(BAS:POBJ;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN);
BEGIN
 INHERITED INIT(BAS,X,Y,H,B,VIS,'Kernel-Debuggerausgabe',FON_STANDARD,12);
 NEW(KDB,INIT(@SELF,0,0,GETAFH,GETAFB,TRUE));
END;
PROCEDURE TKERNELDEBUGH.ONCHANGE(POS:DWORD);
BEGIN
 KERNELDEBUG^.SURF^.REDRAW;
END;
CONSTRUCTOR TKERNELDEBUGH.INIT(BAS:PKERNELDEBUG);
BEGIN
 INHERITED INIT(BAS,BAS,0,BAS^.HI-20,20,BAS^.WI-20,TRUE,0,1280);
 KERNELDEBUG:=BAS;
END;
PROCEDURE TKERNELDEBUGV.ONCHANGE(POS:DWORD);
BEGIN
 KERNELDEBUG^.SURF^.REDRAW;
END;
CONSTRUCTOR TKERNELDEBUGV.INIT(BAS:PKERNELDEBUG);
BEGIN
 INHERITED INIT(BAS,BAS,BAS^.WI-20,0,BAS^.HI-20,20,TRUE,0,0);
 KERNELDEBUG:=BAS;
END;
PROCEDURE TKERNELDEBUGF.ONPAINT;
VAR FH,LINE,I,L:DWORD;
    Y,SCL:LONGINT;
    S:STRING;
BEGIN
 SELECTFONT(KERNELDEBUG^.FONT^);
 CLEAR(CL_BLACK);
 Y:=0;
 FH:=GETSTRINGHEIGHT(KERNELDEBUG^.FONTS);
 L:=HI DIV FH+BYTE(HI MOD FH<>0);
 IF L>0 THEN DEC(L);
 LINE:=KERNELDEBUG^.SCV^.GETPOS;
 SCL:=-LONGINT(KERNELDEBUG^.SCH^.GETPOS);
 FOR I:=0 TO L DO
 BEGIN
  COPYDEBUGBUFFER(LINE+I,1,@S);
  PUTSTRING(SCL,Y,S,CL_YELLOW,KERNELDEBUG^.FONTS);
  INC(Y,FH);
 END;
END;
CONSTRUCTOR TKERNELDEBUGF.INIT(BAS:PKERNELDEBUG);
BEGIN
 INHERITED INIT(BAS,BAS,0,0,BAS^.HI-20,BAS^.WI-20,TRUE);
 KERNELDEBUG:=BAS;
END;
PROCEDURE TKERNELDEBUG.ONSIZE;
BEGIN
 SCV^.MOVESIZE(WI-20,0,HI-20,20);
 SCH^.MOVESIZE(0,HI-20,20,WI-20);
 SURF^.SIZE(HI-20,WI-20);
 CHECK^.MOVE(WI-20,HI-20);
END;
CONSTRUCTOR TKERNELDEBUG.INIT(BAS:POBJ;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN);
BEGIN
 IF NOT ALLOCDEBUGSYS() THEN HALT;
 INHERITED INIT(BAS,NIL,X,Y,H,B,VIS);
 NEW(SCV,INIT(@SELF));
 NEW(SCH,INIT(@SELF));
 NEW(SURF,INIT(@SELF));
 NEW(CHECK,INIT(@SELF,B-20,H-20,20,20,TRUE,'',CL_BLACK,TRUE,FON_STANDARD,12));
 FONT:=FON_STANDARD;
 FONTS:=12;
 SELECTFONT(FONT^);
 FONTH:=GETSTRINGHEIGHT(FONTS);
 DEBUGOBJ:=@SELF;
 INSTALLNEWDEBUGHANDLER(@DEBUGHANDLER);
 SCV^.SETRANGE(GETDEBUGLINECOUNT());
END;
PROCEDURE DEBUGHANDLER;
VAR W,H:DWORD;
BEGIN
 IF DEBUGOBJ<>NIL THEN
 BEGIN
  W:=GETDEBUGLINECOUNT();
  IF W<>DEBUGOBJ^.SCV^.GETRANGE THEN DEBUGOBJ^.SCV^.SETRANGE(W);
  IF DEBUGOBJ^.CHECK^.ISCHECKED THEN
  BEGIN
   H:=(DEBUGOBJ^.SURF^.HI DIV DEBUGOBJ^.FONTH);
   IF H>1 THEN DEC(H);
   IF W>H THEN W:=W-H ELSE W:=0;
   DEBUGOBJ^.SCV^.SETPOS(W);
  END;
  DEBUGOBJ^.SURF^.REDRAW;
 END;
END;
INITIALIZATION
 DEBUGPROT:=WAITFORADRIVER(3,2,DEBUGDRV);
 POINTER(ALLOCDEBUGSYS):=DEBUGPROT^[0];
 POINTER(RELEASEDEBUGSYS):=DEBUGPROT^[1];
 POINTER(INSTALLNEWDEBUGHANDLER):=DEBUGPROT^[2];
 POINTER(GETDEBUGLINECOUNT):=DEBUGPROT^[3];
 POINTER(COPYDEBUGBUFFER):=DEBUGPROT^[4];
FINALIZATION
 IF DEBUGOBJ<>NIL THEN RELEASEDEBUGSYS();
 SIGNALEXIT(DEBUGDRV,2);
END.
