UNIT DISKS;
INTERFACE
USES MEMORY,IRQS;
{$I ..\INCLUDE\DISKS.DEF}
TYPE PDISK=^TDISK;
     TDISK=OBJECT
      PROCEDURE ONDONE;VIRTUAL;
      CONSTRUCTOR INIT(DESC:STRING;BLOCKS,BLOCKSIZE:DWORD);
      PROCEDURE EXECUTE;VIRTUAL;
      PROCEDURE HANDLEIRQ(NR:DWORD);VIRTUAL;
      PROCEDURE SIGNALTASK;
      FUNCTION GETWORK(VAR START:DWORD;VAR TAR:POINTER):DWORD;
      PRIVATE
      DESTRUCTOR DONE;
      NEXT,LAST:PDISK;
      HANDLE:POINTER;
      DELETED:BOOLEAN;
      ADDLOCK:TLOCK;
      ADDLIST:DWORD;
      ADDLISTS:ARRAY[0..1] OF PDRVDISKHAND1;
      WORKLISTUPDATE:DWORD;
      RUNNING:LONGBOOL;
      WORKLIST,LASTWORK:PDRVDISKHAND1;      
      EXEC:BOOLEAN;
     END;
PROCEDURE REMOVEDISK(P:PDISK);
FUNCTION INSTALLIRQ(NR:DWORD):BOOLEAN;
PROCEDURE UNINSTALLIRQ(NR:DWORD);
IMPLEMENTATION
VAR DISKDRV1:PDRIVER;
    DISKPROT1:PPOINTERARRAY;
    ADDDISK:FUNCTION(DATAP,CALLP:POINTER;SIZE,BLOCKSIZE:DWORD;NAME:STRING):POINTER;
    REMOVEDISKC:PROCEDURE(DISK:POINTER);
    SIGNALDISKOPDONE:PROCEDURE(P:PDRVDISKHAND1);    
    FIRSTDISK:PDISK;
    DISK_LOCK:TLOCK;
    DISK_READ:TREADSTAT;
    DISK_TASK:POINTER;
    SHUTDOWNMODE:BOOLEAN;
{$I ..\INCLUDE\DISKS\IRQS.INC}
FUNCTION TDISK.GETWORK(VAR START:DWORD;VAR TAR:POINTER):DWORD;
BEGIN
 IF (LASTWORK<>NIL) THEN
 BEGIN
  SIGNALDISKOPDONE(LASTWORK);
  LASTWORK:=NIL;
 END;
 IF WORKLIST=NIL THEN
 BEGIN
  RUNNING:=FALSE;
  WORKLISTUPDATE:=0;
  IF (ADDLISTS[ADDLIST]<>NIL) AND TRYTOSETDWORD(@WORKLISTUPDATE) THEN
  BEGIN
   ENABLETASK(DISK_TASK);
  END;
  GETWORK:=0;
  EXIT;
 END;
 LASTWORK:=WORKLIST;
 START:=WORKLIST^.ADDR;
 TAR:=WORKLIST^.DATA;
 GETWORK:=WORKLIST^.W1;
 WORKLIST:=WORKLIST^.NEXT;
END;
PROCEDURE TDISK.EXECUTE;
BEGIN
END;
PROCEDURE TDISK.HANDLEIRQ(NR:DWORD);
BEGIN
END;
PROCEDURE TDISK.SIGNALTASK;
BEGIN
 EXEC:=TRUE;
 ENABLETASK(DISK_TASK);
END;
PROCEDURE TDISK.ONDONE;
BEGIN
END;
PROCEDURE DISKTASK;
VAR P:PDISK;
    L:DWORD;
    P1,P2,P3,P4:PDRVDISKHAND1;
BEGIN
 ASM
   STI
 END;
 DISABLETASK(DISK_TASK);
 WHILE (NOT SHUTDOWNMODE) DO
 BEGIN
  P:=FIRSTDISK;
  WHILE P<>NIL DO
  BEGIN
   IF (NOT P^.RUNNING) AND (P^.WORKLISTUPDATE<>0) THEN
   BEGIN
    P^.RUNNING:=TRUE;
    GETLOCK(@P^.ADDLOCK);
    L:=P^.ADDLIST;
    P^.ADDLIST:=(NOT L) AND 1;
    FREELOCK(@P^.ADDLOCK);
    WITH P^ DO
    BEGIN
     P1:=ADDLISTS[L];
     WHILE P1<>NIL DO
     BEGIN
      P4:=P1^.NEXT;
      P2:=WORKLIST;
      P3:=NIL;
      WHILE (P2<>NIL) AND (P2^.ADDR<=P1^.ADDR) DO
      BEGIN
       P3:=P2;
       P2:=P2^.NEXT;
      END;
      IF P3=NIL THEN
      BEGIN
       P1^.NEXT:=WORKLIST;
       P1^.LAST:=NIL;
       IF WORKLIST<>NIL THEN WORKLIST^.LAST:=P1;
       WORKLIST:=P1;
      END
      ELSE
      BEGIN
       P1^.NEXT:=P3^.NEXT;
       P3^.NEXT:=P1;
       P1^.LAST:=P3;
       IF P1^.NEXT<>NIL THEN P1^.NEXT^.LAST:=P1;
      END;
      P1:=P4;
     END;
     ADDLISTS[L]:=NIL;
    END;    
    P^.EXECUTE;
    DISABLETASK(DISK_TASK);
   END;
   IF P^.EXEC THEN
   BEGIN
    P^.EXEC:=FALSE;
    P^.EXECUTE;
    DISABLETASK(DISK_TASK);
   END;
   P:=P^.NEXT;
  END;
 END;
 DESTROYTASK(DISK_TASK,@DISK_TASK);
END;
PROCEDURE PCD1_READBLOCK(P:PDISK;D:PDRVDISKHAND1);
VAR L:DWORD;
BEGIN
 D^.LAST:=NIL;
 D^.W1:=1;
 WITH P^ DO
 BEGIN
  GETLOCK(@ADDLOCK);
  L:=ADDLIST;
  IF ADDLISTS[L]<>NIL THEN ADDLISTS[L]^.LAST:=D;
  D^.NEXT:=ADDLISTS[L];
  ADDLISTS[L]:=D;
  FREELOCK(@ADDLOCK);
  IF (WORKLIST=NIL) AND TRYTOSETDWORD(@P^.WORKLISTUPDATE) THEN
  BEGIN
   WHILE DISK_TASK=NIL DO SCHEDULE;
   ENABLETASK(DISK_TASK);
  END;
 END;
END;
PROCEDURE PCD1_WRITEBLOCK(P:PDISK;D:PDRVDISKHAND1);
VAR L:DWORD;
BEGIN
 D^.LAST:=NIL;
 D^.W1:=2;
 WITH P^ DO
 BEGIN
  GETLOCK(@ADDLOCK);
  L:=ADDLIST;
  IF ADDLISTS[L]<>NIL THEN ADDLISTS[L]^.LAST:=D;
  D^.NEXT:=ADDLISTS[L];
  ADDLISTS[L]:=D;
  FREELOCK(@ADDLOCK);  
  IF (WORKLIST=NIL) AND TRYTOSETDWORD(@WORKLISTUPDATE) THEN
  BEGIN
   WHILE DISK_TASK=NIL DO SCHEDULE;
   ENABLETASK(DISK_TASK);
  END;
 END;
END;
CONST PCD1_FUNCS:ARRAY[0..1] OF POINTER=(
       @PCD1_READBLOCK,
       @PCD1_WRITEBLOCK);
DESTRUCTOR TDISK.DONE;
BEGIN
 GETLOCK(@DISK_LOCK);
 IF LAST<>NIL THEN LAST^.NEXT:=NEXT ELSE FIRSTDISK:=NEXT;
 IF NEXT<>NIL THEN NEXT^.LAST:=LAST;
 FREELOCK(@DISK_LOCK);
 WAITFORREADCYCL(@DISK_READ);
 REMOVEDISKC(HANDLE);
 ONDONE;
END;
CONSTRUCTOR TDISK.INIT(DESC:STRING;BLOCKS,BLOCKSIZE:DWORD);
BEGIN
 ADDLIST:=0;
 ADDLISTS[0]:=NIL;
 ADDLISTS[1]:=NIL;
 WORKLIST:=NIL;
 WORKLISTUPDATE:=0;
 RUNNING:=FALSE;
 LASTWORK:=NIL;
 RESETATOM(@ADDLOCK);
 DELETED:=FALSE;
 GETLOCK(@DISK_LOCK);
 HANDLE:=ADDDISK(@PCD1_FUNCS,@SELF,BLOCKS,BLOCKSIZE,DESC);
 IF HANDLE=NIL THEN
 BEGIN
  WRITELNSTR('ADD DISK : FAILED');
  FREELOCK(@DISK_LOCK);
  FAIL;
 END;
 NEXT:=FIRSTDISK;
 LAST:=NIL;
 IF FIRSTDISK<>NIL THEN FIRSTDISK^.LAST:=@SELF;
 FIRSTDISK:=@SELF;
 FREELOCK(@DISK_LOCK)
END;
PROCEDURE REMOVEDISK(P:PDISK);
VAR GR:DWORD;
    Z:PDISK;
    D:BOOLEAN;
BEGIN
 GR:=STARTREAD(@DISK_READ);
 Z:=FIRSTDISK;
 WHILE (Z<>NIL) AND (Z<>P) DO Z:=Z^.NEXT;
 IF Z=NIL THEN
 BEGIN
  STOPREAD(@DISK_READ,GR);
  EXIT;
 END;
 D:=TRYTOSETBYTE(@P^.DELETED);
 STOPREAD(@DISK_READ,GR);
 IF D THEN DISPOSE(P,DONE);
END;
INITIALIZATION
 DISKPROT1:=WAITFORADRIVER($11,1,DISKDRV1);
 POINTER(ADDDISK):=DISKPROT1^[0];
 POINTER(REMOVEDISKC):=DISKPROT1^[1];
 POINTER(SIGNALDISKOPDONE):=DISKPROT1^[2];
 DISK_TASK:=CREATETASK(GETSYSTEMPROCESS(),@DISKTASK,$7FFFFFFF,'Disk-Task');
FINALIZATION
 WHILE (FIRSTDISK<>NIL) DO REMOVEDISK(FIRSTDISK);
 SHUTDOWNMODE:=TRUE;
 ENABLETASK(DISK_TASK);
 WHILE DISK_TASK<>NIL DO SCHEDULE;
 SIGNALEXIT(DISKDRV1,1);
END.
