TYPE PDISKIRQ=^TDISKIRQ;
     TDISKIRQ=RECORD
      NEXT,LAST:PDISKIRQ;
      NR:DWORD;
      USERS:DWORD;
      IRQHAND:TIRQHANDLER;
     END;
VAR FIRSTDISKIRQ:PDISKIRQ;
    DISKIRQLOCK:TLOCK;
PROCEDURE DISKS_IRQSHAND(NR:POINTER);
VAR P:PDISK;
    GR:DWORD;
BEGIN
 GR:=STARTREAD(@DISK_READ);
 P:=FIRSTDISK;
 WHILE P<>NIL DO
 BEGIN
  P^.HANDLEIRQ(DWORD(NR));
  P:=P^.NEXT;
 END;
 STOPREAD(@DISK_READ,GR);
END;
PROCEDURE UNINSTALLIRQ(NR:DWORD);
VAR P:PDISKIRQ;
BEGIN
 GETLOCK(@DISKIRQLOCK);
 P:=FIRSTDISKIRQ;
 WHILE P<>NIL DO
 BEGIN
  IF P^.NR=NR THEN
  BEGIN
   DEC(P^.USERS);
   IF P^.USERS=0 THEN
   BEGIN
    REMOVEIRQHANDLER(P^.NR,@P^.IRQHAND);
    IF P^.LAST<>NIL THEN P^.LAST^.NEXT:=P^.NEXT ELSE FIRSTDISKIRQ:=P^.NEXT;
    IF P^.NEXT<>NIL THEN P^.NEXT^.LAST:=P^.LAST;
    DISPOSE(P);
   END;
   FREELOCK(@DISKIRQLOCK);
  END;
  P:=P^.NEXT;
 END;
END;
FUNCTION INSTALLIRQ(NR:DWORD):BOOLEAN;
VAR P:PDISKIRQ;
BEGIN
 GETLOCK(@DISKIRQLOCK);
 P:=FIRSTDISKIRQ;
 WHILE P<>NIL DO
 BEGIN
  IF P^.NR=NR THEN
  BEGIN
   INC(P^.USERS);
   FREELOCK(@DISKIRQLOCK);
   INSTALLIRQ:=TRUE;
   EXIT;
  END;
  P:=P^.NEXT;
 END;
 IF NOT GETIRQ(NR) THEN
 BEGIN
  FREELOCK(@DISKIRQLOCK);
  INSTALLIRQ:=FALSE;
  EXIT;
 END;
 NEW(P);
 P^.NEXT:=FIRSTDISKIRQ;
 IF FIRSTDISKIRQ<>NIL THEN FIRSTDISKIRQ^.LAST:=P;
 P^.LAST:=NIL;
 P^.USERS:=1;
 P^.IRQHAND.DATA:=POINTER(NR);
 P^.IRQHAND.PROC:=@DISKS_IRQSHAND;
 ADDIRQHANDLER(NR,@P^.IRQHAND);
 FREELOCK(@DISKIRQLOCK);
 INSTALLIRQ:=TRUE;
END;
