UNIT GRAPH;
INTERFACE
{$I ..\INCLUDE\GRAPH.DEF}
CONST RGB_BLACK=$000000;
      RGB_BLUE=$7F0000;
      RGB_GREEN=$007F00;
      RGB_RED=$00007F;
      RGB_GRAY=$7F7F7F;
      RGB_SILVER=$BFBFBF;
      RGB_YELLOW=$00FFFF;
      RGB_WHITE=$FFFFFF;
      RGB_LSILVER=$CFCFCF;
      RGB_LBLUE=$FF0000;
TYPE PWIN=^TWIN;
     TWIN=RECORD
      ADDX,ADDY,SUBX,SUBY,MAXX,MAXY:LONGINT;
      VIS:BOOLEAN;
     END;
VAR INITMODEC:FUNCTION(WIDTH,HEIGHT,BPP:DWORD):POINTER;
    DONEMODE:PROCEDURE;
    JOINMODEC:FUNCTION(VAR HEIGHT,WIDTH:DWORD):POINTER;
    SHOW:PROCEDURE;
    PUTPIXEL:PROCEDURE(X,Y:LONGINT;C:DWORD);
    CLEAR:PROCEDURE(C:DWORD);
    BAR:PROCEDURE(X,Y:LONGINT;H,B,C:DWORD);
    PUTPIC:PROCEDURE(X,Y:LONGINT;P:PPICTURE);
    SELECTFONT:FUNCTION(NAME:STRING):BOOLEAN;
    PUTSTRING:PROCEDURE(X,Y:LONGINT;S:STRING;C,SZ:DWORD);
    GETSTRINGWIDTH:FUNCTION(S:STRING;SZ:DWORD):DWORD;
    GETSTRINGHEIGHT:FUNCTION(SZ:DWORD):DWORD;
    SETAREA:PROCEDURE(X,Y:LONGINT;H,B:DWORD);
    SETAREABW:PROCEDURE(P:PWIN);
    SETWIN:FUNCTION(WIN:PWIN):BOOLEAN;
    CREATEABSWIN:PROCEDURE(X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;VAR WIN:TWIN);
    CREATESUBWIN:PROCEDURE(BAS:PWIN;X,Y:LONGINT;H,B:DWORD;VIS:BOOLEAN;VAR WIN:TWIN);
    CONV:FUNCTION(C:DWORD):DWORD;
    SETMOUSE:PROCEDURE(X,Y:LONGINT;PIC:PPICTURE;HX,HY:LONGINT);
    BAR3D:PROCEDURE(X,Y:LONGINT;H,B:DWORD);
    FRAME3D:PROCEDURE(X,Y:LONGINT;H,B:DWORD);
    BARI3D:PROCEDURE(X,Y:LONGINT;H,B:DWORD);
    FRAMEI3D:PROCEDURE(X,Y:LONGINT;H,B:DWORD);
    DRAWSPOINTERUP:PROCEDURE(X,Y:LONGINT;H,CL:DWORD);
    DRAWSPOINTERLEFT:PROCEDURE(X,Y:LONGINT;H,CL:DWORD);
    DRAWSPOINTERRIGHT:PROCEDURE(X,Y:LONGINT;H,CL:DWORD);
    DRAWSPOINTERDOWN:PROCEDURE(X,Y:LONGINT;H,CL:DWORD);
    DRAWCROSS:PROCEDURE(X,Y:LONGINT;H,CL:DWORD);
    HEIGHT,WIDTH:DWORD;    
    CL_YELLOW,CL_SILVER,CL_LSILVER,CL_WHITE,CL_GRAY,CL_BLACK,CL_BLUE,CL_GREEN,CL_RED,CL_LBLUE:DWORD;
    CL_LGREEN:DWORD;
FUNCTION GETGRAPHDRIVER:PDRIVER;
FUNCTION INITMODE(WIDTH,HEIGHT,BPP:DWORD):BOOLEAN;
PROCEDURE JOINMODE;
FUNCTION SELECTGRAPHDRIVER(P:PDRIVER):BOOLEAN;
PROCEDURE FINDGRAPHDRIVER;
PROCEDURE EXITGRAPHDRIVER;
IMPLEMENTATION
VAR GRAPHDRV:PDRIVER;
    GRAPHPROT:PPOINTERARRAY;
PROCEDURE READMODEGRAPHPROCS(P:PPOINTERARRAY);
BEGIN
 POINTER(SHOW):=P^[0];
 POINTER(PUTPIXEL):=P^[1];
 POINTER(CLEAR):=P^[2];
 POINTER(BAR):=P^[3];
 POINTER(PUTPIC):=P^[4];
 POINTER(BAR3D):=P^[5];
 POINTER(BARI3D):=P^[6];
 POINTER(FRAME3D):=P^[7];
 POINTER(FRAMEI3D):=P^[8];
 POINTER(SELECTFONT):=P^[9];
 POINTER(PUTSTRING):=P^[10];
 POINTER(GETSTRINGWIDTH):=P^[11];
 POINTER(GETSTRINGHEIGHT):=P^[12];
 POINTER(DRAWSPOINTERUP):=P^[13];
 POINTER(DRAWSPOINTERLEFT):=P^[14];
 POINTER(DRAWSPOINTERRIGHT):=P^[15];
 POINTER(DRAWSPOINTERDOWN):=P^[16];
 POINTER(DRAWCROSS):=P^[17];
 CL_BLACK:=CONV($000000);
 CL_BLUE:=CONV($7F0000);
 CL_GREEN:=CONV($007F00);
 CL_RED:=CONV($00007F);
 CL_GRAY:=CONV($7F7F7F);
 CL_SILVER:=CONV($BFBFBF);
 CL_YELLOW:=CONV($00FFFF);
 CL_WHITE:=CONV($FFFFFF);
 CL_LSILVER:=CONV($CFCFCF);
 CL_LBLUE:=CONV($FF0000);
 CL_LGREEN:=CONV($00FF00);
END;
PROCEDURE JOINMODE;
BEGIN
 READMODEGRAPHPROCS(JOINMODEC(HEIGHT,WIDTH));
END;
FUNCTION GETGRAPHDRIVER:PDRIVER;
BEGIN
 GETGRAPHDRIVER:=GRAPHDRV;
END;
FUNCTION INITMODE(WIDTH,HEIGHT,BPP:DWORD):BOOLEAN;
VAR P:PPOINTERARRAY;
BEGIN
 P:=INITMODEC(WIDTH,HEIGHT,BPP);
 INITMODE:=P<>NIL;
 IF INITMODE THEN
 BEGIN
  READMODEGRAPHPROCS(P);
  GRAPH.HEIGHT:=HEIGHT;
  GRAPH.WIDTH:=WIDTH;
 END;
END;
PROCEDURE READSTDGRAPHPROCS;
BEGIN
 POINTER(INITMODEC):=GRAPHPROT^[0];
 POINTER(DONEMODE):=GRAPHPROT^[1];
 POINTER(JOINMODEC):=GRAPHPROT^[2];
 POINTER(SETAREA):=GRAPHPROT^[3];
 POINTER(SETAREABW):=GRAPHPROT^[4];
 POINTER(SETWIN):=GRAPHPROT^[5];
 POINTER(CREATEABSWIN):=GRAPHPROT^[6];
 POINTER(CREATESUBWIN):=GRAPHPROT^[7];
 POINTER(CONV):=GRAPHPROT^[8];
 POINTER(SETMOUSE):=GRAPHPROT^[9];
END;
PROCEDURE EXITGRAPHDRIVER;
BEGIN
 IF GRAPHDRV<>NIL THEN
 BEGIN
  SIGNALEXIT(GRAPHDRV,2);
  GRAPHDRV:=NIL;
 END;
END;
FUNCTION SELECTGRAPHDRIVER(P:PDRIVER):BOOLEAN;
BEGIN
 GRAPHPROT:=P^.GETPROT(2);
 SELECTGRAPHDRIVER:=GRAPHPROT<>NIL;
 IF SELECTGRAPHDRIVER THEN
 BEGIN
  GRAPHDRV:=P;
  READSTDGRAPHPROCS;
 END;
END;
PROCEDURE FINDGRAPHDRIVER;
BEGIN
 GRAPHPROT:=WAITFORADRIVER(7,2,GRAPHDRV);
 READSTDGRAPHPROCS;
END;
FINALIZATION
 EXITGRAPHDRIVER;
END.
