UNIT SYSTEM;
{$ASMMODE INTEL}
INTERFACE
{$I ..\..\FPINC\TYPES.INH}
{$I ..\INCLUDE\SYSTEM\DRV.INH}
{$I ..\INCLUDE\SYSTEM\DEBUG.INH}
{$I ..\INCLUDE\SYSTEM\TASKS.INH}
{$I ..\INCLUDE\SYSTEM\MEM.INH}
{$I ..\INCLUDE\SYSTEM\PARAMS.INH}
VAR PROG_BASE:DWORD;
    PROG_SIZE:DWORD;
    PROG_BSS:DWORD;
    EXPLSHUTDOWN:PROCEDURE;
    INITDRVSYS:FUNCTION(PR:DWORD):POINTER;
    GETMEMC:FUNCTION(SIZE:DWORD):POINTER;
    FREEMEMC:PROCEDURE(P:POINTER);
{$I ..\..\FPINC\ATOM.INH}
{$I ..\..\FPINC\I386.INH}
PROCEDURE HALT;
PROCEDURE HALT(S:STRING);
PROCEDURE HALTTASK;
FUNCTION UPCASE(C:CHAR):CHAR;
FUNCTION UPSTR(S:STRING):STRING;
FUNCTION HEXSTR(W,L:DWORD):STRING;
FUNCTION HEXSTR(W:DWORD):STRING;
FUNCTION INTSTR(W:LONGINT):STRING;
FUNCTION FORMATRSTR(S:STRING;LEN:DWORD):STRING;
FUNCTION FORMATLSTR(S:STRING;LEN:DWORD):STRING;
PROCEDURE KEEP;
PROCEDURE INCHALTCOUNT;
PROCEDURE DECDRIVERCOUNT;
PROCEDURE SIGNALEXIT(P:PDRIVER;NR:DWORD);
PROCEDURE GETMEM(VAR P:POINTER;SIZE:DWORD);
PROCEDURE FREEMEM(P:POINTER;SIZE:DWORD);
PROCEDURE FREEMEM(VAR P:POINTER);
FUNCTION STR_COPY(S:STRING;START,COUNT:DWORD):STRING;
PROCEDURE STR_DELETE(VAR S:STRING;START,COUNT:DWORD);
PROCEDURE STR_INSERT(S:STRING;VAR Z:STRING;P:DWORD);
FUNCTION LENGTH(P:PCHAR):DWORD;
FUNCTION COMPARE(P1,P2:PCHAR):BOOLEAN;
IMPLEMENTATION
VAR DRIVERCOUNT:DWORD;
    DRIVERLOCK:TLOCK;
FUNCTION COMPARE(P1,P2:PCHAR):BOOLEAN;
BEGIN
 WHILE TRUE DO
 BEGIN
  IF P1^<>P2^ THEN
  BEGIN
   COMPARE:=FALSE;
   EXIT;
  END;
  IF (P1^=#0) THEN
  BEGIN
   COMPARE:=TRUE;
   EXIT;
  END;
  INC(P1);
  INC(P2);
 END;
END;
FUNCTION LENGTH(P:PCHAR):DWORD;
BEGIN
 LENGTH:=0;
 WHILE P^<>#0 DO
 BEGIN
  INC(LENGTH);
  INC(P);
 END;
END;
FUNCTION FORMATLSTR(S:STRING;LEN:DWORD):STRING;
BEGIN
 IF LEN>255 THEN LEN:=255;
 WHILE BYTE(S[0])<LEN DO S:=S+' ';
 IF BYTE(S[0])>LEN THEN S[0]:=CHAR(LEN);
 FORMATLSTR:=S;
END;
FUNCTION FORMATRSTR(S:STRING;LEN:DWORD):STRING;
BEGIN
 IF LEN>255 THEN LEN:=255;
 WHILE BYTE(S[0])<LEN DO S:=' '+S;
 IF BYTE(S[0])>LEN THEN S[0]:=CHAR(LEN);
 FORMATRSTR:=S;
END;
PROCEDURE STR_INSERT(S:STRING;VAR Z:STRING;P:DWORD);
VAR I,L:DWORD;
BEGIN
 L:=DWORD(BYTE(Z[0]))+DWORD(BYTE(S[0]));
 IF L>255 THEN
 BEGIN
  BYTE(S[0]):=255-BYTE(Z[0]);
  L:=255;
 END;
 IF P>BYTE(Z[0])+1 THEN P:=BYTE(Z[0])+1;
 IF P=0 THEN P:=1;
 IF L>P+BYTE(S[0]) THEN FOR I:=L DOWNTO P+BYTE(S[0]) DO
 BEGIN
  Z[I]:=Z[I-BYTE(S[0])];
 END;
 DEC(P);
 FOR I:=1 TO BYTE(S[0]) DO Z[I+P]:=S[I];
 Z[0]:=CHAR(L);
END;
PROCEDURE STR_DELETE(VAR S:STRING;START,COUNT:DWORD);
VAR I,L:DWORD;
BEGIN
 L:=BYTE(S[0]);
 IF START=0 THEN INC(START);
 IF START>L THEN EXIT;
 IF START+COUNT>L+1 THEN COUNT:=L-START+1;
 DEC(L,COUNT);
 FOR I:=START TO L DO S[I]:=S[I+COUNT];
 S[0]:=CHAR(L);
END;
FUNCTION STR_COPY(S:STRING;START,COUNT:DWORD):STRING;
VAR L:DWORD;
BEGIN
 STR_COPY:='';
 L:=BYTE(S[0]);
 IF START=0 THEN INC(START);
 IF START>L THEN EXIT;
 IF START+COUNT>L+1 THEN COUNT:=L-START+1;
 FOR L:=START TO START+COUNT-1 DO
 BEGIN
  STR_COPY:=STR_COPY+S[L];
 END;
END;
PROCEDURE HANDLEERROR(NR:DWORD);
BEGIN
 HALT('Error : '+HEXSTR(NR,8));
END;
{$I ..\..\FPINC\ATOM.INC}
CONST HEXCHARS:ARRAY[0..15] OF CHAR=('0','1','2','3','4','5','6','7','8','9',
                                     'A','B','C','D','E','F');
FUNCTION INTSTR(W:LONGINT):STRING;
VAR SIGNED:BOOLEAN;
BEGIN
 IF W<0 THEN
 BEGIN
  SIGNED:=TRUE;
  W:=-W;
 END ELSE SIGNED:=FALSE;
 INTSTR:='';
 REPEAT
  INTSTR:=HEXCHARS[W MOD 10]+INTSTR;
  W:=W DIV 10;
 UNTIL W=0;
 IF SIGNED THEN INTSTR:='-'+INTSTR;
END;
TYPE SIGNALEXITPROC=PROCEDURE(NR:DWORD);
PROCEDURE SIGNALEXIT(P:PDRIVER;NR:DWORD);
VAR PR:PPOINTERARRAY;
BEGIN
 PR:=P^.GETPROT(0);
 IF PR<>NIL THEN SIGNALEXITPROC(PR^[1])(NR);
END;
PROCEDURE INCHALTCOUNT;
BEGIN
 GETLOCK(@DRIVERLOCK);
 INC(DRIVERCOUNT);
 FREELOCK(@DRIVERLOCK);
END;
PROCEDURE DECDRIVERCOUNT;
BEGIN
 GETLOCK(@DRIVERLOCK);
 DEC(DRIVERCOUNT);
 FREELOCK(@DRIVERLOCK);
END;
PROCEDURE KEEP;
BEGIN
 INCHALTCOUNT;
 HALT;
END;
PROCEDURE FREEMEM(VAR P:POINTER);[public,alias:'FPC_FREEMEM'];
BEGIN
 IF FREEMEMC=NIL THEN HALT('FREEMEMC is not valid !');
 FREEMEMC(P);
 P:=NIL;
END;
PROCEDURE FREEMEM(P:POINTER;SIZE:DWORD);[public,alias:'ASMFREEMEM'];
BEGIN
 IF FREEMEMC=NIL THEN HALT('FREEMEMC is not valid !');
 FREEMEMC(P);
END;
PROCEDURE GETMEM(VAR P:POINTER;SIZE:DWORD);[public,alias:'ASMGETMEM'];[public,alias:'FPC_GETMEM'];
BEGIN
 IF GETMEMC=NIL THEN HALT('GETMEMC is not valid !');
 P:=GETMEMC(SIZE);
END;
FUNCTION HEXSTR(W,L:DWORD):STRING;
BEGIN
 HEXSTR:='';
 WHILE L>0 DO
 BEGIN
  HEXSTR:=HEXCHARS[W AND $F]+HEXSTR;
  DEC(L);
  W:=W SHR 4;
 END;
END;
FUNCTION HEXSTR(W:DWORD):STRING;
BEGIN
 HEXSTR:='';
 WHILE W>0 DO
 BEGIN
  HEXSTR:=HEXCHARS[W AND $F]+HEXSTR;
  W:=W SHR 4;
 END;
 IF HEXSTR='' THEN HEXSTR:='0';
END;
FUNCTION UPCASE(C:CHAR):CHAR;
BEGIN
 IF C IN ['a'..'z'] THEN UPCASE:=CHAR(BYTE(C)-32) ELSE UPCASE:=C;
END;
FUNCTION UPSTR(S:STRING):STRING;
VAR I:DWORD;
BEGIN
 FOR I:=1 TO BYTE(S[0]) DO
 BEGIN
  S[I]:=UPCASE(S[I]);
 END;
 UPSTR:=S;
END;
{$I ..\INCLUDE\SYSTEM\DRV.INC}
{$I ..\INCLUDE\SYSTEM\TASKS.INC}
{$I ..\INCLUDE\SYSTEM\DEBUG.INC}
{$I ..\INCLUDE\SYSTEM\MEM.INC}
{$I ..\INCLUDE\SYSTEM\PARAMS.INC}
CONST MAXUNITS=1024;
TYPE TUNITENTRY=RECORD
      INIT,FINAL:TPROCEDURE;
     END;
     TUNITTABLE=RECORD
      COUNT:DWORD;
      INITSTAT:DWORD;
      PROCS:ARRAY[1..MAXUNITS] OF TUNITENTRY;
     END;
VAR UNITTABLE:TUNITTABLE;EXTERNAL NAME 'INITFINAL';
PROCEDURE UNITFINALPROC(P:TPROCEDURE);
BEGIN
 UNITTABLE.PROCS[UNITTABLE.INITSTAT].FINAL:=P;
END;
PROCEDURE INITIALIZEUNITS;[PUBLIC,ALIAS:'FPC_INITIALIZEUNITS'];
VAR I:DWORD;
BEGIN
 DRIVERCOUNT:=1;
 { Diese Sachen mssen ganz am Anfang initalisiert werden ! }
 INITDRIVERINTERFACE;
 INITTASKSINTERFACE;
 INITDEBUGINTERFACE;
 INITMEMINTERFACE;
 COUNTPARAMETERS;
 FOR I:=1 TO UNITTABLE.COUNT DO
 BEGIN
  IF UNITTABLE.PROCS[I].INIT<>NIL THEN UNITTABLE.PROCS[I].INIT;
  UNITTABLE.INITSTAT:=I;
 END;
END;
PROCEDURE DO_EXIT;[PUBLIC,ALIAS:'FPC_DO_EXIT'];
VAR I:DWORD;
BEGIN
 GETLOCK(@DRIVERLOCK);
 DEC(DRIVERCOUNT);
 IF DRIVERCOUNT<>0 THEN
 BEGIN
  FREELOCK(@DRIVERLOCK);
  { Hier kann es zu einem Exception kommen !
    Wenn ein DRIVERCOUNT=0 mu berprft werden, ob dieser gelscht wurde !
    Bitte noch realisieren !
  }
  DESTROYPROCESS(GETPROCESSHANDLE(),NIL);
 END;
 FOR I:=UNITTABLE.COUNT DOWNTO 1 DO
 BEGIN
  IF UNITTABLE.PROCS[I].FINAL<>NIL THEN UNITTABLE.PROCS[I].FINAL;
 END;
 { Dieser Teil sollte doch besser ausgelagert werden ! (Vernderungen...)}
 SIGNALEXIT(MEMDRIVER,1);
 SIGNALEXIT(TASKSDRIVER,1);
 SIGNALEXIT(DEBUGDRIVER,1);
 DESTROYDRIVER(POINTER(PROG_BASE),PROG_SIZE,GETPROCESSHANDLE());
END;
PROCEDURE HALTTASK;
VAR I:DWORD;
BEGIN
 GETLOCK(@DRIVERLOCK);
 DEC(DRIVERCOUNT);
 IF DRIVERCOUNT<>0 THEN
 BEGIN
  { Hier das selbe Problem, siehe oben ! }
  FREELOCK(@DRIVERLOCK);
  DESTROYTASK(GETTASKHANDLE(),NIL);
 END;
 FOR I:=UNITTABLE.COUNT DOWNTO 1 DO
 BEGIN
  IF UNITTABLE.PROCS[I].FINAL<>NIL THEN UNITTABLE.PROCS[I].FINAL;
 END;
 SIGNALEXIT(MEMDRIVER,1);
 SIGNALEXIT(TASKSDRIVER,1);
 SIGNALEXIT(DEBUGDRIVER,1);
 DESTROYDRIVERTASK(POINTER(PROG_BASE),PROG_SIZE,GETTASKHANDLE());
END;
PROCEDURE HALT;
BEGIN
 DO_EXIT;
END;
PROCEDURE HALT(S:STRING);
BEGIN
 WRITELNSTR(S);
 DO_EXIT;
END;
{$I ..\..\FPINC\I386.INC}
END.
