{$I ..\INCLUDE\IRQS.DEF}
VAR HANDLERS:ARRAY[0..15] OF LONGBOOL;
    HANDLERC:ARRAY[0..15] OF DWORD;
    HANDLER:ARRAY[0..15] OF PIRQHANDLER;
    HANDLERAEOI:ARRAY[0..15] OF PIRQHANDLER;
    HANDLER_LOCK:TLOCK;
FUNCTION GETIRQ(NR:DWORD):LONGBOOL;
BEGIN
 GETLOCK(@HANDLER_LOCK);
 IF HANDLERS[NR] THEN GETIRQ:=FALSE ELSE
 BEGIN
  INC(HANDLERC[NR]);
  GETIRQ:=TRUE;
 END;
 FREELOCK(@HANDLER_LOCK);
END;
PROCEDURE FREEIRQ(NR:DWORD);
BEGIN
 GETLOCK(@HANDLER_LOCK);
 DEC(HANDLERC[NR]);
 IF HANDLERC[NR]=0 THEN HANDLERS[NR]:=FALSE;
 FREELOCK(@HANDLER_LOCK);
END;
FUNCTION GETIRQALONE(NR:DWORD):LONGBOOL;
BEGIN
 GETLOCK(@HANDLER_LOCK);
 IF HANDLERC[NR]>0 THEN GETIRQALONE:=FALSE ELSE
 BEGIN
  INC(HANDLERC[NR]);
  HANDLERS[NR]:=TRUE;
  GETIRQALONE:=TRUE;
 END;
 FREELOCK(@HANDLER_LOCK);
END;
PROCEDURE REMOVEHANDLER(IRQ:DWORD;P:PIRQHANDLER);
BEGIN
 GETLOCK(@HANDLER_LOCK);
 IF P^.LAST<>NIL THEN P^.LAST^.NEXT:=P^.NEXT ELSE HANDLER[IRQ]:=P^.NEXT;
 IF P^.NEXT<>NIL THEN P^.NEXT^.LAST:=P^.LAST;
 FREELOCK(@HANDLER_LOCK);
END;
PROCEDURE REMOVEHANDLERAEOI(IRQ:DWORD;P:PIRQHANDLER);
BEGIN
 GETLOCK(@HANDLER_LOCK);
 IF P^.LAST<>NIL THEN P^.LAST^.NEXT:=P^.NEXT ELSE HANDLERAEOI[IRQ]:=P^.NEXT;
 IF P^.NEXT<>NIL THEN P^.NEXT^.LAST:=P^.LAST;
 FREELOCK(@HANDLER_LOCK);
END;
PROCEDURE ADDHANDLER(IRQ:DWORD;P:PIRQHANDLER);
BEGIN
 GETLOCK(@HANDLER_LOCK);
 P^.NEXT:=HANDLER[IRQ];
 P^.LAST:=NIL;
 IF P^.NEXT<>NIL THEN P^.NEXT^.LAST:=P;
 HANDLER[IRQ]:=P;
 FREELOCK(@HANDLER_LOCK);
END;
PROCEDURE ADDHANDLERAEOI(IRQ:DWORD;P:PIRQHANDLER);
BEGIN
 GETLOCK(@HANDLER_LOCK);
 P^.NEXT:=HANDLERAEOI[IRQ];
 P^.LAST:=NIL;
 IF P^.NEXT<>NIL THEN P^.NEXT^.LAST:=P;
 HANDLERAEOI[IRQ]:=P;
 FREELOCK(@HANDLER_LOCK);
END;
PROCEDURE PRIMARYEOI;ASSEMBLER;
ASM
  MOV AL,020h
  OUT 020h,AL
END;
PROCEDURE SECONDARYEOI;ASSEMBLER;
ASM
  MOV AL,020h
  OUT 0A0h,AL
  OUT 020h,AL
END;
PROCEDURE CALLPRIMARYHANDLER(NR:DWORD);
VAR P:PIRQHANDLER;
    GR:DWORD;
BEGIN
 P:=HANDLER[NR];
 WHILE P<>NIL DO
 BEGIN
  P^.PROC(P^.DATA);
  P:=P^.NEXT;
 END;
 PRIMARYEOI;
 P:=HANDLERAEOI[NR];
 WHILE P<>NIL DO
 BEGIN
  P^.PROC(P^.DATA);
  P:=P^.NEXT;
 END;
END;
PROCEDURE CALLSECONDARYHANDLER(NR:DWORD);
VAR P:PIRQHANDLER;
    GR:DWORD;
BEGIN
 P:=HANDLER[NR];
 WHILE P<>NIL DO
 BEGIN
  P^.PROC(P^.DATA);
  P:=P^.NEXT;
 END;
 SECONDARYEOI;
 P:=HANDLERAEOI[NR];
 WHILE P<>NIL DO
 BEGIN
  P^.PROC(P^.DATA);
  P:=P^.NEXT;
 END;
END;
PROCEDURE HAND_IRQ0;INTERRUPT;
BEGIN
 ASM
   CLI
   MOV AX,10h
   MOV ES,AX
   MOV DS,AX
   MOV FS,AX
   MOV GS,AX
 END;
 CALLPRIMARYHANDLER(0);
END;
PROCEDURE HAND_IRQ1;INTERRUPT;
BEGIN
 ASM
   CLI
   MOV AX,10h
   MOV ES,AX
   MOV DS,AX
   MOV FS,AX
   MOV GS,AX
 END;
 CALLPRIMARYHANDLER(1);
END;
PROCEDURE HAND_IRQ2;INTERRUPT;
BEGIN
 ASM
   CLI
   MOV AX,10h
   MOV ES,AX
   MOV DS,AX
   MOV FS,AX
   MOV GS,AX
 END;
 CALLPRIMARYHANDLER(2);
END;
PROCEDURE HAND_IRQ3;INTERRUPT;
BEGIN
 ASM
   CLI
   MOV AX,10h
   MOV ES,AX
   MOV DS,AX
   MOV FS,AX
   MOV GS,AX
 END;
 CALLPRIMARYHANDLER(3);
END;
PROCEDURE HAND_IRQ4;INTERRUPT;
BEGIN
 ASM
   CLI
   MOV AX,10h
   MOV ES,AX
   MOV DS,AX
   MOV FS,AX
   MOV GS,AX
 END;
 CALLPRIMARYHANDLER(4);
END;
PROCEDURE HAND_IRQ5;INTERRUPT;
BEGIN
 ASM
   CLI
   MOV AX,10h
   MOV ES,AX
   MOV DS,AX
   MOV FS,AX
   MOV GS,AX
 END;
 CALLPRIMARYHANDLER(5);
END;
PROCEDURE HAND_IRQ6;INTERRUPT;
BEGIN
 ASM
   CLI
   MOV AX,10h
   MOV ES,AX
   MOV DS,AX
   MOV FS,AX
   MOV GS,AX
 END;
 CALLPRIMARYHANDLER(6);
END;
PROCEDURE HAND_IRQ7;INTERRUPT;
BEGIN
 ASM
   CLI
   MOV AX,10h
   MOV ES,AX
   MOV DS,AX
   MOV FS,AX
   MOV GS,AX
 END;
 CALLPRIMARYHANDLER(7);
END;
PROCEDURE HAND_IRQ8;INTERRUPT;
BEGIN
 ASM
   CLI
   MOV AX,10h
   MOV ES,AX
   MOV DS,AX
   MOV FS,AX
   MOV GS,AX
 END;
 CALLSECONDARYHANDLER(8);
END;
PROCEDURE HAND_IRQ9;INTERRUPT;
BEGIN
 ASM
   CLI
   MOV AX,10h
   MOV ES,AX
   MOV DS,AX
   MOV FS,AX
   MOV GS,AX
 END;
 CALLSECONDARYHANDLER(9);
END;
PROCEDURE HAND_IRQA;INTERRUPT;
BEGIN
 ASM
   CLI
   MOV AX,10h
   MOV ES,AX
   MOV DS,AX
   MOV FS,AX
   MOV GS,AX
 END;
 CALLSECONDARYHANDLER(10);
END;
PROCEDURE HAND_IRQB;INTERRUPT;
BEGIN
 ASM
   CLI
   MOV AX,10h
   MOV ES,AX
   MOV DS,AX
   MOV FS,AX
   MOV GS,AX
 END;
 CALLSECONDARYHANDLER(11);
END;
PROCEDURE HAND_IRQC;INTERRUPT;
BEGIN
 ASM
   CLI
   MOV AX,10h
   MOV ES,AX
   MOV DS,AX
   MOV FS,AX
   MOV GS,AX
 END;
 CALLSECONDARYHANDLER(12);
END;
PROCEDURE HAND_IRQD;INTERRUPT;
BEGIN
 ASM
   CLI
   MOV AX,10h
   MOV ES,AX
   MOV DS,AX
   MOV FS,AX
   MOV GS,AX
 END;
 CALLSECONDARYHANDLER(13);
END;
PROCEDURE HAND_IRQE;INTERRUPT;
BEGIN
 ASM
   CLI
   MOV AX,10h
   MOV ES,AX
   MOV DS,AX
   MOV FS,AX
   MOV GS,AX
 END;
 CALLSECONDARYHANDLER(14);
END;
PROCEDURE HAND_IRQF;INTERRUPT;
BEGIN
 ASM
   CLI
   MOV AX,10h
   MOV ES,AX
   MOV DS,AX
   MOV FS,AX
   MOV GS,AX
 END;
 CALLSECONDARYHANDLER(15);
END;
VAR IRQS_USERS:DWORD;
    IRQS_SHUTDOWNTASK:POINTER;
    IRQS_SHUTDOWNMODE:LONGBOOL;
PROCEDURE DEINITIALIZEIRQSDRV;
BEGIN
 WRITELNSTR('IRQS UNI.');
 IRQS_SHUTDOWNTASK:=GETTASKHANDLE();
 IRQS_SHUTDOWNMODE:=TRUE;
 IF IRQS_USERS<>0 THEN DISABLETASK(IRQS_SHUTDOWNTASK);
 REMOVEPORTINTV(@PORTINTV1);
 REMOVEPORTINTV(@PORTINTV2);
 WRITELNSTR('IRQS DONE.');
 SIGNALSHUTDOWNOK;
 HALT;
END;
PROCEDURE FREEIRQSPROT(NR:DWORD);
BEGIN
 CASE NR OF
  1:
  BEGIN
   DECATOM(@IRQS_USERS);
   IF IRQS_SHUTDOWNMODE AND (IRQS_USERS=0) THEN ENABLETASK(IRQS_SHUTDOWNTASK);
  END;
 END;
END;
CONST IRQS_PROT0:ARRAY[0..1] OF POINTER=(
       @DEINITIALIZEIRQSDRV,
       @FREEIRQSPROT);
CONST IRQS_PROT1:ARRAY[0..8] OF POINTER=(
       @ADDHANDLER,
       @ADDHANDLERAEOI,
       @REMOVEHANDLER,
       @REMOVEHANDLERAEOI,
       @ENABLEIRQ,
       @DISABLEIRQ,
       @GETIRQ,
       @GETIRQALONE,
       @FREEIRQ);
FUNCTION DOCK_IRQS(PR:DWORD):POINTER;
BEGIN
 CASE PR OF
  0:DOCK_IRQS:=@IRQS_PROT0;
  1:
  BEGIN
   DOCK_IRQS:=@IRQS_PROT1;
   INCATOM(@IRQS_USERS);
  END;
  ELSE DOCK_IRQS:=NIL;
 END;
END;
CONST DRVIRQS:TDRIVER=(NEXT:NIL;LAST:NIL;TYP:5;ID:0;GETPROT:@DOCK_IRQS;
                       DESC:'Irqdriver (1)');
