PROGRAM IRQS;
{$ASMMODE INTEL}
USES PORTS;
{$I HARDWARE.INC}
{$I IRQS.INC}
TYPE PEXCEPTIONDATA=^TEXCEPTIONDATA;
     TEXCEPTIONDATA=RECORD
      NR,ERR:DWORD;
      PROCESS,TASK:DWORD;
      EAX,ECX,EDX,EBX,ESI,EDI,EBP:DWORD;
      ES,DS,FS,GS:DWORD;
      CR0,CR2,CR3:DWORD;
      FLAGS:DWORD;
      CALLSEG:DWORD;
      CALLOFS:DWORD;
      STACKP:DWORD;
     END;
TYPE PEXCEPTIONHANDLER=^TEXCEPTIONHANDLER;
     TEXCEPTIONHANDLER=RECORD
      NEXT,LAST:PEXCEPTIONHANDLER;
      PROC:FUNCTION(P:PEXCEPTIONDATA):LONGBOOL;
     END;
VAR FIRSTEXCHANDLER:PEXCEPTIONHANDLER;
    EXC_LOCK:TLOCK;
    EXC_READ:TREADSTAT;
PROCEDURE REMOVEEXCEPTIONHANDLER(P:PEXCEPTIONHANDLER);
BEGIN
 GETLOCK(@EXC_LOCK);
 IF P^.LAST<>NIL THEN P^.LAST^.NEXT:=P^.NEXT ELSE FIRSTEXCHANDLER:=P^.NEXT;
 IF P^.NEXT<>NIL THEN P^.NEXT^.LAST:=P^.LAST;
 WAITFORREADCYCL(@EXC_READ);
 FREELOCK(@EXC_LOCK);
END;
PROCEDURE ADDEXCEPTIONHANDLER(P:PEXCEPTIONHANDLER);
BEGIN
 GETLOCK(@EXC_LOCK);
 P^.NEXT:=FIRSTEXCHANDLER;
 P^.LAST:=NIL;
 IF FIRSTEXCHANDLER<>NIL THEN FIRSTEXCHANDLER^.LAST:=P;
 FIRSTEXCHANDLER:=P;
 FREELOCK(@EXC_LOCK);
END;
FUNCTION CALLEXCEPTIONHANDLER(D:PEXCEPTIONDATA):LONGBOOL;
VAR P:PEXCEPTIONHANDLER;
    GR:DWORD;
BEGIN
 GR:=STARTREAD(@EXC_READ);
 P:=FIRSTEXCHANDLER;
 WHILE P<>NIL DO
 BEGIN
  CALLEXCEPTIONHANDLER:=P^.PROC(D);
  IF CALLEXCEPTIONHANDLER THEN EXIT;
  P:=P^.NEXT;
 END;
 STOPREAD(@EXC_READ,GR);
 CALLEXCEPTIONHANDLER:=FALSE;
END;
PROCEDURE DISPLAYEXCEPTION(P:PEXCEPTIONDATA);
BEGIN
 WRITESTR('ͻ');
 WRITESTR(' Exception Nr.'+HEXSTR(P^.NR,8)+' in Process '+HEXSTR(P^.PROCESS,8)+' and Task '+HEXSTR(P^.TASK,8)+'                  ');
 WRITESTR('  Error number : '+HEXSTR(P^.ERR,8)+'                                                     ');
 WRITESTR('Ķ');
 WRITESTR(' Registers :                                                                  ');
 WRITESTR('  EAX : '+HEXSTR(P^.EAX,8)+'  EBX : '+HEXSTR(P^.EBX,8)+'  ECX : '+HEXSTR(P^.ECX,8)+'  EDX : '+HEXSTR(P^.EDX,8)+'              ');
 WRITESTR('  ESI : '+HEXSTR(P^.ESI,8)+'  EDI : '+HEXSTR(P^.EDI,8)+'  EBP : '+HEXSTR(P^.EBP,8)+'                              ');
 WRITESTR('Ķ');
 WRITESTR(' Segment Registers :                                                          ');
 WRITESTR('  ES  : '+HEXSTR(P^.ES,8)+'  DS  : '+HEXSTR(P^.DS,8)+'  FS  : '+HEXSTR(P^.FS,8)+'  GS  : '+HEXSTR(P^.GS,8)+'              ');
 WRITESTR('Ķ');
 WRITESTR(' Control Registers :                                                          ');
 WRITESTR('  CR0 : '+HEXSTR(P^.CR0,8)+'  CR2 : '+HEXSTR(P^.CR2,8)+'  CR3 : '+HEXSTR(P^.CR3,8)+'                              ');
 WRITESTR('Ķ');
 WRITESTR(' Flags : '+HEXSTR(P^.FLAGS,8)+'                                                             ');
 WRITESTR('Ķ');
 WRITESTR(' Aufrufer : '+HEXSTR(P^.CALLSEG,8)+':'+HEXSTR(P^.CALLOFS,8)+' ('+HEXSTR(P^.STACKP,8)+')                                      ');
 WRITESTR('Ķ');
 WRITESTR(' Debug :                                                                      ');
 WRITESTR('  000 : '+HEXSTR(GETDEBUGFLAG(0),8)+'  001 : '+HEXSTR(GETDEBUGFLAG(1),8)+'  002 : '+HEXSTR(GETDEBUGFLAG(2),8)+'  003 : '+HEXSTR(GETDEBUGFLAG(3),8)+'              ');
 WRITESTR('  004 : '+HEXSTR(GETDEBUGFLAG(4),8)+'  005 : '+HEXSTR(GETDEBUGFLAG(5),8)+'  006 : '+HEXSTR(GETDEBUGFLAG(6),8)+'  007 : '+HEXSTR(GETDEBUGFLAG(7),8)+'              ');
 WRITESTR('  008 : '+HEXSTR(GETDEBUGFLAG(8),8)+'  009 : '+HEXSTR(GETDEBUGFLAG(9),8)+'  010 : '+HEXSTR(GETDEBUGFLAG(10),8)+'  011 : '+HEXSTR(GETDEBUGFLAG(11),8)+'              ');
 WRITESTR('  012 : '+HEXSTR(GETDEBUGFLAG(12),8)+'  013 : '+HEXSTR(GETDEBUGFLAG(13),8)+'  014 : '+HEXSTR(GETDEBUGFLAG(14),8)+'  015 : '+HEXSTR(GETDEBUGFLAG(15),8)+'              ');
 WRITESTR('ͼ');
END;
PROCEDURE HANDLEEXC(NR:DWORD;ERRC:LONGBOOL);
VAR EXCEPTIONDATA:TEXCEPTIONDATA;
    P:PDWORDARRAY;
BEGIN
 ASM
   PUSH ES
   PUSH DS
   PUSH FS
   PUSH GS
   PUSHAD
   MOV EAX,CR0
   PUSH EAX
   MOV EAX,CR2   
   PUSH EAX
   MOV EAX,CR3
   PUSH EAX
   MOV AX,10h
   MOV DS,AX
   MOV ES,AX
   MOV FS,AX
   MOV GS,AX
   MOV P,ESP
 END;
 EXCEPTIONDATA.NR:=NR;
 EXCEPTIONDATA.PROCESS:=DWORD(GETPROCESSHANDLE());
 EXCEPTIONDATA.TASK:=DWORD(GETTASKHANDLE());
 EXCEPTIONDATA.ES:=P^[14];
 EXCEPTIONDATA.DS:=P^[13];
 EXCEPTIONDATA.FS:=P^[12];
 EXCEPTIONDATA.GS:=P^[11];
 EXCEPTIONDATA.EAX:=P^[10];
 EXCEPTIONDATA.ECX:=P^[9];
 EXCEPTIONDATA.EDX:=P^[8];
 EXCEPTIONDATA.EBX:=P^[7];
 EXCEPTIONDATA.ESI:=P^[4];
 EXCEPTIONDATA.EDI:=P^[3];
 EXCEPTIONDATA.EBP:=P^[38];
 EXCEPTIONDATA.CR0:=P^[2];
 EXCEPTIONDATA.CR2:=P^[1];
 EXCEPTIONDATA.CR3:=P^[0];
 IF ERRC THEN
 BEGIN
  EXCEPTIONDATA.ERR:=P^[42];
  EXCEPTIONDATA.CALLOFS:=P^[43];
  EXCEPTIONDATA.CALLSEG:=P^[44];
  EXCEPTIONDATA.FLAGS:=P^[45];
  EXCEPTIONDATA.STACKP:=DWORD(P)+172;
 END                       
 ELSE
 BEGIN
  EXCEPTIONDATA.ERR:=0;
  EXCEPTIONDATA.CALLOFS:=P^[42];
  EXCEPTIONDATA.CALLSEG:=P^[43];
  EXCEPTIONDATA.FLAGS:=P^[44];
  EXCEPTIONDATA.STACKP:=DWORD(P)+168;
 END;
 IF NOT CALLEXCEPTIONHANDLER(@EXCEPTIONDATA) THEN
 BEGIN
{  EXPLSHUTDOWN;}
  DISPLAYEXCEPTION(@EXCEPTIONDATA);
  DESTROYTASK(GETTASKHANDLE(),NIL);
 END;
 P^[10]:=EXCEPTIONDATA.EAX;
 ASM
   ADD ESP,12
   POPAD
   POP GS
   POP FS
   POP DS
   POP ES
 END;
END;
PROCEDURE EXCEPTION0;ASSEMBLER;
ASM
  PUSH DWORD 0
  PUSH DWORD 0
  CALL HANDLEEXC
  IRET
END;
PROCEDURE EXCEPTION1;ASSEMBLER;
ASM
  PUSH DWORD 0
  PUSH DWORD 1
  CALL HANDLEEXC
  IRET
END;
PROCEDURE EXCEPTION2;ASSEMBLER;
ASM
  PUSH DWORD 0
  PUSH DWORD 2
  CALL HANDLEEXC
  IRET
END;
PROCEDURE EXCEPTION3;ASSEMBLER;
ASM
  PUSH DWORD 0
  PUSH DWORD 3
  CALL HANDLEEXC
  IRET
END;
PROCEDURE EXCEPTION4;ASSEMBLER;
ASM
  PUSH DWORD 0
  PUSH DWORD 4
  CALL HANDLEEXC
  IRET
END;
PROCEDURE EXCEPTION5;ASSEMBLER;
ASM
  PUSH DWORD 0
  PUSH DWORD 5
  CALL HANDLEEXC
  IRET
END;
PROCEDURE EXCEPTION6;ASSEMBLER;
ASM
  PUSH DWORD 0
  PUSH DWORD 6
  CALL HANDLEEXC
  IRET
END;
PROCEDURE EXCEPTION7;ASSEMBLER;
ASM
  PUSH DWORD 0
  PUSH DWORD 7
  CALL HANDLEEXC
  IRET
END;
PROCEDURE EXCEPTION8;ASSEMBLER;
ASM
  PUSH DWORD 0
  PUSH DWORD 8
  CALL HANDLEEXC
  IRET
END;
PROCEDURE EXCEPTION9;ASSEMBLER;
ASM
  PUSH DWORD 0
  PUSH DWORD 9
  CALL HANDLEEXC
  IRET
END;
PROCEDURE EXCEPTIONA;ASSEMBLER;
ASM
  PUSH DWORD 0
  PUSH DWORD 10
  CALL HANDLEEXC
  IRET
END;
PROCEDURE EXCEPTIONB;ASSEMBLER;
ASM
  PUSH DWORD 0
  PUSH DWORD 11
  CALL HANDLEEXC
  IRET
END;
PROCEDURE EXCEPTIONC;ASSEMBLER;
ASM
  PUSH DWORD 0
  PUSH DWORD 12
  CALL HANDLEEXC
  IRET
END;
PROCEDURE EXCEPTIOND;ASSEMBLER;
ASM
  PUSH DWORD 1
  PUSH DWORD 13
  CALL HANDLEEXC
  ADD ESP,4
  IRET
END;
PROCEDURE EXCEPTIONE;ASSEMBLER;
ASM
  PUSH DWORD 1
  PUSH DWORD 14
  CALL HANDLEEXC
  IRET
END;
PROCEDURE EXCEPTIONF;ASSEMBLER;
ASM
  PUSH DWORD 0
  PUSH DWORD 15
  CALL HANDLEEXC
  IRET
END;
PROCEDURE HAND_SOFTFF;ASSEMBLER;
ASM
  PUSH DS
  PUSH ES
  PUSH FS
  PUSH GS
  PUSHAD
  MOV AX,10h
  MOV DS,AX
  MOV ES,AX
  MOV FS,AX
  MOV GS,AX
  CALL [SCHEDULE]
  POPAD
  POP GS
  POP FS
  POP ES
  POP DS
  IRET
END;
PROCEDURE DEINITIALIZEEXCSDRV;
BEGIN
 WRITELNSTR('EXCS DONE.');
 SIGNALSHUTDOWNOK;
 HALT;
END;
PROCEDURE FREEEXCSPROT(NR:DWORD);
BEGIN
 CASE NR OF
  1:
  BEGIN
   DECATOM(@IRQS_USERS);
   IF IRQS_SHUTDOWNMODE AND (IRQS_USERS=0) THEN ENABLETASK(IRQS_SHUTDOWNTASK);
  END;
 END;
END;
CONST EXCS_PROT0:ARRAY[0..1] OF POINTER=(
       @DEINITIALIZEEXCSDRV,
       @FREEEXCSPROT);
CONST EXCS_PROT1:ARRAY[0..1] OF POINTER=(
       @ADDEXCEPTIONHANDLER,
       @REMOVEEXCEPTIONHANDLER);
FUNCTION DOCK_EXCS(PR:DWORD):POINTER;
BEGIN
 CASE PR OF
  0:DOCK_EXCS:=@EXCS_PROT0;
  1:
  BEGIN
   INCATOM(@IRQS_USERS);
   DOCK_EXCS:=@EXCS_PROT1;
  END;
  ELSE DOCK_EXCS:=NIL;
 END;
END;
CONST DRVEXCS:TDRIVER=(NEXT:NIL;LAST:NIL;TYP:9;ID:0;GETPROT:@DOCK_EXCS;
                       DESC:'Exceptionsdriver (1)');
BEGIN
 WRITELNSTR('IRQS ('+HEXSTR(DWORD(GETPROCESSHANDLE())));
 STARTDRIVERINITIALIZATION;
 IF NOT ADDPORTINTV(@PORTINTV1) THEN HALT('Portarea $20..$21 allready allocated->exit');
 IF NOT ADDPORTINTV(@PORTINTV2) THEN
 BEGIN
  REMOVEPORTINTV(@PORTINTV1);
  HALT('Portarea $A0..$A1 allready allocated->exit');
  STOPDRIVERINITIALIZATION;
 END;
 SETIRQSTO2028;
 IDTP.LIMIT:=256*8-1;
 IDTP.BASE:=@IDT; 
 SETIDT($00,@EXCEPTION0);
 SETIDT($01,@EXCEPTION1);
 SETIDT($02,@EXCEPTION2);
 SETIDT($03,@EXCEPTION3);
 SETIDT($04,@EXCEPTION4);
 SETIDT($05,@EXCEPTION5);
 SETIDT($06,@EXCEPTION6);
 SETIDT($07,@EXCEPTION7);
 SETIDT($08,@EXCEPTION8);
 SETIDT($09,@EXCEPTION9);
 SETIDT($0A,@EXCEPTIONA);
 SETIDT($0B,@EXCEPTIONB);
 SETIDT($0C,@EXCEPTIONC);
 SETIDT($0D,@EXCEPTIOND);
 SETIDT($0E,@EXCEPTIONE);
 SETIDT($0F,@EXCEPTIONF);
 SETIDT($20,@HAND_IRQ0);
 SETIDT($21,@HAND_IRQ1);
 SETIDT($22,@HAND_IRQ2);
 SETIDT($23,@HAND_IRQ3);
 SETIDT($24,@HAND_IRQ4);
 SETIDT($25,@HAND_IRQ5);
 SETIDT($26,@HAND_IRQ6);
 SETIDT($27,@HAND_IRQ7);
 SETIDT($28,@HAND_IRQ8);
 SETIDT($29,@HAND_IRQ9);
 SETIDT($2A,@HAND_IRQA);
 SETIDT($2B,@HAND_IRQB);
 SETIDT($2C,@HAND_IRQC);
 SETIDT($2D,@HAND_IRQD);
 SETIDT($2E,@HAND_IRQE);
 SETIDT($2F,@HAND_IRQF);
 SETIDT3($FF,@HAND_SOFTFF);
 ASM
   DB 00Fh,001h,01Dh
   DD IDTP
   XOR EAX,EAX
   OUT 70h,AL
 END;
 ADDDRIVER(@DRVIRQS);
 ADDDRIVER(@DRVEXCS);
 STOPDRIVERINITIALIZATION;
END.
