PROCEDURE MINIMALDELAY;ASSEMBLER;
ASM
  MOV ESI,100
 @LP:
  DEC ESI
  JNE @LP
END;
PROCEDURE EMPTY8042;ASSEMBLER;
ASM
  MOV ECX,0FFFFFFh
 @LP:
  DEC ECX
  JZ @EXT
  CALL MINIMALDELAY
  IN AL,64h
  TEST AL,1
  JZ @NO
  CALL MINIMALDELAY
  IN AL,60h
  JMP @LP
 @NO:
  TEST AL,2
  JNZ @LP
 @EXT:
END;
PROCEDURE RESETKEYB;ASSEMBLER;
ASM
  CALL EMPTY8042
  MOV AL,0FFh
  OUT 60h,AL
  CALL EMPTY8042
END;
PROCEDURE SETILEDS(SCROLL,NUM,CAPS:BOOLEAN);ASSEMBLER;
ASM
  CALL EMPTY8042
  MOV AL,0EDh
  OUT 60h,AL
  MOV AL,[SCROLL]
  AND AL,1
  MOV BL,[NUM]
  AND BL,1
  SHL BL,1
  OR AL,BL
  MOV BL,[CAPS]
  AND BL,1
  SHL BL,2
  OR AL,BL
  OUT 60h,AL
  CALL EMPTY8042
END;
PROCEDURE WRITENOR(C:DWORD);ASSEMBLER;
ASM
 @RDYLP:
  IN AL,64h
  AND AL,2
  JNZ @RDYLP
  MOV EAX,C
  OUT 60h,AL
END;
PROCEDURE WRITECMD(C:DWORD);ASSEMBLER;
ASM
 @RDYLP:
  IN AL,64h
  AND AL,2
  JNZ @RDYLP
  MOV EAX,C
  OUT 64h,AL
END;
PROCEDURE WRITEMOUSE(C:DWORD);ASSEMBLER;
ASM
  PUSH DWORD 0D4h
  CALL WRITECMD  
  PUSH DWORD PTR [C]
  CALL WRITENOR
END;
FUNCTION READNOR:BYTE;ASSEMBLER;
ASM
  MOV ECX,0FFFFh
 @LP:
  IN AL,64h
  TEST AL,1
  JZ @LPD
  AND AL,0C0h
  JNZ @LPD
  IN AL,60h
  RET
 @LPD:
  DEC ECX
  JNE @LP
  MOV AL,255
END;
FUNCTION DETECTMOUSE:BOOLEAN;ASSEMBLER;
ASM
  CALL EMPTY8042
  PUSH DWORD 0A8h
  CALL WRITECMD
  CALL EMPTY8042
  PUSH DWORD 0F2h
  CALL WRITEMOUSE
  CALL READNOR
  CMP AL,255
  JZ @NOMOUSE
  OR AL,AL
  JZ @MOUSE
  CALL READNOR
  OR AL,AL
  JNZ @NOMOUSE
 @MOUSE:
  CALL EMPTY8042
  MOV EAX,1
  RET
 @NOMOUSE:
  CALL EMPTY8042
  XOR EAX,EAX
END;
