;MAIN KBD\KBD.ASM
%INCLUDE "SYS.INC"
%INCLUDE "USP.INC"
%INCLUDE "GDT.INC"
%INCLUDE "MEM.INC"
%INCLUDE "IRQS.INC"
%INCLUDE "PORTS.INC"
%INCLUDE "PAR.INC"
%INCLUDE "TIMER.INC"
%INCLUDE "KBD\KBD.KCO"
%INCLUDE "KBD\KBD.CH0"
%INCLUDE "KBD\KBD.CH1"
%INCLUDE "KBD\KBD.CH2"
%INCLUDE "KBD\KBD.CH3"
%INCLUDE "KBD\MOUSE.INC"
KBD_TIMERDESC DD 0,0
              DD KBD_TIMER
              DD 0
              DD 0
              DD 1
KBD_TCO DD 0
KBD_TIMER:
  MOV DS,[CS:SYS_DATA]
  INC DWORD [KBD_TCO]
  RETF
KBD_NAME TIMES 64 DD 0
KBD_PORTS DD 0,0
          DD 60h
          DD 64h
;Ŀ
; KBD_ATAB                                                                  
;  Funktion       : Gibt die Tabelle der aktuellen Tastencodes an.          
;
KBD_ATAB DD 0
KBD_BUFFER TIMES 256 DD 0
KBD_READPOS DD 0
KBD_WRITEPOS DD 0
KBD_DRV DD 0,0
        DD 00000008h
KBD_DRVCALLP DD 0
KBD_CALL00000001P DD 0
KBD_CALL00000001_FN DD KBD_GETKEY
                    DD KBD_ADDKEY
                    DD KBD_GETCHARKEY
;ͻ
; KBD_SETILEDS                                                              
;  Funktion       : Setzt die LEDs nach KBD_CHARTAB oder KBD_EKBDLEDS.      
;ͼ
KBD_SETILEDS:
  IRQS_DISABLE 1
  XOR EAX,EAX
  MOV [KBD_TCO],EAX
 KBD_SETILEDS_WAIT:
  CMP [KBD_TCO],DWORD 10
  JNB KBD_SETILEDS_WAITEND
  USP_SWITCHUSER
  USP_SWITCHTASK
  JMP KBD_SETILEDS_WAIT
 KBD_SETILEDS_WAITEND:
  CALL KBD_EMPTY8042
  MOV AL,0EDh
  OUT 60h,AL
  MOV AL,[KBD_SCROLL]
  AND AL,1
  MOV BL,[KBD_NUM]
  AND BL,1
  SHL BL,1
  OR AL,BL
  MOV BL,[KBD_CAPS]
  AND BL,1
  SHL BL,2
  OR AL,BL
  OUT 60h,AL
  CALL KBD_EMPTY8042
  IRQS_ENABLE 1
  RET
;ͻ
; KBD_ADDKEY                                                                
;  Funktion       : Schreibt ein Tastaturcode in den Tastaturpuffer.        
;  Parameter      : EDX=Zeichen                                             
;ͼ
KBD_ADDKEY:
  PUSHFD
  CLI
  MOV EBX,[KBD_WRITEPOS]
  MOV ESI,[KBD_READPOS]
  INC BL
  CMP ESI,EBX
  JZ KBD_ADDKEY_FULL
  DEC BL
  MOV [KBD_BUFFER+EBX*4],EDX
  INC BL
  MOV [KBD_WRITEPOS],EBX
 KBD_ADDKEY_FULL:
  POPFD
  RET
;ͻ
; KBD_GETKEY                                                                
;  Funktion       : Liest ein Tastaturcode aus dem Tastaturpuffer.          
;  Rckgabewerte  : EDX=Tastaturcode                                        
;  Anmerkung      : Unbedingt gegen Doppelnutzung sichern !!!               
;ͼ
KBD_GETKEY:
  MOV EBX,[KBD_READPOS]
  MOV ESI,[KBD_WRITEPOS]
  CMP EBX,ESI
  JZ KBD_GETKEY_EMPTY
  MOV EDX,[KBD_BUFFER+EBX*4]
  INC BL
  MOV [KBD_READPOS],EBX
  RET
 KBD_GETKEY_EMPTY:
  MOV EDX,0FFFFFFFFh
  RET
%DEFINE KBD_CHARTAB_SHIFT   0000000010000000b
%DEFINE KBD_CHARTAB_NSHIFT  1111111101111111b
%DEFINE KBD_CHARTAB_ALTGR   0000000100000000b
%DEFINE KBD_CHARTAB_NALTGR  1111111011111111b
KBD_CHARTAB DD 0
KBD_NUM DB 0
KBD_CAPS DB 0
KBD_SCROLL DB 0
;ͻ
; KBD_GETCHARKEY                                                            
;  Funktion       : Liest ein Tastaturcode aus dem Tastaturpuffer und       
;                   wandelt diesen in ein Zeichen um.                       
; Rckgabewerte   : EDX=Zeichen                                             
;ͼ
KBD_GETCHARKEY:
  CALL KBD_GETKEY
  CMP EDX,00000100h
  JNB KBD_GETCHARKEY_DIFCODE
  MOVZX EDX,DX
  ADD EDX,[KBD_CHARTAB]
  MOV EDX,[KBD_256Z0+EDX*4]
  RET
 KBD_GETCHARKEY_DIFCODE:
  CMP EDX,00010004h
  JZ KBD_GETCHARKEY_SHIFTON
  CMP EDX,80010004h
  JZ KBD_GETCHARKEY_SHIFTOFF
  CMP EDX,00010006h
  JZ NEAR KBD_GETCHARKEY_CAPSSW
  CMP EDX,0001000Ah
  JZ KBD_GETCHARKEY_ALTGRON
  CMP EDX,8001000Ah
  JZ KBD_GETCHARKEY_ALTGROFF
  CMP EDX,0001000Bh
  JZ KBD_GETCHARKEY_NUMSW
  CMP EDX,0001000Ch
  JZ KBD_GETCHARKEY_SCROLLSW
  RET
 KBD_GETCHARKEY_SCROLLSW:
  NOT BYTE [KBD_SCROLL]
  PUSH EDX
  CALL KBD_SETILEDS
  POP EDX
  RET
 KBD_GETCHARKEY_NUMSW:
  NOT BYTE [KBD_NUM]
  PUSH EDX
  CALL KBD_SETILEDS
  POP EDX
  RET
 KBD_GETCHARKEY_ALTGRON:
  OR [KBD_CHARTAB],DWORD KBD_CHARTAB_ALTGR 
  RET
 KBD_GETCHARKEY_ALTGROFF:
  AND [KBD_CHARTAB],DWORD KBD_CHARTAB_NALTGR
  RET
 KBD_GETCHARKEY_SHIFTON:
  OR [KBD_CHARTAB],DWORD KBD_CHARTAB_SHIFT
  XOR AL,AL
  MOV [KBD_CAPS],AL
  PUSH EDX
  CALL KBD_SETILEDS
  POP EDX
  RET
 KBD_GETCHARKEY_SHIFTOFF:
  AND [KBD_CHARTAB],DWORD KBD_CHARTAB_NSHIFT
  XOR AL,AL
  MOV [KBD_CAPS],AL
  PUSH EDX
  CALL KBD_SETILEDS
  POP EDX
  RET
 KBD_GETCHARKEY_CAPSSW:
  XOR EAX,EAX
  MOV AL,[KBD_CAPS]
  XOR AL,00000001b
  MOV [KBD_CAPS],AL
  SHL EAX,7
  AND [KBD_CHARTAB],DWORD KBD_CHARTAB_NSHIFT
  OR [KBD_CHARTAB],EAX
  PUSH EDX
  CALL KBD_SETILEDS
  POP EDX
  RET
KBD_CALL00000001:
  CMP EDX,00000004h
  JA KBD_CALL00000001_EXT
  PUSH DS
  PUSH DWORD [CS:SYS_DATA]
  POP DS
  CALL [KBD_CALL00000001_FN+EDX*4]
  POP DS
 KBD_CALL00000001_EXT:
  RETF
KBD_DRVCALL_FN DD KBD_DRVCALL00000000
               DD KBD_DRVCALL00000001
               DD KBD_DRVCALL00000002
               DD KBD_DRVCALLXXXXXXXX
               DD KBD_DRVCALLXXXXXXXX
               DD KBD_DRVCALLXXXXXXXX
KBD_DRVCALL00000000:
  PORTS_DONE
  SYS_SIGNDONE
  RET
KBD_DRVCALLXXXXXXXX:
  MOV EAX,1
  RET
KBD_DRVCALL00000002:
  MOV ESI,KBD_NAME
  ADD ESI,[SYS_BASE]
  RET
KBD_DRVCALL00000001:
  CMP EAX,00000001h
  JZ KBD_DRVCALL00000001_1
  XOR EAX,EAX
  RET
 KBD_DRVCALL00000001_1:
  MOV EAX,[KBD_CALL00000001P]
  RET
KBD_DRVCALL:
  CMP EDX,00000005h
  JA KBD_DRVCALL_EXT
  PUSH DS
  PUSH DWORD [CS:SYS_DATA]
  POP DS
  CALL [KBD_DRVCALL_FN+EDX*4]
  POP DS
 KBD_DRVCALL_EXT:
  RETF
KBD_DELAY:
  JMP KBD_DELAY_P1             ; 
 KBD_DELAY_P1:                 ;  Ein kleines bisschen Zeit vertun...
  JMP KBD_DELAY_P2             ; 
 KBD_DELAY_P2:                 ; 
  JMP KBD_DELAY_P3             ; 
 KBD_DELAY_P3:                 ; 
  RET                          ; Fertig ?
KBD_EMPTY8042:
  PUSH ECX
  MOV ECX,0FFFFFFh
 KBD_EMPTY8042_LP:
  DEC ECX
  JZ KBD_EMPTY8042_EXT
  CALL KBD_DELAY
  IN AL,64h
  TEST AL,1
  JZ KBD_EMPTY8042_NO
  CALL KBD_DELAY
  IN AL,60h
  JMP KBD_EMPTY8042_LP
 KBD_EMPTY8042_NO:
  TEST AL,2
  JNZ KBD_EMPTY8042_LP
 KBD_EMPTY8042_EXT:
  POP ECX
  RET
KBD_RESET:
  CALL KBD_EMPTY8042
  MOV AL,0FFh
  OUT 60h,AL
  CALL KBD_EMPTY8042
  RET
KBD_DESC DD 0,0
         DD KBD_HANDLER
         DD 0
KBD_HANDLER:
  MOV DS,[CS:SYS_DATA]  
  IN AL,60h
  CMP AL,225
  JZ KBD_HANDLER_SHUTDOWN
  XOR EDX,EDX
  MOV DL,AL
  MOV EDI,[KBD_ATAB]
  SHL EDI,11
  SHL EDX,3
  ADD EDI,EDX
  ADD EDI,KBD_TAB0
  MOV EAX,[EDI]
  TEST EAX,1
  JZ KBD_HANDLER_NADD
  PUSH EAX
  MOV EDX,[EDI+4]
  CALL KBD_ADDKEY
  POP EAX
 KBD_HANDLER_NADD:
  SHR EAX,16
  MOV [KBD_ATAB],EAX
  RETF
 KBD_HANDLER_SHUTDOWN:
  SYS_SHUTDOWN
KBD_WRITECMD:
  PUSH AX
 KBD_WRITECMD_RDYLP:
  IN AL,64h
  AND AL,2
  JNZ KBD_WRITECMD_RDYLP
  POP AX
  OUT 64h,AL
  RET
KBD_WRITE:
  PUSH AX
 KBD_WRITE_RDYLP:
  IN AL,64h
  AND AL,2
  JNZ KBD_WRITE_RDYLP
  POP AX
  OUT 60h,AL
  RET
KBD_READ:
  MOV ECX,0FFFFh
 KBD_READ_LP:
  IN AL,64h
  TEST AL,1
  JZ KBD_READ_LPD
  AND AL,0C0h
  JNZ KBD_READ_LPD
  IN AL,60h
  RET
 KBD_READ_LPD:
  DEC ECX
  JNE KBD_READ_LP
  MOV AL,255
  RET
DRV_ENTRY:
  SYS_INIT
  USP_INIT
  GDT_INIT
  MEM_INIT
  IRQS_INIT
  PORTS_INIT
  PAR_INIT
  TIMER_INIT
  TIMER_ADD KBD_TIMERDESC
  PAR_SEARCHDRVNAME 00000008h,00000000h,KBD_NAME
  PAR_SEARCHDRVNAME 00000009h,00000000h,MOUSE_NAME
  PORTS_GET KBD_PORTS
  IRQS_DISABLE 1
;  CALL KBD_RESET               ; Tastatur wird nur zurckgesetzt.
  IRQS_ADDHAND 1,KBD_DESC
  IRQS_ENABLE 1
  GDT_ALLOCCALLGT0 [SYS_CODE],KBD_DRVCALL,[KBD_DRVCALLP]
  GDT_ALLOCCALLGT0 [SYS_CODE],KBD_CALL00000001,[KBD_CALL00000001P]
  SYS_ADDDRV KBD_DRV           ; Treiber zur liste hinzufgen
  CALL MOUSE_DETECT            ; Ist eine PS/2 Maus vorhanden ?
  OR EAX,EAX
  JZ NEAR DRV_SKIPMOUSE
  IRQS_DISABLE 12
  IRQS_ADDHAND 12,MOUSE_DESC
  CALL MOUSE_INITHARDWARE      ; Maus mu initalisiert werden
  MOV [MOUSE_STAT],DWORD 255
  IRQS_ENABLE 12
  GDT_ALLOCCALLGT0 [SYS_CODE],MOUSE_DRVCALL,[MOUSE_DRVCALLP]
  GDT_ALLOCCALLGT0 [SYS_CODE],MOUSE_CALL00000001,[MOUSE_CALL00000001P]
  PORTS_INCUSEC
  SYS_ADDDRV MOUSE_DRV
 DRV_SKIPMOUSE:
  CALL KBD_SETILEDS
  USP_DELUSERME
