;INC KBD\MOUSE.INC
MOUSE_HASOWNER DD 0
MOUSE_NAME TIMES 64 DD 0
MOUSE_DRV DD 0,0
          DD 00000009h
MOUSE_DRVCALLP DD 0
MOUSE_DRVCALL_FN DD MOUSE_DRVCALL00000000
                 DD MOUSE_DRVCALL00000001
                 DD MOUSE_DRVCALL00000002
                 DD KBD_DRVCALLXXXXXXXX
                 DD KBD_DRVCALLXXXXXXXX
                 DD KBD_DRVCALLXXXXXXXX
MOUSE_DRVCALL00000000:
  PORTS_DONE
  SYS_SIGNDONE
  RET
MOUSE_DRVCALL00000002:
  MOV ESI,MOUSE_NAME
  ADD ESI,[SYS_BASE]
  RET
MOUSE_DRVCALL00000001:
  CMP EAX,00000001h
  JZ MOUSE_DRVCALL00000001_1
  XOR EAX,EAX
  RET 
 MOUSE_DRVCALL00000001_1:
  MOV EAX,[MOUSE_CALL00000001P]
  RET
MOUSE_DRVCALL:
  CMP EDX,00000005h
  JA MOUSE_DRVCALL_EXT
  PUSH DS
  PUSH DWORD [CS:SYS_DATA]
  POP DS
  CALL [MOUSE_DRVCALL_FN+EDX*4]
  POP DS
 MOUSE_DRVCALL_EXT:
  RETF
MOUSE_CALL00000001P DD 0
MOUSE_CALL00000001_FN DD MOUSE_INIT      ; 0
                      DD MOUSE_SETRES    ; 1
                      DD MOUSE_GETPOS    ; 2
                      DD MOUSE_SETPOS    ; 3
                      DD MOUSE_DONE      ; 4
                      DD MOUSE_INSTHAND  ; 5
                      DD MOUSE_REMOVEHAND; 6
MOUSE_EXTHAND DD 0,0
MOUSE_HANDLOCK DD 0
;ͻ
; MOUSE_INSTHAND                                                            
;  Funktion       : Installiert einen Maushandler.                          
;  Parameter      : ECX:EBX=FARPTR                                          
;ͼ
MOUSE_INSTHAND:
  MOV EAX,0FFFFFFFFh
  XCHG EAX,[MOUSE_HANDLOCK]
  OR EAX,EAX
  JZ MOUSE_INSTHAND_GL
  USP_SWITCHUSER
  USP_SWITCHTASK
  JMP MOUSE_INSTHAND
 MOUSE_INSTHAND_GL:
  MOV [MOUSE_EXTHAND],EBX
  MOV [MOUSE_EXTHAND+4],ECX
  XOR EAX,EAX
  MOV [MOUSE_HANDLOCK],EAX
  RET
;ͻ
; MOUSE_REMOVEHAND                                                          
;  Funktion       : Entfernt den Maushandler.                               
;ͼ
MOUSE_REMOVEHAND:
  MOV EAX,0FFFFFFFFh
  XCHG EAX,[MOUSE_HANDLOCK]
  OR EAX,EAX
  JZ MOUSE_REMOVEHAND_GL
  USP_SWITCHUSER
  USP_SWITCHTASK
  JMP MOUSE_REMOVEHAND
 MOUSE_REMOVEHAND_GL:
  XOR EAX,EAX
  MOV [MOUSE_EXTHAND],EAX
  MOV [MOUSE_HANDLOCK],EAX
  RET
;ͻ
; MOUSE_DONE                                                                
;  Funktion       : Gibt das Recht diese Maus zu nutzen frei.               
;ͼ
MOUSE_DONE:
  XOR EAX,EAX
  MOV [MOUSE_HASOWNER],EAX
  RET
;ͻ
; MOUSE_INIT                                                                
;  Funktion       : Reserviert das Recht diese Maus zu nutzen.              
;  Rckgabewerte  : EAX=Erfolg(Bool)                                        
;ͼ
MOUSE_INIT:
  MOV EAX,0FFFFFFFFh
  XCHG EAX,[MOUSE_HASOWNER]
  NEG EAX
  AND EAX,1
  RET
;ͻ
; MOUSE_SETRES                                                              
;  Funktion       : Setzt den Maus-Bewegungsraum.                           
;  Parameter      : EDI=Horizontale Ausdehnung;ECX=Vertikale Ausdehnung     
;ͼ
MOUSE_SETRES:
  DEC ECX
  DEC EDI
  MOV [MOUSE_MX],ECX
  MOV [MOUSE_MY],EDI
  RET
;ͻ
; MOUSE_GETPOS                                                              
;  Funktion       : Ermittelt die aktuelle Mausposition und Knpfe.         
;  Rckgabewerte  : ECX=X-Position;EDX=Y-Position;EBX=Mausknpfe            
;ͼ
MOUSE_GETPOS:
  MOV ECX,[MOUSE_X]
  MOV EDX,[MOUSE_Y]
  MOV EBX,[MOUSE_B]
  RET
;ͻ
; MOUSE_SETPOS                                                              
;  Funktion       : Setzt die Mausposition.                                 
;  Parameter      : ECX=X-Position;EDI=Y-Position                           
;ͼ
MOUSE_SETPOS:
  OR ECX,ECX
  JNS MOUSE_SETPOS_NXNEG
  XOR ECX,ECX
 MOUSE_SETPOS_NXNEG:
  CMP ECX,[MOUSE_MX]
  JNA MOUSE_SETPOS_NXOVER
  MOV ECX,[MOUSE_MX]
 MOUSE_SETPOS_NXOVER: 
  OR EDI,EDI
  JNS MOUSE_SETPOS_NYNEG
  XOR EDI,EDI
 MOUSE_SETPOS_NYNEG:
  CMP EDI,[MOUSE_MY]
  JNA MOUSE_SETPOS_NYOVER
  MOV EDI,[MOUSE_MY]
 MOUSE_SETPOS_NYOVER:
  MOV [MOUSE_X],ECX
  MOV [MOUSE_Y],EDI
  RET
MOUSE_CALL00000001:
  CMP EDX,00000006h
  JA MOUSE_CALL00000001_EXT
  PUSH DS
  PUSH DWORD [CS:SYS_DATA]
  POP DS
  CALL [MOUSE_CALL00000001_FN+EDX*4]
  POP DS
 MOUSE_CALL00000001_EXT:
  RETF
MOUSE_STAT DD 0
MOUSE_X DD 0
MOUSE_Y DD 0
MOUSE_B DD 0
MOUSE_XSIGN DD 0
MOUSE_YSIGN DD 0
MOUSE_IGNORE DD 0
MOUSE_MX DD 319
MOUSE_MY DD 199
MOUSE_DESC DD 0,0
           DD MOUSE_HAND
           DD 0
MOUSE_CALLHAND:
 ; Nach dem setzen der Y-Daten soll der Handler aufgerufen werden !
 ; Wenn gerade jmd. am Handler rumpfuscht, wird nix aufgerufen !
 MOUSE_HANDY_GETLOCK:
  MOV EAX,0FFFFFFFFh
  XCHG EAX,[MOUSE_HANDLOCK]
  OR EAX,EAX
  JNZ MOUSE_HANDY_FULLEXT
 ; Der Handler sollte eindeutig nicht so viel Zeit verplempern, ich hoffe
 ; der Programmierer wei etwas von Bottom-Half !
 ; Der Handler ist eher zum Puffern der Maussignale gedacht als zum
 ; Zeichenen der Maus und eventuell von DRAG und DROP-Objekten !
  MOV EAX,[MOUSE_EXTHAND+4]
  OR EAX,EAX
  JZ MOUSE_HANDY_NOEXTHAND
  PUSH DS
  CALL FAR [MOUSE_EXTHAND]
  POP DS
 MOUSE_HANDY_NOEXTHAND:
  XOR EAX,EAX
  MOV [MOUSE_HANDLOCK],EAX
 MOUSE_HANDY_FULLEXT:
  RET
MOUSE_HANDX:
  MOV ECX,[MOUSE_IGNORE]
  OR ECX,ECX
  JNZ MOUSE_HANDX_EXT
  MOV EBX,[MOUSE_X]
  MOV ECX,[MOUSE_XSIGN]
  OR ECX,ECX
  JZ MOUSE_HANDX_NOTSIGN
  OR EAX,0FFFFFF00h
 MOUSE_HANDX_NOTSIGN:
  ADD EBX,EAX
  JS MOUSE_HANDX_ZERO
  CMP EBX,[MOUSE_MX]
  JNA MOUSE_HANDX_NOVER
  MOV EBX,[MOUSE_MX]
 MOUSE_HANDX_NOVER:
  MOV [MOUSE_X],EBX
 MOUSE_HANDX_EXT:
  RET
 MOUSE_HANDX_ZERO:
  XOR EBX,EBX
  MOV [MOUSE_X],EBX
  RET
MOUSE_HANDY:
  MOV ECX,[MOUSE_IGNORE]
  OR ECX,ECX
  JNZ MOUSE_HANDY_EXT
  MOV EBX,[MOUSE_Y]
  MOV ECX,[MOUSE_YSIGN]
  OR ECX,ECX
  JZ MOUSE_HANDY_NOTSIGN
  OR EAX,0FFFFFF00h
 MOUSE_HANDY_NOTSIGN:
  SUB EBX,EAX
  JS MOUSE_HANDY_ZERO
  CMP EBX,[MOUSE_MY]
  JNA MOUSE_HANDY_NOVER
  MOV EBX,[MOUSE_MY]
 MOUSE_HANDY_NOVER:
  MOV [MOUSE_Y],EBX
  JMP MOUSE_HANDY_EXT
 MOUSE_HANDY_ZERO:
  XOR EBX,EBX
  MOV [MOUSE_Y],EBX
 MOUSE_HANDY_EXT:
  CALL MOUSE_CALLHAND
  RET
MOUSE_HANDB:
  XOR ECX,ECX
  TEST EAX,16
  SETNE CL
  MOV [MOUSE_XSIGN],ECX
  TEST EAX,32
  SETNE CL
  MOV [MOUSE_YSIGN],ECX
  TEST EAX,192
  SETNE CL
  MOV [MOUSE_IGNORE],ECX
  AND EAX,3
  MOV [MOUSE_B],EAX
  RET
MOUSE_HAND:
  MOV DS,[CS:SYS_DATA]
  IN AL,60h
  MOVZX EAX,AL
  MOV ECX,[MOUSE_STAT]
  CMP ECX,1
  JA MOUSE_HAND_2OR255
  JB MOUSE_HAND_0
  CALL MOUSE_HANDX
  MOV [MOUSE_STAT],DWORD 2
  JMP MOUSE_HAND_EXT
 MOUSE_HAND_0:
  CMP EAX,0FAh
  JZ NEAR MOUSE_HAND_EXTE
  TEST EAX,8
  JZ NEAR MOUSE_HAND_EXTE
  CALL MOUSE_HANDB
  MOV [MOUSE_STAT],DWORD 1
  JMP MOUSE_HAND_EXT
 MOUSE_HAND_2OR255:
  OR ECX,ECX
  JS MOUSE_HAND_255
  CALL MOUSE_HANDY
  XOR EAX,EAX
  MOV [MOUSE_STAT],EAX
  JMP MOUSE_HAND_EXT
 MOUSE_HAND_255:
  MOV [MOUSE_STAT],DWORD 1
  JMP MOUSE_HAND_EXT
 MOUSE_HAND_EXTE:
  XOR EAX,EAX
  MOV [MOUSE_X],EAX
  MOV [MOUSE_Y],EAX
  MOV [MOUSE_B],EAX
 MOUSE_HAND_EXT:
  RETF
MOUSE_WRITE:
  PUSH AX
  MOV AL,0D4h
  CALL KBD_WRITECMD
  POP AX
  CALL KBD_WRITE
  RET
MOUSE_DETECT:
  CALL KBD_EMPTY8042
  MOV AL,0A8h                  ; 2. Gert aktivieren
  CALL KBD_WRITECMD
  CALL KBD_EMPTY8042
  MOV AL,0F2h
  CALL MOUSE_WRITE
  CALL KBD_READ
  CMP AL,255
  JZ MOUSE_DETECT_NOMOUSE
  OR AL,AL
  JZ MOUSE_DETECT_MOUSE
  CALL KBD_READ
  OR AL,AL
  JNZ MOUSE_DETECT_NOMOUSE
 MOUSE_DETECT_MOUSE:
  CALL KBD_EMPTY8042
  MOV EAX,1
  RET
 MOUSE_DETECT_NOMOUSE:
  CALL KBD_EMPTY8042
  XOR EAX,EAX
  RET
MOUSE_INITHARDWARE:
  MOV AL,0F6h
  CALL MOUSE_WRITE
  CALL KBD_EMPTY8042
  MOV AL,0F4h
  CALL MOUSE_WRITE
  MOV AL,60h                   ; 
  CALL KBD_WRITECMD            ;  Modus setzen (IRQs an).
  MOV AL,47h                   ; 
  CALL KBD_WRITE               ; 
  CALL KBD_EMPTY8042
  RET
