PROGRAM KEYB;
{$ASMMODE INTEL}
USES PORTS,IRQS;
CONST PORTINTV1:TPORTINTV=(NEXT:NIL;LAST:NIL;START:$60;ENDE:$61);
TYPE TKEYTABENTRY=PACKED RECORD
      CMD:DWORD;
      CODE:DWORD; { 0..23 : Keycode ; 24..31 : Class }
     END;
     TKEYTAB=ARRAY[0..255] OF TKEYTABENTRY;
     PKEYTAB=^TKEYTAB;
     TKEYTABDIR=ARRAY[0..1] OF PKEYTAB;
TYPE TMOUSEMSG=RECORD
      BUTTONS:DWORD;
      X,Y:LONGINT;
     END;
TYPE TKEY=RECORD
      FLAGS:DWORD;
      CODE:DWORD;
     END;
{$I HARDWARE.INC}
{$I KBDCOD.INC }
{$I KBDCHAR.INC }
VAR KEYBBUFFER:ARRAY[0..255] OF TKEY;
    READPOS,WRITEPOS:BYTE;
    KEYB_READLOCK:TLOCK;
    KEYBFLAGS:DWORD; { Nur Bits 0..23 ! fr Flags ! }
    BOTTOMHALF:POINTER;
    MOUSE_READLOCK:TLOCK;
    MOUSEBOTTOMHALF:POINTER;
    MOUSESTATE:DWORD;
    MOUSEBYTE1:BYTE;
    MOUSEBYTE2,MOUSEBYTE3:SHORTINT;
    MOUSEBUFFER:ARRAY[0..255] OF TMOUSEMSG;
    MOUSEREADPOS,MOUSEWRITEPOS:BYTE;
PROCEDURE ADDMOUSEMSGTOBUFFER(BUTTONS:DWORD;X,Y:LONGINT);
VAR NP:BYTE;
    A:LONGINT;
BEGIN
 NP:=MOUSEWRITEPOS+1;
 IF NP<>MOUSEREADPOS THEN { Noch Platz im Ringpuffer ? }
 BEGIN
  MOUSEBUFFER[MOUSEWRITEPOS].BUTTONS:=BUTTONS;
  A:=X*X DIV 16;
  IF X<0 THEN DEC(X,A) ELSE INC(X,A);
  A:=Y*Y DIV 16;
  IF Y<0 THEN DEC(Y,A) ELSE INC(Y,A);
  MOUSEBUFFER[MOUSEWRITEPOS].X:=X;
  MOUSEBUFFER[MOUSEWRITEPOS].Y:=Y;
  MOUSEWRITEPOS:=NP;
  IF MOUSEBOTTOMHALF<>NIL THEN ENABLETASK(MOUSEBOTTOMHALF);
 END;
END;
PROCEDURE READMOUSEMSGFROMBUFFER(VAR BUTTONS:DWORD;VAR X,Y:LONGINT);
BEGIN
 GETLOCK(@MOUSE_READLOCK); { Nur einer darf lesen ! }
 IF MOUSEREADPOS<>MOUSEWRITEPOS THEN
 BEGIN
  BUTTONS:=MOUSEBUFFER[MOUSEREADPOS].BUTTONS;
  X:=MOUSEBUFFER[MOUSEREADPOS].X;
  Y:=MOUSEBUFFER[MOUSEREADPOS].Y;
  INC(MOUSEREADPOS);  
 END;
 FREELOCK(@MOUSE_READLOCK);
END;
PROCEDURE MOUSEHANDLER(DATA:POINTER);
VAR W:DWORD;
BEGIN
 ASM
   IN AL,60h     
   MOV BYTE PTR W,AL
 END;
 CASE MOUSESTATE OF
  0:
  BEGIN
   MOUSEBYTE1:=W;
   MOUSESTATE:=1;
  END;
  1:
  BEGIN
   MOUSEBYTE2:=W;
   MOUSESTATE:=2;
  END;
  2:
  BEGIN
   MOUSEBYTE3:=W;
   MOUSESTATE:=0;
   ADDMOUSEMSGTOBUFFER(MOUSEBYTE1 AND 3,MOUSEBYTE2,-MOUSEBYTE3);
  END;
 END;
END;
FUNCTION KEYPRESSED:LONGBOOL;
BEGIN
 KEYPRESSED:=READPOS<>WRITEPOS;
END;
PROCEDURE ADDKEYTOBUFFER(FLAGS,CODE:DWORD);
VAR NP:BYTE;
BEGIN
 NP:=WRITEPOS+1;
 IF NP<>READPOS THEN { Noch Platz im Ringpuffer ? }
 BEGIN
  KEYBBUFFER[WRITEPOS].FLAGS:=FLAGS;
  KEYBBUFFER[WRITEPOS].CODE:=CODE;
  WRITEPOS:=NP;
  IF BOTTOMHALF<>NIL THEN ENABLETASK(BOTTOMHALF);
 END;
END;
PROCEDURE READKEYFROMBUFFER(VAR FLAGS,CODE:DWORD);
BEGIN
 GETLOCK(@KEYB_READLOCK); { Nur einer darf lesen ! }
 IF READPOS<>WRITEPOS THEN
 BEGIN
  FLAGS:=KEYBBUFFER[READPOS].FLAGS;
  CODE:=KEYBBUFFER[READPOS].CODE;
  INC(READPOS);  
 END;
 FREELOCK(@KEYB_READLOCK);
END;
FUNCTION CONVERTKEYTOCHAR(FLAGS,CODE:DWORD):DWORD;
BEGIN
 FLAGS:=FLAGS AND 1;
 IF CODE AND $7FFFFFFF>255 THEN CONVERTKEYTOCHAR:=CODE AND $80000000 ELSE
  CONVERTKEYTOCHAR:=KBDCHAR0[FLAGS,CODE AND $7FFFFFFF] OR (CODE AND $80000000);
END;
VAR CURTAB:PKEYTAB;
{ Variablen fr SPECIALKEY }
VAR SPEC_CAPSDOWN:LONGBOOL;
    SPEC_NUMDOWN:LONGBOOL;
    SPEC_SCROLLDOWN:LONGBOOL;
    SPEC_CAPS:LONGBOOL;
    SPEC_SCROLL:LONGBOOL;
    SPEC_NUM:LONGBOOL;
PROCEDURE SPECIALKEY(C:DWORD);
BEGIN
 CASE C OF
  $FF000000:KEYBFLAGS:=(KEYBFLAGS AND $FFFFFFFE) OR BYTE(SPEC_CAPS);
  $7F000000:KEYBFLAGS:=(KEYBFLAGS AND $FFFFFFFE) OR BYTE(NOT SPEC_CAPS);
  $FF000006:SPEC_CAPSDOWN:=FALSE;
  $7F000006:IF NOT SPEC_CAPSDOWN THEN
  BEGIN
   SPEC_CAPSDOWN:=TRUE;
   KEYBFLAGS:=KEYBFLAGS XOR 16384;
   SPEC_CAPS:=NOT SPEC_CAPS;
   KEYBFLAGS:=(KEYBFLAGS AND $FFFFFFFE) OR BYTE(SPEC_CAPS);
   SETILEDS(SPEC_SCROLL,SPEC_NUM,SPEC_CAPS);
  END;
  $FF000007:SPEC_SCROLLDOWN:=FALSE;
  $7F000007:IF NOT SPEC_SCROLLDOWN THEN
  BEGIN
   SPEC_SCROLLDOWN:=TRUE;
   KEYBFLAGS:=KEYBFLAGS XOR 65536;
   SPEC_SCROLL:=NOT SPEC_SCROLL;
   SETILEDS(SPEC_SCROLL,SPEC_NUM,SPEC_CAPS);
  END;
  $FF000008:SPEC_NUMDOWN:=FALSE;
  $7F000008:IF NOT SPEC_NUMDOWN THEN
  BEGIN
   SPEC_NUMDOWN:=TRUE;
   KEYBFLAGS:=KEYBFLAGS XOR 32768;
   SPEC_NUM:=NOT SPEC_NUM;
   SETILEDS(SPEC_SCROLL,SPEC_NUM,SPEC_CAPS);
  END;
 END;
END;
VAR SHUTDOWNBKBF:BOOLEAN;
PROCEDURE KEYBHANDLER(D:POINTER);
VAR KEY:DWORD;
BEGIN
 ASM
   XOR EAX,EAX
   IN AL,60h    
   MOV KEY,EAX
 END;
 IF (KEY=225) AND (NOT SHUTDOWNBKBF) THEN
 BEGIN
  SHUTDOWNBKBF:=TRUE;
  WRITELNSTR('[PAUSE]->Shutdown');
  EXPLSHUTDOWN;
  SHUTDOWN(NIL);
 END;
 WITH CURTAB^[KEY] DO
 BEGIN
{  WRITESTR('Key : ');
  WRITEHEX(KEY);
  WRITESTR(' -> ');
  WRITEHEX(CMD);
  WRITESTR(' + ');
  WRITELNHEX(CODE);}
  IF CMD AND 2<>0 THEN SPECIALKEY(CODE);
  IF CMD AND 1<>0 THEN ADDKEYTOBUFFER(KEYBFLAGS,CODE);
  CURTAB:=KEYTABS[CMD SHR 16];
 END;
END;
PROCEDURE SETBOTTOMHALF(P:POINTER);
BEGIN
 DISABLEIRQ(1);
 BOTTOMHALF:=P;
 READPOS:=WRITEPOS;
 ENABLEIRQ(1);
END;
CONST IRQ1:TIRQHANDLER=(NEXT:NIL;LAST:NIL;DATA:NIL;PROC:@KEYBHANDLER);
CONST IRQ12:TIRQHANDLER=(NEXT:NIL;LAST:NIL;DATA:NIL;PROC:@MOUSEHANDLER);
VAR KEYB_USERS:DWORD;
    KEYB_SHUTDOWNTASK:POINTER;
    KEYB_SHUTDOWNMODE:LONGBOOL;
PROCEDURE DEINITIALIZEKEYBDRV;
BEGIN
 WRITELNSTR('KEYB UNI');
 KEYB_SHUTDOWNTASK:=GETTASKHANDLE();
 KEYB_SHUTDOWNMODE:=TRUE;
 IF KEYB_USERS<>0 THEN DISABLETASK(KEYB_SHUTDOWNTASK);
 REMOVEIRQHANDLER(1,@IRQ1);
 REMOVEIRQHANDLER(12,@IRQ12);
 FREEIRQ(1);
 FREEIRQ(12);
 REMOVEPORTINTV(@PORTINTV1);
 WRITELNSTR('KEYB DONE.');
 SIGNALSHUTDOWNOK;
 HALT;
END;
PROCEDURE FREEKEYBPROT(NR:DWORD);
BEGIN
 CASE NR OF
  1:
  BEGIN
   DECATOM(@KEYB_USERS);
   BOTTOMHALF:=NIL; { Bitte in ALLOC/RELEASE-Struct ! }
   IF KEYB_SHUTDOWNMODE AND (KEYB_USERS=0) THEN ENABLETASK(KEYB_SHUTDOWNTASK);
  END;
 END;
END;
PROCEDURE DEINITIALIZEMOUSEDRV;
BEGIN
 { Sollten die IRQs fr Maus etc nicht hier freigegeben werden ! ? }
 WRITELNSTR('MOUSE DONE.');
 SIGNALSHUTDOWNOK;
 HALT;
END;
PROCEDURE FREEMOUSEPROT(NR:DWORD);
BEGIN
 CASE NR OF
  1:
  BEGIN
   DECATOM(@KEYB_USERS);
   MOUSEBOTTOMHALF:=NIL; { Bitte in ALLOC/RELEASE-Struct ! }
   IF KEYB_SHUTDOWNMODE AND (KEYB_USERS=0) THEN ENABLETASK(KEYB_SHUTDOWNTASK);
  END;
 END;
END;
CONST KEYB_PROT0:ARRAY[0..1] OF POINTER=(
       @DEINITIALIZEKEYBDRV,
       @FREEKEYBPROT);
CONST KEYB_PROT1:ARRAY[0..3] OF POINTER=(
       @KEYPRESSED,
       @READKEYFROMBUFFER,
       @CONVERTKEYTOCHAR,
       @SETBOTTOMHALF);
FUNCTION DOCK_KEYB(NR:DWORD):POINTER;
BEGIN
 CASE NR OF
  0:DOCK_KEYB:=@KEYB_PROT0;
  1:
  BEGIN
   INCATOM(@KEYB_USERS);
   DOCK_KEYB:=@KEYB_PROT1;
  END;
  ELSE DOCK_KEYB:=NIL;
 END;
END;
CONST DRVKEYB:TDRIVER=(NEXT:NIL;LAST:NIL;TYP:8;ID:0;GETPROT:@DOCK_KEYB;
                       DESC:'Keybdriver (1)');
PROCEDURE SETMSBOTTOMHALF(TASK:POINTER);
BEGIN
 DISABLEIRQ(12); { MU SMP Kompatibel sein ! }
 MOUSEREADPOS:=MOUSEWRITEPOS;
 MOUSEBOTTOMHALF:=TASK;
 ENABLEIRQ(12);
END;
FUNCTION MOUSEMSGEXISTS:LONGBOOL;
BEGIN
 MOUSEMSGEXISTS:=MOUSEREADPOS<>MOUSEWRITEPOS;
END;
CONST MOUSE_PROT0:ARRAY[0..1] OF POINTER=(
       @DEINITIALIZEMOUSEDRV,
       @FREEMOUSEPROT);
CONST MOUSE_PROT1:ARRAY[0..2] OF POINTER=(
       @MOUSEMSGEXISTS,
       @READMOUSEMSGFROMBUFFER,
       @SETMSBOTTOMHALF);
FUNCTION DOCK_MOUSE(NR:DWORD):POINTER;
BEGIN
 CASE NR OF
  0:DOCK_MOUSE:=@MOUSE_PROT0;
  1:
  BEGIN
   INCATOM(@KEYB_USERS);
   DOCK_MOUSE:=@MOUSE_PROT1;
  END;
 END;
END;
CONST MOUSEDRV:TDRIVER=(NEXT:NIL;LAST:NIL;TYP:$A;ID:0;GETPROT:@DOCK_MOUSE;
                        DESC:'Mouse driver (1)');
BEGIN
 STARTDRIVERINITIALIZATION;
 IF NOT ADDPORTINTV(@PORTINTV1) THEN
 BEGIN
  STOPDRIVERINITIALIZATION;
  HALT('Keyb needs PORTS $60..$61');
 END;
 IF NOT GETIRQALONE(1) THEN
 BEGIN
  REMOVEPORTINTV(@PORTINTV1);
  STOPDRIVERINITIALIZATION;
  HALT('Keyb needs IRQ1 !');
 END;
 IF NOT GETIRQALONE(12) THEN
 BEGIN
  REMOVEPORTINTV(@PORTINTV1);
  FREEIRQ(1);
  STOPDRIVERINITIALIZATION;
  HALT('PS/2 needs IRQ12 !');
 END;
 CURTAB:=KEYTABS[0];
 DISABLEIRQ(1); 
 ADDIRQHANDLER(1,@IRQ1);
 ENABLEIRQ(1);
 DISABLEIRQ(12); 
 ADDIRQHANDLER(12,@IRQ12); 
 IF DETECTMOUSE THEN
 BEGIN
  WRITELNSTR('PS/2 Mouse found...');
  WRITEMOUSE($F6);
  READNOR;
  EMPTY8042;
  WRITEMOUSE($F4);
  READNOR;
  WRITECMD($60);
  WRITENOR($47);
  EMPTY8042;
 END ELSE WRITELNSTR('PS/2 Mouse not found...');
 ENABLEIRQ(12);
 SETILEDS(SPEC_SCROLL,SPEC_NUM,SPEC_CAPS); 
 ADDDRIVER(@DRVKEYB);
 ADDDRIVER(@MOUSEDRV);
 STOPDRIVERINITIALIZATION;
END.
