PROGRAM MEM;
TYPE PMEMBLOCK=^TMEMBLOCK;
     TMEMBLOCK=RECORD
      NEXT:PMEMBLOCK;
      SIZE:DWORD;
     END;
TYPE PMEMPAGE=^TMEMPAGE;
     TMEMPAGE=RECORD
      NEXT,LAST:PMEMPAGE;
      FIRST:PMEMBLOCK;   
     END;
VAR FIRSTPAGE:PMEMPAGE;
    PAGESIZE:DWORD;
    PAGEAND:DWORD;
    PAGESHR:DWORD;
    MEMLOCK:TELOCK;
FUNCTION GETMEM(SIZE:DWORD):POINTER;
VAR PAGE:PMEMPAGE;
    N,P,L:PMEMBLOCK;
BEGIN
 IF (SIZE>=PAGESIZE-SIZEOF(TMEMBLOCK)-SIZEOF(TMEMPAGE)) THEN
 BEGIN
  INC(SIZE,8);
  GETMEM:=ALLOCMEM(SIZE);
  PDWORD(GETMEM)^:=$FFFFFFFF;
  PDWORD(GETMEM+4)^:=SIZE;
  INC(GETMEM,8);
{  WRITELNSTR('ALLOC PAGE : '+HEXSTR(DWORD(GETMEM),8));}
  EXIT;
 END;
 SIZE:=SIZE AND $FFFFFFFC+ORD(SIZE AND 3) SHL 2; { DWORD solls sein ! }
 GETELOCK(@MEMLOCK);
 PAGE:=FIRSTPAGE;
 WHILE PAGE<>NIL DO
 BEGIN
  P:=PAGE^.FIRST;
  { 1. Schritt : Genug Platz vor dem ersten Block ? }
  IF (DWORD(P) AND PAGEAND)-SIZEOF(TMEMPAGE)>=SIZE+SIZEOF(TMEMBLOCK) THEN
  BEGIN
   N:=POINTER(PAGE)+SIZEOF(TMEMPAGE);
   N^.NEXT:=P;
   N^.SIZE:=SIZE;
   PAGE^.FIRST:=N;
   FREEELOCK(@MEMLOCK);
   GETMEM:=N+1;
{   WRITELNSTR('ALLOC FI   : '+HEXSTR(DWORD(GETMEM),8));}
   EXIT;
  END;
  { 2. Schritt : Genug Platz zwischen 2 Blcken ? }
  L:=P;
  P:=P^.NEXT;
  WHILE P<>NIL DO
  BEGIN
   IF DWORD(P)-DWORD(L)-L^.SIZE>=SIZE+2*SIZEOF(TMEMBLOCK) THEN
   BEGIN
    N:=POINTER(L)+L^.SIZE+SIZEOF(TMEMBLOCK);
    N^.NEXT:=P;
    N^.SIZE:=SIZE;
    L^.NEXT:=N;
    FREEELOCK(@MEMLOCK);
    GETMEM:=N+1;
{    WRITELNSTR('ALLOC SUB  : '+HEXSTR(DWORD(GETMEM),8));}
    EXIT;
   END;
   L:=P;
   P:=P^.NEXT;
  END;
  { 3. Schritt : Genug Platz am Ende des Blocks ? }
  { L kann nicht NIL sein, sonst wrde der Block nicht existieren,
    zumindest nicht mit LOCK ! }  
  IF PAGESIZE-(DWORD(L) AND PAGEAND)>=SIZE+2*SIZEOF(TMEMBLOCK)+L^.SIZE THEN
  BEGIN
   N:=POINTER(L)+L^.SIZE+SIZEOF(TMEMBLOCK);
   N^.NEXT:=NIL;
   N^.SIZE:=SIZE;
   L^.NEXT:=N;
   FREEELOCK(@MEMLOCK);
   GETMEM:=N+1;
{   WRITELNSTR('ALLOC END  : '+HEXSTR(DWORD(GETMEM),8));}
   EXIT;
  END;
  PAGE:=PAGE^.NEXT;
 END;
 PAGE:=ALLOCMEM(PAGESIZE);
 IF PAGE=NIL THEN
 BEGIN
  FREEELOCK(@MEMLOCK);
  GETMEM:=NIL;
  EXIT;
 END;
 N:=POINTER(PAGE+1);
 PAGE^.NEXT:=FIRSTPAGE;
 PAGE^.LAST:=NIL;
 PAGE^.FIRST:=N; 
 N^.NEXT:=NIL;
 N^.SIZE:=SIZE;
 FIRSTPAGE:=PAGE;
 GETMEM:=N+1;
{ WRITELNSTR('ALLOC NEW  : '+HEXSTR(DWORD(GETMEM),8));}
 FREEELOCK(@MEMLOCK);
END;
PROCEDURE FREEMEM(P:PMEMBLOCK);
VAR PAGE:PMEMPAGE;
    L:PMEMBLOCK;
BEGIN
 PAGE:=POINTER(DWORD(P) AND (NOT PAGEAND));
 IF DWORD(PAGE^.NEXT)=$FFFFFFFF THEN
 BEGIN
  WRITELNSTR('RELEASE PAGES : '+HEXSTR(DWORD(PAGE),8));
  RELEASEMEM(PAGE,DWORD(PAGE^.LAST));
  EXIT;
 END;
 DEC(P);
{ WRITELNSTR('RELEASE NORMAL : '+HEXSTR(DWORD(P+1),8));}
 L:=PAGE^.FIRST;
 IF P=L THEN
 BEGIN
  IF P^.NEXT=NIL THEN
  BEGIN
   { Seite freigeben ! }
   GETELOCK(@MEMLOCK);
   IF PAGE^.LAST<>NIL THEN PAGE^.LAST^.NEXT:=PAGE^.NEXT ELSE FIRSTPAGE:=PAGE^.NEXT;
   IF PAGE^.NEXT<>NIL THEN PAGE^.NEXT^.LAST:=PAGE^.LAST;
   FREEELOCK(@MEMLOCK);
   RELEASEMEM(PAGE,PAGESIZE);
  END ELSE PAGE^.FIRST:=P^.NEXT;
  EXIT;
 END;
 WHILE L^.NEXT<>P DO L:=L^.NEXT;
 L^.NEXT:=P^.NEXT; { Und schon ausgeklingt ! }
END;
VAR MEM_USERS:DWORD;
    MEM_SHUTDOWNTASK:POINTER;
    MEM_SHUTDOWNMODE:BOOLEAN;
PROCEDURE DEINITIALIZEMEMDRV;
BEGIN
 MEM_SHUTDOWNTASK:=GETTASKHANDLE();
 MEM_SHUTDOWNMODE:=TRUE;
 IF MEM_USERS<>0 THEN DISABLETASK(MEM_SHUTDOWNTASK);
 WRITELNSTR('MEM DONE.');
 SIGNALSHUTDOWNOK;
 HALT;
END;
PROCEDURE FREEMEMPROT(NR:DWORD);
BEGIN
 CASE NR OF
  2:
  BEGIN
   DECATOM(@MEM_USERS);
   IF MEM_SHUTDOWNMODE AND (MEM_USERS=0) THEN ENABLETASK(MEM_SHUTDOWNTASK);
  END;
 END;
END;
CONST MEMPROT0:ARRAY[0..1] OF POINTER=(
       @DEINITIALIZEMEMDRV,
       @FREEMEMPROT);
CONST MEMPROT2:ARRAY[0..1] OF POINTER=(
       @GETMEM,
       @FREEMEM);
FUNCTION DOCK_MEM(NR:DWORD):POINTER;
BEGIN
 CASE NR OF
  0:DOCK_MEM:=@MEMPROT0;
  2:
  BEGIN
   INCATOM(@MEM_USERS);
   DOCK_MEM:=@MEMPROT2;
  END;
  ELSE DOCK_MEM:=NIL;
 END;
END;
CONST DRVMEM:TDRIVER=(NEXT:NIL;LAST:NIL;TYP:2;ID:0;GETPROT:@DOCK_MEM;
                      DESC:'Memory driver (2)');
BEGIN
 WRITELNSTR('MEM ('+HEXSTR(DWORD(GETPROCESSHANDLE())));
 STARTDRIVERINITIALIZATION;
 PAGESHR:=GETPAGEBITS();
 PAGESIZE:=1 SHL PAGESHR;
 PAGEAND:=PAGESIZE-1;
 ADDDRIVER(@DRVMEM);
 STOPDRIVERINITIALIZATION;
END.
