PROGRAM PORTS;
TYPE PPORTINTV=^TPORTINTV;
     TPORTINTV=RECORD
      NEXT,LAST:PPORTINTV;
      START,ENDE:DWORD;
     END;
VAR PORT_LOCK:TLOCK;
    FIRSTPORTINTV:PPORTINTV;
FUNCTION ADDPORTINTV(P:PPORTINTV):BOOLEAN;
VAR S:PPORTINTV;
BEGIN
 GETLOCK(@PORT_LOCK);
 S:=FIRSTPORTINTV;
 WHILE S<>NIL DO
 BEGIN
  IF ((P^.START>=S^.START) AND (P^.START<=S^.ENDE)) OR
     ((P^.ENDE>=S^.START) AND (P^.ENDE<=S^.ENDE)) THEN
  BEGIN
   FREELOCK(@PORT_LOCK);
   ADDPORTINTV:=FALSE;
   EXIT;
  END;
  S:=S^.NEXT;
 END;
 P^.LAST:=NIL;
 P^.NEXT:=FIRSTPORTINTV;
 IF FIRSTPORTINTV<>NIL THEN FIRSTPORTINTV^.LAST:=P;
 FIRSTPORTINTV:=P;
 FREELOCK(@PORT_LOCK);
 ADDPORTINTV:=TRUE;
END;
PROCEDURE REMOVEPORTINTV(P:PPORTINTV);
BEGIN
 GETLOCK(@PORT_LOCK);
 IF P^.LAST<>NIL THEN P^.LAST^.NEXT:=P^.NEXT ELSE FIRSTPORTINTV:=P^.NEXT;
 IF P^.NEXT<>NIL THEN P^.NEXT^.LAST:=P^.LAST;
 FREELOCK(@PORT_LOCK); 
END;
VAR PORTS_USERS:DWORD;
    PORTS_SHUTDOWNTASK:POINTER;
    PORTS_SHUTDOWNMODE:BOOLEAN;
PROCEDURE FREEPORTSPROT(NR:DWORD);
BEGIN
 CASE NR OF
  1:
  BEGIN
   DECATOM(@PORTS_USERS);
   IF PORTS_SHUTDOWNMODE AND (PORTS_USERS=0) THEN ENABLETASK(PORTS_SHUTDOWNTASK);
  END;
 END;
END;
PROCEDURE DEINITIALIZEPORTSDRV;
BEGIN
 WRITELNSTR('PORTS UNI');
 PORTS_SHUTDOWNTASK:=GETTASKHANDLE();
 PORTS_SHUTDOWNMODE:=TRUE;
 IF PORTS_USERS<>0 THEN DISABLETASK(PORTS_SHUTDOWNTASK);
 WRITELNSTR('PORTS DONE.');
 SIGNALSHUTDOWNOK;
 HALT;
END;
CONST PORTS_PROT0:ARRAY[0..1] OF POINTER=(
       @DEINITIALIZEPORTSDRV,
       @FREEPORTSPROT);
CONST PORTS_PROT1:ARRAY[0..1] OF POINTER=(
       @ADDPORTINTV,
       @REMOVEPORTINTV);
FUNCTION DOCK_PORTS(PR:DWORD):POINTER;
BEGIN
 CASE PR OF
  0:DOCK_PORTS:=@PORTS_PROT0;
  1:
  BEGIN
   DOCK_PORTS:=@PORTS_PROT1;
   INCATOM(@PORTS_USERS);
  END;
  ELSE DOCK_PORTS:=NIL;
 END;
END;
CONST DRVPORTS:TDRIVER=(NEXT:NIL;LAST:NIL;TYP:4;ID:0;GETPROT:@DOCK_PORTS;
                        DESC:'Portdriver (1)');
BEGIN
 STARTDRIVERINITIALIZATION();
 ADDDRIVER(@DRVPORTS);
 STOPDRIVERINITIALIZATION();
END.
