PROGRAM TIMER;
{$ASMMODE INTEL}
USES PORTS,IRQS;
CONST PORTINTV1:TPORTINTV=(NEXT:NIL;LAST:NIL;START:$40;ENDE:$43);
TYPE PTIMERHANDLE=^TTIMERHANDLE;
     TTIMERHANDLE=RECORD
      NEXT,LAST:PTIMERHANDLE;
      PROC:PROCEDURE;
      PERIOD:DWORD;
      LEFT:DWORD;
     END;
VAR CALLSCHED:LONGBOOL;
    SCHEDPERIOD:DWORD;
    SCHEDLEFT:DWORD;
    TIMER_LOCK:TLOCK;
    BASISCL:DWORD;
    CONFIGTIMER:LONGBOOL;
    INITTASK:POINTER;
    TIME1,TIME2:DWORD;
    TIMERCOUNTER:DWORD;
    FIRSTHANDLE:PTIMERHANDLE;
PROCEDURE SETTIMERFREQ(W:DWORD);ASSEMBLER;
ASM
  PUSHFD
  CLI
  MOV EAX,[BASISCL]
  XOR EDX,EDX
  MOV EBX,W
  DIV EBX
  MOV EBX,EAX
  MOV AL,36h
  OUT 43h,AL
  MOV AL,BL
  OUT 40h,AL
  MOV AL,BH
  OUT 40h,AL
  POPFD
END;
PROCEDURE IRQ0HANDLER(D:POINTER);
VAR P:PTIMERHANDLE;
BEGIN
 P:=FIRSTHANDLE;
 WHILE P<>NIL DO
 BEGIN
  IF P^.LEFT>0 THEN DEC(P^.LEFT) ELSE
  BEGIN
   P^.PROC;
   P^.LEFT:=P^.PERIOD;
  END;
  P:=P^.NEXT;
 END;
END;
PROCEDURE IRQ0HANDLERAEOI(D:POINTER);
BEGIN
 IF CALLSCHED THEN
 BEGIN
  IF SCHEDLEFT>0 THEN DEC(SCHEDLEFT) ELSE
  BEGIN
   SCHEDULE;
   SCHEDLEFT:=SCHEDPERIOD;
  END;
 END;
END;
CONST IRQ0:TIRQHANDLER=(NEXT:NIL;LAST:NIL;DATA:NIL;PROC:@IRQ0HANDLER);
CONST IRQ0AEOI:TIRQHANDLER=(NEXT:NIL;LAST:NIL;DATA:NIL;PROC:@IRQ0HANDLERAEOI);
PROCEDURE ADDTIMERHANDLE(P:PTIMERHANDLE);
BEGIN
 GETLOCK(@TIMER_LOCK);
 P^.LAST:=NIL;
 P^.NEXT:=FIRSTHANDLE;
 IF FIRSTHANDLE<>NIL THEN FIRSTHANDLE^.LAST:=P;
 FIRSTHANDLE:=P;
 FREELOCK(@TIMER_LOCK);
END;
PROCEDURE REMOVETIMERHANDLE(P:PTIMERHANDLE);
BEGIN
 GETLOCK(@TIMER_LOCK);
 IF P^.NEXT<>NIL THEN P^.NEXT^.LAST:=P^.LAST;
 IF P^.LAST<>NIL THEN P^.LAST^.NEXT:=P^.NEXT ELSE FIRSTHANDLE:=P^.NEXT;
 FREELOCK(@TIMER_LOCK);
END;
VAR TIMER_USERS:DWORD;
    TIMER_SHUTDOWNTASK:POINTER;
    TIMER_SHUTDOWNMODE:LONGBOOL;
PROCEDURE DEINITIALIZETIMERDRV;
BEGIN
 TIMER_SHUTDOWNTASK:=GETTASKHANDLE();
 TIMER_SHUTDOWNMODE:=TRUE;
 IF TIMER_USERS<>0 THEN DISABLETASK(TIMER_SHUTDOWNTASK);
 REMOVEIRQHANDLER(0,@IRQ0);
 REMOVEIRQHANDLERAEOI(0,@IRQ0AEOI);
 FREEIRQ(0);
 REMOVEPORTINTV(@PORTINTV1);
 SETTIMERFREQ(18); { Naja... }
 WRITELNSTR('TIMER DONE.');
 SIGNALSHUTDOWNOK;
 HALT;
END;
PROCEDURE FREETIMERPROT(NR:DWORD);
BEGIN
 CASE NR OF
  1:
  BEGIN
   DECATOM(@TIMER_USERS);
   IF TIMER_SHUTDOWNMODE AND (TIMER_USERS=0) THEN ENABLETASK(TIMER_SHUTDOWNTASK);
  END;
 END;
END;
CONST TIMER_PROT0:ARRAY[0..1] OF POINTER=(
       @DEINITIALIZETIMERDRV,
       @FREETIMERPROT);
CONST TIMER_PROT1:ARRAY[0..1] OF POINTER=(
       @ADDTIMERHANDLE,
       @REMOVETIMERHANDLE);
FUNCTION DOCK_TIMER(NR:DWORD):POINTER;
BEGIN
 CASE NR OF
  0:DOCK_TIMER:=@TIMER_PROT0;
  1:
  BEGIN
   INCATOM(@TIMER_USERS);
   DOCK_TIMER:=@TIMER_PROT1;
  END;
  ELSE DOCK_TIMER:=NIL;
 END;
END;
CONST DRVTIMER:TDRIVER=(NEXT:NIL;LAST:NIL;TYP:6;ID:0;GETPROT:@DOCK_TIMER;
                        DESC:'Timer driver (1)');
VAR PC:DWORD;
    S:STRING;
    COUNTER:DWORD;
BEGIN
 WRITELNSTR('TIMER ('+HEXSTR(DWORD(GETPROCESSHANDLE())));
 STARTDRIVERINITIALIZATION;
 IF NOT GETIRQALONE(0) THEN
 BEGIN
  STOPDRIVERINITIALIZATION;
  HALT('Timer driver needs IRQ 0 for himself, no irq-sharing allowed !');
 END;
 IF NOT ADDPORTINTV(@PORTINTV1) THEN
 BEGIN
  FREEIRQ(0);
  STOPDRIVERINITIALIZATION;
  HALT('Ports could not be reserved ! (TIMER)');
 END;
 FOR PC:=1 TO PARAMCOUNT DO
 BEGIN
  S:=PARAMSTR(PC-1);
  IF S='Schedule' THEN
  BEGIN
   SCHEDPERIOD:=10;
   CALLSCHED:=TRUE;
  END;
 END;
 DISABLEIRQ(0);
 BASISCL:=11931820;
 SETTIMERFREQ(1024);
 ENABLEIRQ(0);
 ADDIRQHANDLER(0,@IRQ0);
 ADDIRQHANDLERAEOI(0,@IRQ0AEOI);
 INITTASK:=GETTASKHANDLE();
 ADDDRIVER(@DRVTIMER);
 STOPDRIVERINITIALIZATION;
END.
