PROGRAM V86;
{$ASMMODE INTEL}
USES KRNL86RM,IRQS,TIMER,EXCEPTS,PORTS;
VAR V86SEGMENT:DWORD;
    V86OFFSET:DWORD;
    V86DESC:PDWORDARRAY;
    REALMODETASK:POINTER;
FUNCTION IALLOCRMB(SIZE:DWORD):POINTER;
BEGIN
 IALLOCRMB:=ALLOCREALMODEBUFFER(SIZE);
END;
PROCEDURE IRELEASERMB(P:POINTER;SIZE:DWORD);
BEGIN
 RELEASEREALMODEBUFFER(P,SIZE);
END;
FUNCTION V86EXCEPTIONSH(P:PEXCEPTIONDATA):LONGBOOL;
VAR I:DWORD;
    S,N:PDWORDARRAY;
    A,V,V2,INTNR:DWORD;
    N1:PBYTEARRAY;
    REALMODESTACK:PWORDARRAY;
BEGIN
 IF P^.TASK=REALMODETASK THEN
 BEGIN
  S:=P^.STACKP;
  N:=NIL;
  N1:=NIL;
  A:=S^[0]+S^[1] SHL 4;
  V:=N1^[A];
  V2:=N1^[A+1];
  CASE V OF
   $CD:
   BEGIN
    DEC(S^[3],6); { Ein IRET mehr ! }
    REALMODESTACK:=POINTER(S^[3]+S^[4] SHL 4);
    REALMODESTACK^[0]:=S^[0]+2;
    REALMODESTACK^[1]:=S^[1];
    REALMODESTACK^[2]:=S^[2];
    S^[0]:=N^[V2] AND $FFFF;
    S^[1]:=N^[V2] SHR 16;
    V86EXCEPTIONSH:=TRUE;
   END;
   $EC:{ IN AL,DX }
   BEGIN
    INC(S^[0]);
    P^.EAX:=P^.EAX AND $FFFFFF00 OR INPORTB(P^.EDX);
    V86EXCEPTIONSH:=TRUE;
   END;
   $ED:{ IN AX,DX }
   BEGIN
    INC(S^[0]);
    P^.EAX:=P^.EAX AND $FFFF0000 OR INPORTW(P^.EDX);
    V86EXCEPTIONSH:=TRUE;
   END;
   $EE:{ OUT DX,AL}
   BEGIN
    INC(S^[0]);
    OUTPORTB(P^.EDX,P^.EAX);
    V86EXCEPTIONSH:=TRUE;
   END;
   $EF:{ OUT DX,AX}
   BEGIN
    INC(S^[0]);
    OUTPORTW(P^.EDX,P^.EAX);
    V86EXCEPTIONSH:=TRUE;
   END;
   ELSE V86EXCEPTIONSH:=FALSE;
  END;
 END ELSE V86EXCEPTIONSH:=FALSE;
END;
CONST V86EXCEPTIONS:TEXCEPTIONHANDLER=(NEXT:NIL;LAST:NIL;PROC:@V86EXCEPTIONSH);
PROCEDURE REALMODE_TASK;ASSEMBLER;
ASM
  STI
  PUSH DWORD 0
  PUSH DWORD 0
  PUSH DWORD 0
  PUSH DWORD 0
  PUSH DWORD 0
  PUSH DWORD 0
  PUSHFD
  POP EAX
  OR EAX,131072+4096+8192
  PUSH EAX
  PUSH DWORD [V86SEGMENT]
  PUSH DWORD [V86OFFSET]
  IRET
END;
TYPE TREGISTERS=RECORD
      EAX,ECX,EDX,EBX:DWORD;
      ESI,EDI,EBP:DWORD;
      ES,DS,FS,GS:DWORD;
      FLAGS:DWORD;
     END;
PROCEDURE REALINT(NR:DWORD;VAR REG:TREGISTERS);
VAR P:POINTER;
BEGIN
 GETREALMODEENV();
 V86DESC^[2]:=NR;
 V86DESC^[5]:=REG.EAX;
 V86DESC^[6]:=REG.ECX;
 V86DESC^[7]:=REG.EDX;
 V86DESC^[8]:=REG.EBX;
 V86DESC^[9]:=REG.EDI;
 V86DESC^[10]:=REG.ESI;
 V86DESC^[11]:=REG.EBP;
 V86DESC^[12]:=REG.ES;
 V86DESC^[13]:=REG.DS;
 V86DESC^[14]:=REG.FS;
 V86DESC^[15]:=REG.GS;
 V86DESC^[16]:=REG.FLAGS;
 V86DESC^[0]:=1;
 REALMODETASK:=CREATEV86TASK(GETPROCESSHANDLE(),@REALMODE_TASK,$7FFFFFFF,'V86 Task',TRUE);
 WHILE V86DESC^[0]<>0 DO SCHEDULE;
 P:=REALMODETASK;
 REALMODETASK:=NIL;
 DESTROYTASK(P,NIL);
 FREEREALMODEENV();
END;
CONST V86_PROT2:ARRAY[0..2] OF POINTER=(
       @REALINT,
       @IALLOCRMB,
       @IRELEASERMB);
VAR V86_USERS:DWORD;
    V86_SHUTDOWNMODE:LONGBOOL;
    V86_SHUTDOWNTASK:POINTER;
PROCEDURE DEINITIALIZEV86DRV;
BEGIN
 V86_SHUTDOWNTASK:=GETTASKHANDLE();
 V86_SHUTDOWNMODE:=TRUE;
 IF V86_USERS<>0 THEN DISABLETASK(V86_SHUTDOWNTASK);
 WRITELNSTR('V86 DONE.');
 SIGNALSHUTDOWNOK;
 HALT;
END;
PROCEDURE FREEV86PROT(NR:DWORD);
BEGIN
 CASE NR OF
  2:
  BEGIN
   DECATOM(@V86_USERS);
   IF (V86_SHUTDOWNMODE) AND (V86_USERS=0) THEN ENABLETASK(V86_SHUTDOWNTASK);
  END;
 END;
END;
CONST V86_PROT0:ARRAY[0..1] OF POINTER=(
       @DEINITIALIZEV86DRV,
       @FREEV86PROT);
FUNCTION DOCK_V86(NR:DWORD):POINTER;
BEGIN
 CASE NR OF
  0:DOCK_V86:=@V86_PROT0;
  2:
  BEGIN
   INCATOM(@V86_USERS);
   DOCK_V86:=@V86_PROT2;
  END;
  ELSE DOCK_V86:=NIL;
 END;
END;
CONST V86DRV:TDRIVER=(NEXT:NIL;LAST:NIL;TYP:$C;ID:0;GETPROT:@DOCK_V86;
                      DESC:'V86 Realmode driver (2)');
BEGIN
 STARTDRIVERINITIALIZATION;
 ADDEXCEPTIONHANDLER(@V86EXCEPTIONS);
 ADDDRIVER(@V86DRV);
 STOPDRIVERINITIALIZATION;
 V86SEGMENT:=GETV86SEGMENT();
 V86OFFSET:=DWORD(GETV86PROC())-V86SEGMENT*16;
 V86DESC:=GETV86CMDBLOCK(); 
END.
