LOADNEXTBLOCK DD 0
BUFFER DD 0
LBUFFER DD 0
BUFFERSIZE DD 0
BUFFERPOS DD 0
DEB_X DW 0
DEB_Y DW 0
DEB_CRTC DW 0
KERNEL16_BASE DD 0
KERNEL16_REBOOT:
  MOV AL,0FCh
  OUT 64h,AL
  RETF
KERNEL16_LOADBTS:
  MOV AX,07C0h
  MOV ES,AX
  MOV DS,AX
  XOR BX,BX
  MOV AX,201h
  INT 13h
  JMP 7C0h:0
KERNEL16_RUNBOOTSEC:
  MOV AX,7C0h
  MOV ES,AX
  MOV DS,AX
  JMP 7C0h:0
DOSIDT DW 256*4-1              ; Dos-IDT.
       DD 0
OLDSS DW 0                     ; Altes Stacksegment.
GDT DW 6*8-1                   ; 7 Eintrge
    DD 0                       ; Basis
GDT_NIL DD 0,0                 ; Dummy (notwendig)
GDT_CODE16 DW 0FFFFh           ; 
           DB 0,0,0            ;  Codesegment fr Kernel16. (8h)
           DW 0000000010011010b; 
           DB 0                ; 
GDT_DATA16 DW 0FFFFh           ; 
           DB 0,0,0            ;  Datensegment fr Kernel16. (10h)
           DW 0000000010010010b; 
           DB 0                ; 
GDT_CODE32 DW 0FFFFh           ; 
           DB 0,0,0            ;  Codesegment fr Kernel32 (18h)
           DW 1100111110011010b; 
           DB 0                ; 
GDT_DATA32 DW 0FFFFh           ; 
           DB 0,0,0            ;  Flat-Datensegment(20h)
           DW 1100111110010010b; 
           DB 0                ; 
GDT_STACK DW 0FFFFh            ; 
          DB 0,0,0             ;  Alias fr den Realmode Stapel (28h)
          DW 0000000010010010b ; 
          DB 0                 ; 
;ͻ
; MEM_GETMEMSIZE                                                            
;  Funktion       : Ermitteln des Installierten Speichers.                  
;  Rckgabewerte  : EAX=Speichergre in 4Kb blcken.                       
;  Anmerkung      : Der Speicher ber 1Mb darf nicht whrend dieses Tests   
;                   genutzt werden !!!                                      
;ͼ
MEM_GETMEMSIZE:
  PUSH DS
  MOV AX,20h
  MOV DS,AX
  MOV EDI,1024*1024            ; Anfangsadresse fr den Speichertest.
  MOV ECX,1024*1023+256        ; Anzahl mglicher Speicherseiten.(4Gb)
 MEM_GETMEMSIZE_WRLP:          ; 
  MOV [EDI],ECX                ;  In Jeden 4Kb Block ein paar
  MOV [EDI+4092],EDI           ;  Informationen speichern.
  CMP [EDI],ECX                ;  Bei Funktionierendem Cache endet dieser
  JNZ MEM_GETMEMSIZE_WND       ;  Vorgang am Ende des Vorhandenen Speichers.
  CMP [EDI+4092],EDI           ; 
  JNZ MEM_GETMEMSIZE_WND       ; 
  ADD EDI,4096                 ; 
  DEC ECX                      ; 
  JNE MEM_GETMEMSIZE_WRLP      ; 
 MEM_GETMEMSIZE_WND:           ;
  MOV EDI,1024*1024            ; Anfangsadresse fr die Prfung.
  MOV ECX,1024*1023+256        ; Anzahl mglicher Speicherseiten.
 MEM_GETMEMSIZE_RDLP:          ; 
  CMP [EDI],ECX                ;  Hier wird geprft, ob uns der Cache
  JNZ MEM_GETMEMSIZE_END       ;  vielleicht einen Streich gespielt hat.
  CMP [EDI+4092],EDI           ;  Der Cache darf nicht mehr als 1/2048
  JNZ MEM_GETMEMSIZE_END       ;  des Speichers halten. (Witz!)
  ADD EDI,4096                 ; 
  DEC ECX                      ; 
  JNE MEM_GETMEMSIZE_RDLP      ; 
 MEM_GETMEMSIZE_END:           ; 
  MOV EAX,1024*1023+256        ; 
  SUB EAX,ECX                  ;  Rckgabewert berechnen.
  ADD EAX,256                  ; 
  POP DS
  RET                          ; Fertig ?
DONEKERNEL16:
  LIDT [DOSIDT]                ; Interrupt-Tabelle wieder bei 0:0
  CALL SETIRQ8_70              ; Alte Vektoren fr PIC setzen...
  STI                          ; Interrupts wieder einschalten...
  CALL KEYB_CLEAR
  CALL RESETKEYB
  CALL CRTCTOBIOS              ; Cursorpositon kopieren.
  RET
READCOUNTER DD 0
READBYTE:
  INC DWORD [READCOUNTER]
  MOV EDI,[BUFFERPOS]
  MOV ESI,[LBUFFER]
  MOVZX EAX,BYTE [FS:ESI+EDI]
  INC EDI
  CMP EDI,[BUFFERSIZE]
  JNZ READBYTE_NOOVER
  PUSH EAX
  CALL SWITCHTORMODE
  CALL FAR [LOADNEXTBLOCK]
  CALL SWITCHTOPMODE
  POP EAX
  XOR EDI,EDI
 READBYTE_NOOVER:
  MOV [BUFFERPOS],EDI
  RET
READWORD:
  CALL READBYTE
  PUSH EAX
  CALL READBYTE
  POP EBX
  SHL EAX,8
  ADD EAX,EBX
  RET
READDWORD:
  CALL READWORD
  PUSH EAX
  CALL READWORD
  POP EBX
  SHL EAX,16
  ADD EAX,EBX
  RET
PREPAREKERNEL16:
  CLD                          ; Immer geradeaus, dann links, dann rechts...
  MOV AX,CS                    ; Datensegment=Codesegment
  MOV DS,AX
  MOV [REALSEG],AX             ; Sichern fr den Rcksprung am Ende...
  MOV [KERNEL16_REALMODEDESC+20],AX
  MOV [LOADNEXTBLOCK],BX
  MOV [LOADNEXTBLOCK+2],CX
  MOV [BUFFER],SI
  MOV [BUFFER+2],DX
  MOV [BUFFERSIZE],DI
  AND EDX,0FFFFh
  AND ESI,0FFFFh
  SHL EDX,4
  ADD EDX,ESI
  MOV [LBUFFER],EDX
  CALL FAR [LOADNEXTBLOCK]     ; Ersten Sektor in den Puffer laden.
  CLI                          ; Interrupts ausschalten...
  CALL ENABLEA20               ; Grrrrrrrrrrrr... (AUS MIT DEM WRAPPER)
  CALL KEYB_CLEAR              ; Nur zur Vorsicht: Tastatur zurcksetzen.
  CALL PREPAREGDT
  RET
SWITCHTOPMODE:
  CLI                          ; Interrupts ausschalten...
  MOV EAX,CR0                  ; 
  OR AL,1                      ;  Ab in den Geschtzten Modus und ins
  MOV CR0,EAX                  ;  neue Code-Segment 8h.
  JMP 8h:TO_PMODE              ; 
 TO_PMODE:                     ; 
  MOV AX,20h                   ; Neuer Datenselektor.
  MOV FS,AX
  MOV AX,28h                   ; Und alten Stapel ber neuen Alias
  MOV SS,AX
  MOV AX,10h
  MOV DS,AX
  MOV ES,AX
  MOV GS,AX
  RET
SWITCHTORMODE:
  MOV AX,10h
  MOV DS,AX
  MOV EAX,CR0                  ; 
  AND AL,0FEh                  ;  Und zurck in "Mtterchen" Real-Mode,
  MOV CR0,EAX                  ;  ins alte Code-Segment...
  DB 0EAh                      ; 
  DW TO_REALMODE               ; 
 REALSEG DW 0                  ; 
 TO_REALMODE:                  ; 
  MOV AX,[REALSEG]             ; 
  MOV DS,AX                    ;  Realmode Datensegment wieder laden.
  MOV ES,AX                    ; 
  MOV FS,AX                    ; 
  MOV GS,AX                    ; 
  MOV SS,[OLDSS]               ; 
  RET
PREPAREGDT: 
  MOV EAX,[KERNEL16_REALMODEDESC+20]
  SHL EAX,4
  MOV [KERNEL16_BASE],EAX
  ADD [KERNEL16_REALMODEDESC+4],EAX
  ADD [KERNEL16_REALMODEDESC+8],EAX
  ADD [KERNEL16_REALMODEDESC+12],EAX
  ADD [KERNEL16_REALMODEDESC+16],EAX
  MOV [GDT_CODE16+2],AX        ; 
  MOV [GDT_DATA16+2],AX        ;  Und mit dieser Information, die
  ROL EAX,16                   ;  notwendigen Deskriptoren und den
  MOV [GDT_CODE16+4],AL        ;  GDT-Zeiger initalisieren.
  MOV [GDT_DATA16+4],AL        ; 
  MOV [GDT_CODE16+7],AH        ; 
  MOV [GDT_DATA16+7],AH        ; 
  ROL EAX,16                   ; 
  ADD EAX,GDT_NIL              ; 
  MOV [GDT+2],EAX              ; 
  MOV AX,SS                    ; 
  MOV [OLDSS],AX               ;  Stapel initalisieren...
  MOVZX EAX,AX                 ; 
  SHL EAX,4                    ; 
  MOV [GDT_STACK+2],AX         ; 
  SHR EAX,16                   ; 
  MOV [GDT_STACK+4],AL         ; 
  MOV [GDT_STACK+7],AH         ; 
  LGDT [GDT]                   ; GDT-Laden
  RET
SETIRQ8_70:
  MOV AL,11h                   ; 
  OUT 20h,AL                   ;  Basis der IRQs nach 8,70h verschieben.
  OUT 0A0h,AL                  ; 
  MOV AL,8                     ; 
  OUT 21h,AL                   ; 
  MOV AL,70h                   ; 
  OUT 0A1h,AL                  ; 
  MOV AL,4h                    ; 
  OUT 21h,AL                   ; 
  MOV AL,2h                    ; 
  OUT 0A1h,AL                  ; 
  MOV AL,1h                    ; 
  OUT 21h,AL                   ; 
  OUT 0A1h,AL                  ; 
  RET
RESETKEYB:
  CALL EMPTY_8042
  MOV AL,0F6h
  OUT 60h,AL
  CALL EMPTY_8042
  RET
ENABLEA20:
  CALL EMPTY_8042
  MOV AL,0D1h
  OUT 64h,AL
  CALL EMPTY_8042
  MOV AL,0DFh
  OUT 60h,AL
  CALL EMPTY_8042
  XOR AX,AX
  MOV ES,AX
  DEC AX  
  MOV GS,AX
  MOV BX,[ES:0]
 ENABLEA20_WAIT:
  INC AX
  MOV [ES:0],AX
  MOV BX,0FFFFh
  MOV ES,BX
  CMP AX,[ES:10h]
  JE ENABLEA20_WAIT
  XOR BX,BX
  MOV ES,AX
  MOV [ES:0],BX
  RET
EMPTY_8042:
  PUSH ECX
  MOV ECX,0FFFFFFh
 EMPTY_8042_LP:
  DEC ECX
  JZ EMPTY_8042_EXT
  CALL DELAY
  IN AL,64h
  TEST AL,1
  JZ EMPTY_8042_NO
  CALL DELAY
  IN AL,60h
  JMP EMPTY_8042_LP
 EMPTY_8042_NO:
  TEST AL,2
  JNZ EMPTY_8042_LP
 EMPTY_8042_EXT:
  POP ECX
  RET
KEYB_CLEAR:
  MOV AX,0305h                 ; 
  XOR BX,BX                    ;  Tastatur zurcksetzen (Geschwindigkeit).
  INT 16h                      ; 
 KEYB_REP:                     ; 
  MOV AH,1                     ;  Alle Tasten aus dem Bios-Tastaturpuffer
  INT 16h                      ;  holen.
  JZ KEYB_EMPTY                ; 
  XOR AX,AX                    ; 
  INT 16h                      ; 
  JMP KEYB_REP                 ; 
 KEYB_EMPTY:                   ; 
  RET                          ; Fertig ?
DELAY:
  JMP DELAY_P1                 ; 
 DELAY_P1:                     ;  Ein kleines bisschen Zeit vertun...
  JMP DELAY_P2                 ; 
 DELAY_P2:                     ; 
  JMP DELAY_P3                 ; 
 DELAY_P3:                     ; 
  RET                          ; Fertig ?
CRTCTOBIOS:
  CALL DEB_INIT
  MOV AH,2
  XOR BX,BX
  MOV DH,[DEB_Y]
  MOV DL,[DEB_X]
  INT 10h
  RET
DEB_INIT:
  MOV DX,3CCh                  ; 
  IN AL,DX                     ;  Initalisieren der Variablen,
  AND AL,1                     ;  unterscheiden zwischen Monochrom und
  JNZ DEB_INIT_COLOR           ;  Farbe.
  MOV [DEB_CRTC],WORD 03B4h    ; 
  JMP DEB_INIT_DMONO           ; 
 DEB_INIT_COLOR:               ; 
  MOV [DEB_CRTC],WORD 03D4h    ; 
 DEB_INIT_DMONO:               ; 
  MOV DX,[DEB_CRTC]            ; 
  MOV AL,14                    ;  Lesen der Cursorposition in AX.
  OUT DX,AL                    ; 
  INC DX                       ; 
  IN AL,DX                     ; 
  MOV BL,AL                    ; 
  DEC DX                       ; 
  MOV AL,15                    ; 
  OUT DX,AL                    ; 
  INC DX                       ; 
  IN AL,DX                     ; 
  MOV AH,BL                    ; 
  MOV CX,AX                    ; 
  XOR DX,DX                    ;  Umrechnen des Cursor-Offsets in
  MOV BX,80                    ;  X und Y Koordinaten.
  DIV BX                       ; 
  MOV [DEB_Y],AX               ; 
  MUL BX                       ; 
  SUB CX,AX                    ; 
  MOV [DEB_X],CX               ; 
  RET                          ; Fertig ?
