UNIT DEBUG;
{$ASMMODE INTEL}
INTERFACE
CONST BUFFERSIZE=65536;
PROCEDURE WRITESTR(S:STRING);
PROCEDURE WRITELNSTR(S:STRING);
PROCEDURE WRITEHEX(W:DWORD);
PROCEDURE WRITELNHEX(W:DWORD);
PROCEDURE COPYDEBUGBUFFER(START,COUNT:DWORD;T:PSTRINGARRAY);
FUNCTION HEXSTR(W:DWORD):STRING;
IMPLEMENTATION
USES DRIVERS,TASKS;
CONST HEXCHARS:ARRAY[0..15] OF CHAR=('0','1','2','3','4','5','6','7','8','9',
                                     'A','B','C','D','E','F');
VAR DEBUGLOCK:TLOCK;
    BUFFER:PCHARARRAY;
    BUFSTART,BUFEND,BUFPOS,LINELEN,LINECOUNT,LINESTART:DWORD;
    DEBUGSYSR:DWORD;
    DISPLAYTASKH:PTASK;
    DISPLAYCONT:LONGBOOL;
    DISPLAYHAND:PROCEDURE;
    SCREEN:ARRAY[0..24] OF STRING;
    COUNT:DWORD;
    DISPLAYHANDLOCK:TLOCK;
PROCEDURE SIGNALDEBUGHAND;
BEGIN
 GETLOCK(@DISPLAYHANDLOCK);
 IF DISPLAYHAND<>NIL THEN DISPLAYHAND();  { GETLOCK sollte vielleicht doch
  hier hin, wegen gleichzeitigem Del ! }
 FREELOCK(@DISPLAYHANDLOCK);
END;
FUNCTION HEXSTR(W:DWORD):STRING;
BEGIN
 HEXSTR:='';
 WHILE W>0 DO
 BEGIN
  HEXSTR:=HEXCHARS[W AND $F]+HEXSTR;
  W:=W SHR 4;
 END;
 IF HEXSTR='' THEN HEXSTR:='0';
END;
PROCEDURE INSTALLNEWOUTPUTHANDLER(P:POINTER);
BEGIN
 GETLOCK(@DISPLAYHANDLOCK);
 POINTER(DISPLAYHAND):=P;
 FREELOCK(@DISPLAYHANDLOCK);
END;
FUNCTION GETDEBUGLINECOUNT:DWORD;
BEGIN
 GETDEBUGLINECOUNT:=LINECOUNT+1;
END;
FUNCTION ALLOCDEBUGSYS:LONGBOOL;
BEGIN
 ALLOCDEBUGSYS:=TRYTOSETDWORD(@DEBUGSYSR);
END;
PROCEDURE RELEASEDEBUGSYS;
BEGIN
 GETLOCK(@DISPLAYHANDLOCK);
 DISPLAYHAND:=NIL;
 DEBUGSYSR:=0;
 FREELOCK(@DISPLAYHANDLOCK);
END;
PROCEDURE COPYDEBUGBUFFER(START,COUNT:DWORD;T:PSTRINGARRAY);
VAR P,P2,CC:DWORD;
BEGIN
 IF COUNT=0 THEN EXIT;
 ASM
   PUSHFD
   CLI
 END;
 GETLOCK(@DEBUGLOCK);
 IF (START>LINECOUNT) THEN
 BEGIN
  FOR P:=1 TO COUNT DO T^[P-1]:='';
  FREELOCK(@DEBUGLOCK);
  ASM
    POPFD
  END;
  EXIT;
 END;
 P:=BUFSTART;
 CC:=0;
 WHILE (START>0) AND (P<>BUFEND) DO
 BEGIN
  IF BUFFER^[P]=#10 THEN
  BEGIN
   DEC(START);
   CC:=0;
  END
  ELSE
  BEGIN
   INC(CC);
   IF CC=80 THEN
   BEGIN
    DEC(START);
    CC:=0;
   END;
  END;
  INC(P);
  IF P>=BUFFERSIZE THEN P:=0;
 END;
 P2:=0;
 T^[P2]:='';
 WHILE (COUNT>0) AND (P<>BUFEND) DO
 BEGIN
  IF (BUFFER^[P]=#10) THEN
  BEGIN
   INC(P2);
   DEC(COUNT);
   IF COUNT>0 THEN T^[P2]:='';
  END
  ELSE T^[P2]:=T^[P2]+BUFFER^[P];
  IF T^[P2,0]=#80 THEN
  BEGIN   
   IF COUNT>0 THEN DEC(COUNT);
   INC(P2);
   IF COUNT>0 THEN T^[P2]:='';
  END;
  INC(P);
  IF P>=BUFFERSIZE THEN P:=0;
 END;
 IF (COUNT<>0) AND (T^[P2]<>'') THEN
 BEGIN
  INC(P2);
  DEC(COUNT);
 END;
 WHILE COUNT>0 DO
 BEGIN
  T^[P2]:='';
  INC(P2);
  DEC(COUNT);
 END;
 FREELOCK(@DEBUGLOCK);
 ASM
   POPFD
 END;
END;
PROCEDURE SHOWLINE;
VAR I:DWORD;
    S:STRING;
BEGIN
 IF DISPLAYHAND<>NIL THEN EXIT;
 S:='';
 I:=LINESTART;
 WHILE I<>BUFEND DO
 BEGIN
  S:=S+BUFFER^[I];
  INC(I);
  IF I>=BUFFERSIZE THEN I:=0;
 END;
 PUTSTRINGL(S);
END;
PROCEDURE ADDCHAR(C:CHAR);
VAR P,NP:DWORD;
BEGIN
 IF C=#13 THEN
 BEGIN
  BUFPOS:=LINESTART;
  EXIT;
 END;
 P:=BUFPOS;
 INC(P);
 IF P>=BUFFERSIZE THEN NP:=0 ELSE NP:=P;
 IF C=#10 THEN
 BEGIN
  SHOWLINE;
  IF BUFPOS=BUFEND THEN
  BEGIN
   BUFFER^[BUFPOS]:=#10;
   BUFPOS:=NP;
  END;
  LINELEN:=0;
  LINESTART:=NP;
  INC(LINECOUNT);
 END
 ELSE
 BEGIN
  IF BUFPOS=BUFEND THEN INC(LINELEN);
  BUFFER^[BUFPOS]:=C;
  BUFPOS:=NP;
 END;
 IF P>BUFEND THEN
 BEGIN
  BUFEND:=NP;
  IF BUFEND=BUFSTART THEN
  BEGIN
   NP:=0;
   WHILE (BUFFER^[BUFSTART]<>#10) AND (NP<79) DO
   BEGIN
    INC(BUFSTART);
    IF BUFSTART>=BUFFERSIZE THEN BUFSTART:=0;
    INC(NP);
   END;
   INC(BUFSTART);
   IF BUFSTART>=BUFFERSIZE THEN BUFSTART:=0;
   DEC(LINECOUNT);
  END;
 END;
 IF LINELEN=80 THEN
 BEGIN
  SHOWLINE;
  LINELEN:=0;
  LINESTART:=BUFPOS;
  INC(LINECOUNT);
 END;
END;
PROCEDURE WRITESTR(S:STRING);
VAR I:DWORD;
BEGIN
 ASM
   PUSHFD
   CLI
 END;
 GETLOCK(@DEBUGLOCK);
 FOR I:=1 TO BYTE(S[0]) DO ADDCHAR(S[I]);
 SIGNALDEBUGHAND;
 FREELOCK(@DEBUGLOCK);
 ASM
   POPFD
 END;
END;
PROCEDURE WRITELNSTR(S:STRING);
VAR I:DWORD;
BEGIN
 ASM
   PUSHFD
   CLI
 END;
 GETLOCK(@DEBUGLOCK);
 FOR I:=1 TO BYTE(S[0]) DO ADDCHAR(S[I]);
 ADDCHAR(#10);
 SIGNALDEBUGHAND;
 FREELOCK(@DEBUGLOCK);
 ASM
   POPFD
 END;
END;
PROCEDURE WRITEHEX(W:DWORD);
VAR I:DWORD;
BEGIN
 ASM
   PUSHFD
   CLI
 END;
 GETLOCK(@DEBUGLOCK);
 FOR I:=7 DOWNTO 0 DO ADDCHAR(HEXCHARS[W SHR (I*4) AND 15]);
 SIGNALDEBUGHAND;
 FREELOCK(@DEBUGLOCK);
 ASM
   POPFD
 END;
END;
PROCEDURE WRITELNHEX(W:DWORD);
VAR I:DWORD;
BEGIN
 ASM
   PUSHFD
   CLI
 END;
 GETLOCK(@DEBUGLOCK);
 FOR I:=7 DOWNTO 0 DO ADDCHAR(HEXCHARS[W SHR (I*4) AND 15]);
 ADDCHAR(#10);
 SIGNALDEBUGHAND;
 FREELOCK(@DEBUGLOCK);
 ASM
   POPFD
 END;
END;
PROCEDURE DEINITIALIZEDEBUGDRV;
BEGIN
 SIGNALSHUTDOWNOK;
 DESTROYPROCESS(GETPROCESSHANDLE(),NIL);
END;
PROCEDURE FREEDEBUGPROT;
BEGIN
END;
VAR DEBUGFLAGS:ARRAY[0..15] OF DWORD;
PROCEDURE SETDEBUGFLAG(NR,W:DWORD);
BEGIN
 DEBUGFLAGS[NR]:=W;
END;
FUNCTION GETDEBUGFLAG(NR:DWORD):DWORD;
BEGIN
 GETDEBUGFLAG:=DEBUGFLAGS[NR];
END;
CONST DRVDEBUG_PROT0:ARRAY[0..1] OF POINTER=(
       @DEINITIALIZEDEBUGDRV,
       @FREEDEBUGPROT);
CONST DRVDEBUG_PROT1:ARRAY[0..5] OF POINTER=(
       @WRITESTR,
       @WRITELNSTR,
       @WRITEHEX,
       @WRITELNHEX,
       @SETDEBUGFLAG,
       @GETDEBUGFLAG);
CONST DRVDEBUG_PROT2:ARRAY[0..4] OF POINTER=(
       @ALLOCDEBUGSYS,
       @RELEASEDEBUGSYS,
       @INSTALLNEWOUTPUTHANDLER,
       @GETDEBUGLINECOUNT,
       @COPYDEBUGBUFFER);
FUNCTION DOCK_DEBUG(PR:DWORD):POINTER;
BEGIN
 CASE PR OF
  0:DOCK_DEBUG:=@DRVDEBUG_PROT0;
  1:DOCK_DEBUG:=@DRVDEBUG_PROT1;
  2:DOCK_DEBUG:=@DRVDEBUG_PROT2;
  ELSE DOCK_DEBUG:=NIL;
 END;
END;
CONST DRVDEBUG:TDRIVER=(NEXT:NIL;LAST:NIL;TYP:3;ID:0;GETPROT:@DOCK_DEBUG;
                        DESC:'Kernel32 - Debug driver (1)');
INITIALIZATION
 WRITELNHEXC:=@WRITELNHEX;
 BUFFER:=ALLOCMEM(BUFFERSIZE);
 ADDDRIVER(@DRVDEBUG);
FINALIZATION
 RELEASEMEM(BUFFER,BUFFERSIZE);
END.
