UNIT DRIVERS;
{$ASMMODE INTEL}
INTERFACE
TYPE PDRIVER=^TDRIVER;
     TDRIVER=PACKED RECORD
      NEXT,LAST:PDRIVER;
      TYP,ID:DWORD;
      GETPROT:FUNCTION(PR:DWORD):POINTER;
      DESC:STRING;
     END;
FUNCTION FINDDRIVER(TYP,ID:DWORD;VAR GR:DWORD):PDRIVER;
FUNCTION FINDFIRSTADRIVER(TYP:DWORD;VAR GR:DWORD):PDRIVER;
FUNCTION FINDNEXTADRIVER(L:PDRIVER;TYP:DWORD):PDRIVER;
PROCEDURE FINDCLOSEDRIVER(GR:DWORD);
PROCEDURE ADDDRIVER(P:PDRIVER);
FUNCTION INITIALDRIVERINTERFACE(PR:DWORD):POINTER;
FUNCTION GETFIRSTDRIVER:PDRIVER;
PROCEDURE SHUTDOWN(P:PDRIVER);
PROCEDURE REBOOT;
PROCEDURE SIGNALSHUTDOWNOK;
PROCEDURE STARTDRIVERINITIALIZATION;
PROCEDURE STOPDRIVERINITIALIZATION;
IMPLEMENTATION
USES TASKS,DEBUG;
VAR FIRSTDRIVER:PDRIVER;
    DRV_LOCK:TLOCK;
    DRV_READ:TREADSTAT;
    SHUTDOWN_LOCK:TELOCK;
    SHUTDOWNCOUNT:DWORD;
PROCEDURE STARTDRIVERINITIALIZATION;
BEGIN
 STARTREADLOCK(@SHUTDOWN_LOCK);
END;
PROCEDURE STOPDRIVERINITIALIZATION;
BEGIN
 STOPREADLOCK(@SHUTDOWN_LOCK);
END;
PROCEDURE SIGNALSHUTDOWNOK;
BEGIN
 DECATOM(@SHUTDOWNCOUNT);
 IF (SHUTDOWNCOUNT=0) AND (SHUTDOWN_LOCK.LOCK.LOCK<>0) THEN
 BEGIN
  WRITELNSTR('All drivers have been deinitialized');
  HALT;
 END;
END;
PROCEDURE SUBSHUTDOWN(P:PDRIVER);
VAR PR:PPOINTERARRAY;
    PROCESS:PPROCESS;
BEGIN
 IF P^.LAST<>NIL THEN P^.LAST^.NEXT:=P^.NEXT ELSE FIRSTDRIVER:=P^.NEXT;
 IF P^.NEXT<>NIL THEN P^.NEXT^.LAST:=P^.LAST;
 WAITFORREADCYCL(@DRV_READ); { Jetzt liet keiner mehr diesen Treiber ! }
 PR:=P^.GETPROT(0);
 IF PR<>NIL THEN
 BEGIN
  INCATOM(@SHUTDOWNCOUNT);
  PROCESS:=CREATEPROCESS(NIL,$FFFFFFFF,'Shutdown-Task');
  CREATETASK(PROCESS,PR^[0],$7FFFFFFF,'Shutdown-Task');
 END ELSE{ WRITELNSTR('Treiber hat kein Protokoll(0) !')};
END;
PROCEDURE REBOOT;
BEGIN
 SHUTDOWNFLAG:=1;
 SHUTDOWN(NIL);
END;
PROCEDURE SHUTDOWN(P:PDRIVER);
BEGIN
 GETELOCK(@SHUTDOWN_LOCK); { Das ist Endgltig wenn P=NIL }
 GETLOCK(@DRV_LOCK); { Liste fr sich beanspruchen (Schreiben+Lesen) }
 WRITESTR('Got Shutdown Message for ');
 WRITELNHEX(DWORD(P));
 IF P=NIL THEN
 BEGIN  
  INCATOM(@SHUTDOWNCOUNT);
  WHILE FIRSTDRIVER<>NIL DO SUBSHUTDOWN(FIRSTDRIVER);
  SIGNALSHUTDOWNOK;
 END
 ELSE
 BEGIN  
  SUBSHUTDOWN(P);
  FREELOCK(@DRV_LOCK);
  FREEELOCK(@SHUTDOWN_LOCK);
 END;
END;
PROCEDURE STARTREADINGDRIVERLIST(VAR GR:DWORD);
BEGIN
 GR:=STARTREAD(@DRV_READ);
END;
PROCEDURE STOPREADINGDRIVERLIST(GR:DWORD);
BEGIN
 STOPREAD(@DRV_READ,GR);
END;
FUNCTION GETFIRSTDRIVER:PDRIVER;
BEGIN
 GETFIRSTDRIVER:=FIRSTDRIVER;
END;
FUNCTION GETMINOR(TYP:DWORD):DWORD; { Lock bereits durch ADDRIVER ! }
VAR P:PDRIVER;
    F:LONGBOOL;
BEGIN
 GETMINOR:=0;
 REPEAT
  F:=FALSE;
  P:=FIRSTDRIVER;
  WHILE P<>NIL DO
  BEGIN
   IF (P^.TYP=TYP) AND (P^.ID=GETMINOR) THEN
   BEGIN
    INC(GETMINOR);
    F:=TRUE;
   END;
   P:=P^.NEXT;
  END;
 UNTIL NOT F;
END;
PROCEDURE ADDDRIVER(P:PDRIVER);
BEGIN
 GETLOCK(@DRV_LOCK);
 P^.ID:=GETMINOR(P^.TYP);
 P^.NEXT:=FIRSTDRIVER;
 P^.LAST:=NIL;
 IF FIRSTDRIVER<>NIL THEN FIRSTDRIVER^.LAST:=P;
 FIRSTDRIVER:=P;
 FREELOCK(@DRV_LOCK);
END;
FUNCTION FINDFIRSTADRIVER(TYP:DWORD;VAR GR:DWORD):PDRIVER;
BEGIN
 GR:=STARTREAD(@DRV_READ);
 FINDFIRSTADRIVER:=FIRSTDRIVER;
 WHILE FINDFIRSTADRIVER<>NIL DO
 BEGIN
  IF FINDFIRSTADRIVER^.TYP=TYP THEN EXIT;
  FINDFIRSTADRIVER:=FINDFIRSTADRIVER^.NEXT;
 END;
END;
FUNCTION FINDNEXTADRIVER(L:PDRIVER;TYP:DWORD):PDRIVER;
BEGIN
 FINDNEXTADRIVER:=L;
 IF FINDNEXTADRIVER=NIL THEN EXIT;
 FINDNEXTADRIVER:=L^.NEXT;
 WHILE FINDNEXTADRIVER<>NIL DO
 BEGIN
  IF FINDNEXTADRIVER^.TYP=TYP THEN EXIT;
  FINDNEXTADRIVER:=FINDNEXTADRIVER^.NEXT;
 END;
END;
PROCEDURE FINDCLOSEDRIVER(GR:DWORD);
BEGIN
 STOPREAD(@DRV_READ,GR);
END;
FUNCTION FINDDRIVER(TYP,ID:DWORD;VAR GR:DWORD):PDRIVER;
BEGIN 
 GR:=STARTREAD(@DRV_READ);
 FINDDRIVER:=FIRSTDRIVER;
 WHILE FINDDRIVER<>NIL DO
 BEGIN
  IF (FINDDRIVER^.TYP=TYP) AND (FINDDRIVER^.ID=ID) THEN EXIT;
  FINDDRIVER:=FINDDRIVER^.NEXT;
 END;
 FINDDRIVER:=NIL;
END;
CONST DRIVERS_PROT1:ARRAY[0..12] OF POINTER=(
       @FINDDRIVER,
       @FINDFIRSTADRIVER,
       @FINDNEXTADRIVER,
       @FINDCLOSEDRIVER,
       @ADDDRIVER,
       @GETFIRSTDRIVER,
       @STARTREADINGDRIVERLIST,
       @STOPREADINGDRIVERLIST,
       @SHUTDOWN,
       @SIGNALSHUTDOWNOK,
       @STARTDRIVERINITIALIZATION,
       @STOPDRIVERINITIALIZATION,
       @REBOOT);
FUNCTION INITIALDRIVERINTERFACE(PR:DWORD):POINTER;
BEGIN
 CASE PR OF
  1:INITIALDRIVERINTERFACE:=@DRIVERS_PROT1;
  ELSE INITIALDRIVERINTERFACE:=NIL;
 END;
END;
END.
