UNIT SYSTEM;
{$DEFINE KERNEL}
{$ASMMODE INTEL}
INTERFACE
CONST GDT_SIZE=8192;   { Beschreiber }
      SYSMEM_SIZE=256; { Pagedir-Eintrge }
{$I ..\FPINC\TYPES.INH}
VAR PROG_BASE:DWORD;
    PROG_SIZE:DWORD;
    PROG_BSS:DWORD;
    REALMODEDESC:PDWORDARRAY;
    SYSMEMORY:DWORD;
    FIRSTADDR:DWORD;
    RETURN_SS:DWORD;
    RETURN_ESP:DWORD;
    SYSTEMPAGEDIR:PDWORDARRAY;
    SCHEDULER:PROCEDURE;
    SHUTDOWNFLAG:DWORD;
{$I ..\FPINC\ATOM.INH}
{$I ..\FPINC\I386.INH}
{$I SYSTEM\GDT.INH}
{$I SYSTEM\MEM.INH}
PROCEDURE HALT;
FUNCTION GETTASKREG:DWORD;
PROCEDURE CLEARINTERRUPTFLAG;
PROCEDURE SETINTERRUPTFLAG;
PROCEDURE SCHEDULE;
PROCEDURE GETMEM(VAR P:POINTER;SIZE:DWORD);
PROCEDURE FREEMEM(P:POINTER;SIZE:DWORD);
PROCEDURE FREEMEM(VAR P:POINTER);
FUNCTION GETPAGEFRAME(ADDR:DWORD):DWORD;
PROCEDURE PUTSTRING(X,Y:LONGINT;S:STRING);
PROCEDURE PUTSTRINGL(S:STRING);
IMPLEMENTATION
VAR LINE:DWORD;
PROCEDURE PUTCHAR(X,Y:DWORD;C:CHAR);ASSEMBLER;
ASM
  MOV EDX,Y
  CMP EDX,24
  JA @EXT
  MOV ECX,X
  CMP EDX,79
  JA  @EXT
  MOV EAX,80
  MUL EDX
  ADD EAX,ECX
  SHL EAX,1
  MOV BL,C
  MOV BH,7
  ADD EAX,0B8000h
  MOV [EAX],BX
 @EXT:
END;
PROCEDURE PUTSTRING(X,Y:LONGINT;S:STRING);
VAR I:DWORD;
BEGIN
 FOR I:=1 TO BYTE(S[0]) DO
 BEGIN
  PUTCHAR(X+I-1,Y,S[I]);
 END;
END;
PROCEDURE PUTSTRINGL(S:STRING);
BEGIN
 PUTSTRING(0,LINE,S);
 INC(LINE);
 IF LINE>24 THEN LINE:=0;
END;
TYPE TGDTPOINTER=RECORD
      SIZE:WORD;
      BASE:POINTER;
      REST:WORD;
     END;
VAR OLDGDT:TGDTPOINTER;
    NEWGDT:TGDTPOINTER;
    PAGETABLES:PDWORDARRAY;    
    MEMALLOC:PBYTEARRAY;
    PAGES_LOCK:TLOCK;
    GDT_LOCK:TLOCK;
    STARTUPALLOC:DWORD;
FUNCTION GETPAGEFRAME(ADDR:DWORD):DWORD;
BEGIN
 ADDR:=ADDR SHR 12;
 IF ADDR<SYSMEM_SIZE*1024 THEN GETPAGEFRAME:=PAGETABLES^[ADDR]
  ELSE GETPAGEFRAME:=$FFFFFFFF;
END;
PROCEDURE FREEMEM(VAR P:POINTER);[public,alias:'FPC_FREEMEM'];
BEGIN
END;
PROCEDURE FREEMEM(P:POINTER;SIZE:DWORD);[public,alias:'ASMFREEMEM'];
BEGIN
END;
PROCEDURE GETMEM(VAR P:POINTER;SIZE:DWORD);[public,alias:'ASMGETMEM'];[public,alias:'FPC_GETMEM'];
BEGIN
END;
PROCEDURE HANDLEERROR(NR:DWORD);
BEGIN
 HALT;
END;
PROCEDURE SCHEDULE;ASSEMBLER;
ASM
  PUSH EAX
  MOV EAX,[SCHEDULER]
  OR EAX,EAX
  JZ @EXT
  PUSHAD
  CALL [SCHEDULER]
  POPAD
 @EXT:
  POP EAX
END;
PROCEDURE CLEARINTERRUPTFLAG;ASSEMBLER;
ASM
  CLI
END;
PROCEDURE SETINTERRUPTFLAG;ASSEMBLER;
ASM
  STI
END;
FUNCTION GETTASKREG:DWORD;ASSEMBLER;
ASM
  XOR EAX,EAX
  STR AX
END;
PROCEDURE INITSTARTUPALLOC;
BEGIN
 STARTUPALLOC:=FIRSTADDR;
 IF STARTUPALLOC AND $FFF<>0 THEN STARTUPALLOC:=STARTUPALLOC AND $FFFFF000+4096;
END;
FUNCTION GSTARTUPALLOC(SIZE:DWORD):POINTER;
BEGIN
 GSTARTUPALLOC:=POINTER(STARTUPALLOC);
 INC(STARTUPALLOC,SIZE);
 IF STARTUPALLOC AND $FFF<>0 THEN STARTUPALLOC:=STARTUPALLOC AND $FFFFF000+4096;
END;
{$I SYSTEM\MEM.INC}
{$I SYSTEM\GDT.INC}
{$I ..\FPINC\ATOM.INC}
CONST MAXUNITS=1024;
TYPE TUNITENTRY=RECORD
      INIT,FINAL:TPROCEDURE;
     END;
     TUNITTABLE=RECORD
      COUNT:DWORD;
      INITSTAT:DWORD;
      PROCS:ARRAY[1..MAXUNITS] OF TUNITENTRY;
     END;
VAR UNITTABLE:TUNITTABLE;EXTERNAL NAME 'INITFINAL';
PROCEDURE UNITFINALPROC(P:TPROCEDURE);
BEGIN
 UNITTABLE.PROCS[UNITTABLE.INITSTAT].FINAL:=P;
END;
PROCEDURE INITIALIZEUNITS;[PUBLIC,ALIAS:'FPC_INITIALIZEUNITS'];
VAR I:DWORD;
    MEMP:DWORD;
BEGIN
 INITSTARTUPALLOC;
 INITGDT;
 INITMEM;
 FOR I:=1 TO UNITTABLE.COUNT DO
 BEGIN
  IF UNITTABLE.PROCS[I].INIT<>NIL THEN UNITTABLE.PROCS[I].INIT;
  UNITTABLE.INITSTAT:=I;
 END;
END;
PROCEDURE DO_EXIT;[PUBLIC,ALIAS:'FPC_DO_EXIT'];
VAR I:DWORD;
BEGIN
 FOR I:=UNITTABLE.COUNT DOWNTO 1 DO
 BEGIN
  IF UNITTABLE.PROCS[I].FINAL<>NIL THEN UNITTABLE.PROCS[I].FINAL;
 END;
 DONEGDT;
 ASM
   CLI
   CLTS
   MOV SS,[RETURN_SS]
   MOV ESP,[RETURN_ESP]
   MOV EAX,CR0
   AND EAX,2147483647
   MOV CR0,EAX
   MOV EBX,[SHUTDOWNFLAG]
   RETF
 END;
END;
PROCEDURE HALT;
BEGIN
 DO_EXIT;
END;
{$I ..\FPINC\I386.INC}
END. 
