UNIT TASKS;
{$ASMMODE INTEL}
INTERFACE
USES DEBUG,DRIVERS;
{ Es gibt noch keine Prfung, ob genug Speicher vorhanden ist ! }
CONST STARTSTACKSIZE=4096*4;
TYPE PPROCESS=^TPROCESS;
     PTASK=^TTASK;
     TPROCESS=RECORD
      GLOBALNEXT,GLOBALLAST:PPROCESS;
      NEXT,LAST,FATHER,CHILD:PPROCESS;
      PAGEDIR:PDWORDARRAY;
      TASK_LOCK:TLOCK;
      TASK_READ:TREADSTAT;
      TASKS:PTASK;
      RESTPROCESS:LONGBOOL;
      HASOWNPAGEDIR:LONGBOOL;
      MAXIMUMPRIO:DWORD;
      DESC:STRING;
     END;
     TTASK=PACKED RECORD
      TSS_BACKLINK:DWORD;
      TSS_ESP0:DWORD;
      TSS_SS0:DWORD;
      TSS_ESP1:DWORD;
      TSS_SS1:DWORD;
      TSS_ESP2:DWORD;
      TSS_SS2:DWORD;
      TSS_CR3:DWORD;
      TSS_EIP:DWORD;
      TSS_EFLAGS:DWORD;
      TSS_EAX:DWORD;
      TSS_ECX:DWORD;
      TSS_EDX:DWORD;
      TSS_EBX:DWORD;
      TSS_ESP:DWORD;
      TSS_EBP:DWORD;
      TSS_ESI:DWORD;
      TSS_EDI:DWORD;
      TSS_ES:DWORD;
      TSS_CS:DWORD;
      TSS_SS:DWORD;
      TSS_DS:DWORD;
      TSS_FS:DWORD;
      TSS_GS:DWORD;
      TSS_LDT:DWORD;
      TSS_IO:DWORD;
      NEXT,LAST:PTASK;
      PROCESS:PPROCESS;
      RUNNING:DWORD;
      ENABLECOUNT:DWORD;
      SENABLECOUNT:DWORD;
      STACK_START:POINTER;
      STACK_SIZE:DWORD;
      DESCRIPTOR:DWORD;
      PRIO:DWORD;
      SCHED:DWORD;
      READGR:DWORD;
      SIZE:DWORD;
      DESC:STRING;
     END;
FUNCTION CREATEPROCESS(FATHER:PPROCESS;MAXP:DWORD;DESC:STRING):PPROCESS;
FUNCTION CREATETASK(PROCESS:PPROCESS;OFS:POINTER;PRIO:DWORD;DESC:STRING):PTASK;
FUNCTION CREATEV86TASK(PROCESS:PPROCESS;OFS:POINTER;PRIO:DWORD;DESC:STRING;PORTSON:BOOLEAN):PTASK;
PROCEDURE DESTROYTASK(TASK:PTASK;CB:POINTER);
PROCEDURE DESTROYPROCESS(PROCESS:PPROCESS;CB:POINTER);
PROCEDURE DESTROYDRIVER(BASE:POINTER;SIZE:DWORD;PROCESS:PPROCESS);
PROCEDURE INITIALRUN;
PROCEDURE SWITCHTOTASK(P:PTASK);
FUNCTION GETTASKHANDLE:PTASK;
FUNCTION GETPROCESSHANDLE:PPROCESS;
FUNCTION GETFIRSTPROCESS:PPROCESS;
FUNCTION GETNEXTPROCESS(P:PPROCESS):PPROCESS;
FUNCTION STARTREADPROCESS:DWORD;
PROCEDURE STOPREADPROCESS(GR:DWORD);
PROCEDURE ENABLETASK(P:PTASK);
PROCEDURE DISABLETASK(P:PTASK);
FUNCTION GETTASKENABLE(P:PTASK):DWORD;
FUNCTION ENTERSCHEDULER(P:PTASK):LONGBOOL;
FUNCTION GETSYSTEMPROCESS:PPROCESS;
PROCEDURE FREETASKSPROT(NR:DWORD);
VAR PROCESS_LOCK:TLOCK;
    HELPTASK_LOCK:TLOCK;
    PROCESS_READ:TREADSTAT;   
    HELPTASK:TTASK;
    FIRSTPROCESS,TASKSPROCESS,TASKSDELETEPROCESS:PPROCESS;
    TASKSTASK,TASKSDELETETASK:PTASK;
IMPLEMENTATION
FUNCTION STARTREADTASKS(P:PPROCESS):DWORD;
BEGIN
 STARTREADTASKS:=STARTREAD(@P^.TASK_READ);
END;
PROCEDURE STOPREADTASKS(P:PPROCESS;GR:DWORD);
BEGIN
 STOPREAD(@P^.TASK_READ,GR);
END;
PROCEDURE TASKSTASKPROC;
BEGIN
 WHILE TRUE DO
 BEGIN
  WAITFORREADCYCL(@PROCESS_READ);
  IF TASKSDELETETASK<>NIL THEN
  BEGIN
   RELEASEMEM(TASKSDELETETASK,TASKSDELETETASK^.SIZE);
   TASKSDELETETASK:=NIL;
  END;
  IF TASKSDELETEPROCESS<>NIL THEN
  BEGIN
   RELEASEMEM(TASKSDELETEPROCESS,SIZEOF(TPROCESS));
   TASKSDELETEPROCESS:=NIL;
  END;
  FREELOCK(@HELPTASK_LOCK);
  DISABLETASK(TASKSTASK);
 END;
END;
PROCEDURE WAITUNTILTSSNOTBUSY(DESC:DWORD);ASSEMBLER;
ASM
  MOV EAX,DESC
  MOV ESI,[GDTTABLE]
 @LP:
  BT WORD [ESI+4+EAX],9
  JNC @EXT
  CALL SCHEDULE
  JMP @LP
 @EXT:
END;
PROCEDURE DESTROYDRIVERTASK(BASE:POINTER;SIZE:DWORD;TASK:PTASK);
BEGIN
 RELEASEMEM(BASE,SIZE);
 IF TASK<>NIL THEN DESTROYTASK(TASK,NIL);
END;
PROCEDURE DESTROYDRIVER(BASE:POINTER;SIZE:DWORD;PROCESS:PPROCESS);
BEGIN
 RELEASEMEM(BASE,SIZE);
 IF PROCESS<>NIL THEN DESTROYPROCESS(PROCESS,NIL);
END;
FUNCTION ENTERSCHEDULER(P:PTASK):LONGBOOL;
BEGIN
 ENTERSCHEDULER:=TRYTOSETDWORD(@P^.SCHED);
 IF ENTERSCHEDULER THEN P^.READGR:=STARTREAD(@PROCESS_READ);
END;
PROCEDURE LEAVESCHEDULER(P:PTASK);
BEGIN
 STOPREAD(@PROCESS_READ,P^.READGR);
 P^.SCHED:=0;
END;
FUNCTION GETTASKENABLE(P:PTASK):DWORD;
BEGIN
 GETTASKENABLE:=P^.ENABLECOUNT;
END;
PROCEDURE SDISABLETASK(P:PTASK);ASSEMBLER;
ASM
  MOV EDI,P
  LOCK DEC DWORD [EDI+TTASK.SENABLECOUNT]
  MOV EAX,[EDI+TTASK.ENABLECOUNT]
  OR EAX,EAX
  JNZ @EXT
  CALL SCHEDULE
 @EXT:
END;
PROCEDURE SENABLETASK(P:PTASK);ASSEMBLER;
ASM
  MOV EDI,P
  LOCK INC DWORD [EDI+TTASK.SENABLECOUNT]
END;
PROCEDURE DISABLETASK(P:PTASK);ASSEMBLER;
ASM
  MOV EDI,P
  LOCK DEC DWORD [EDI+TTASK.ENABLECOUNT]
  MOV EAX,[EDI+TTASK.ENABLECOUNT]
  OR EAX,EAX                                                       
  JNZ @EXT
  CALL SCHEDULE
 @EXT:
END;
PROCEDURE ENABLETASK(P:PTASK);ASSEMBLER;
ASM
  MOV EDI,P
  LOCK INC DWORD [EDI+TTASK.ENABLECOUNT]
END;
FUNCTION GETNEXTPROCESS(P:PPROCESS):PPROCESS;
BEGIN
 GETNEXTPROCESS:=P^.GLOBALNEXT;
END;
FUNCTION STARTREADPROCESS:DWORD;
BEGIN
 STARTREADPROCESS:=STARTREAD(@PROCESS_READ);
END;
PROCEDURE STOPREADPROCESS(GR:DWORD);
BEGIN
 STOPREAD(@PROCESS_READ,GR);
END;
PROCEDURE SETTASKPRIO(TASK:PTASK;PRIO:DWORD);
BEGIN
 IF PRIO>TASK^.PROCESS^.MAXIMUMPRIO THEN PRIO:=TASK^.PROCESS^.MAXIMUMPRIO;
 TASK^.PRIO:=PRIO;
END;
PROCEDURE DEFAULTSCHED;
VAR NS,S,AS,P:PTASK;
    U:PPROCESS;
    PR:DWORD;
    LEAVE:LONGBOOL;
BEGIN
 S:=GETTASKHANDLE();
 AS:=S;
 IF NOT ENTERSCHEDULER(AS) THEN EXIT;
 P:=S;
 U:=S^.PROCESS;
 NS:=NIL;
 PR:=0;
 REPEAT
  IF NS<>NIL THEN
  BEGIN
   S:=NS;
   NS:=NIL;
  END;
  IF P^.NEXT=NIL THEN
  BEGIN
   REPEAT
    IF U=NIL THEN U:=FIRSTPROCESS ELSE
     IF U^.GLOBALNEXT=NIL THEN U:=FIRSTPROCESS ELSE U:=U^.GLOBALNEXT;
   UNTIL U^.TASKS<>NIL;
   P:=U^.TASKS;
  END ELSE P:=P^.NEXT;
  IF S=@HELPTASK THEN NS:=P;
  IF (P^.SENABLECOUNT<>0) AND (P^.ENABLECOUNT<>0) AND
     ((P^.RUNNING=0) OR (P=AS)) AND (P^.PRIO>PR) THEN PR:=P^.PRIO;
 UNTIL (P=S);
 P:=S;
 U:=S^.PROCESS;
 REPEAT   
  IF P^.NEXT=NIL THEN
  BEGIN
   REPEAT
    IF U=NIL THEN U:=FIRSTPROCESS ELSE
     IF U^.GLOBALNEXT=NIL THEN U:=FIRSTPROCESS ELSE U:=U^.GLOBALNEXT;
   UNTIL U^.TASKS<>NIL;
   P:=U^.TASKS;
  END ELSE P:=P^.NEXT;
 UNTIL ((P^.PRIO>=PR) AND (P^.ENABLECOUNT<>0) AND (P^.SENABLECOUNT<>0)
       AND (TRYTOSETDWORD(@P^.RUNNING) OR (P=AS)));
 LEAVESCHEDULER(AS);
 IF P<>AS THEN
 BEGIN
  AS^.RUNNING:=0;
  SWITCHTOTASK(P);
 END;
END;
{ Die Task mu schon reserviert und berprft worden sein ! }
FUNCTION GETPROCESSHANDLE:PPROCESS;
BEGIN
 GETPROCESSHANDLE:=PTASK(GDT_GETBASE(GETTASKREG))^.PROCESS;
END;
FUNCTION GETTASKHANDLE:PTASK;
BEGIN
 GETTASKHANDLE:=GDT_GETBASE(GETTASKREG);
END;
PROCEDURE DESTROYPROCESS(PROCESS:PPROCESS;CB:POINTER);
VAR P,P2,S:PTASK;
    OWNER:LONGBOOL;
    PRO,PRO2:PPROCESS;
BEGIN
 { Die Prozedur sollte noch so verndert werden, da sie alle Tasks
   herausnimmt auer der eigenen (wenn ntig).
   Dann reicht ein WAITFORREADCYCL nmlich aus ! }
 S:=GETTASKHANDLE;
 GETLOCK(@PROCESS_LOCK); { So, kein anderer kann mehr was machen ! }
 P:=PROCESS^.TASKS;
 OWNER:=FALSE;
 WHILE P<>NIL DO
 BEGIN
  P2:=P^.NEXT;
  IF P=S THEN OWNER:=TRUE ELSE { Ist es die eigene Task ? }
  BEGIN
   WHILE NOT TRYTOSETDWORD(@P^.RUNNING) DO SCHEDULE;
   WAITUNTILTSSNOTBUSY(P^.DESCRIPTOR);
   IF P^.LAST<>NIL THEN P^.LAST^.NEXT:=P^.NEXT ELSE PROCESS^.TASKS:=P^.NEXT;
   IF P^.NEXT<>NIL THEN P^.NEXT^.LAST:=P^.LAST;
   WAITFORREADCYCL(@PROCESS_READ);
   RELEASEMEM(P,P^.SIZE);
  END;
  P:=P2;
 END;
 PROCESS^.RESTPROCESS:=TRUE; { Es knnen keine Subprozesse mehr erstellt werden ! }
 IF PROCESS^.FATHER<>NIL THEN { Macht es Sinn ? }
 BEGIN
  PRO:=PROCESS^.FATHER;
  IF PROCESS^.LAST<>NIL THEN PROCESS^.LAST^.NEXT:=PROCESS^.NEXT ELSE PRO^.CHILD:=PROCESS^.NEXT;
  IF PROCESS^.NEXT<>NIL THEN PROCESS^.NEXT^.LAST:=PROCESS^.LAST;
  WHILE (PRO<>NIL) AND (PRO^.RESTPROCESS) AND (PRO^.CHILD=NIL) DO
  BEGIN
   PRO2:=PRO^.FATHER;
   IF PRO2<>NIL THEN { Sonst gar nicht erst anfangen zu klinken }
   BEGIN
    IF PRO^.LAST<>NIL THEN PRO^.LAST^.NEXT:=PRO^.NEXT ELSE PRO2^.CHILD:=PRO^.NEXT;
    IF PRO^.NEXT<>NIL THEN PRO^.NEXT^.LAST:=PRO^.LAST;
   END;
   WAITFORREADCYCL(@PROCESS_READ); { <- Hier wre eine Trennung
    zwischen TREE und GLOBAL sinnvoll ! }
   RELEASEMEM(PRO,SIZEOF(TPROCESS));
   PRO:=PRO2;
  END;
 END;
 { Alle zustzlichen Datenblcke freigeben : Lokale CR3 etc ! }
 IF OWNER THEN
 BEGIN
  GETLOCK(@HELPTASK_LOCK); { Das gelobte HELPTASK }
  CLEARINTERRUPTFLAG;
 END;
 IF PROCESS^.GLOBALLAST<>NIL THEN PROCESS^.GLOBALLAST^.GLOBALNEXT:=PROCESS^.GLOBALNEXT ELSE
  FIRSTPROCESS:=PROCESS^.GLOBALNEXT;
 IF PROCESS^.GLOBALNEXT<>NIL THEN PROCESS^.GLOBALNEXT^.GLOBALLAST:=PROCESS^.GLOBALLAST;
 FREELOCK(@PROCESS_LOCK);
 IF CB<>NIL THEN PDWORD(CB)^:=0;
 IF OWNER THEN
 BEGIN
  IF PROCESS^.CHILD=NIL THEN TASKSDELETEPROCESS:=PROCESS;  
  TASKSDELETETASK:=S;
  ENABLETASK(TASKSTASK);
  HELPTASK.SCHED:=0;
  ASM
    MOV EAX,[HELPTASK.DESCRIPTOR]
    MOV ESI,[GDTTABLE]
   @LP:
    BT WORD [ESI+4+EAX],9
    JC @LP
    LTR AX
  END;
  SCHEDULE;
 END
 ELSE
 BEGIN
  WAITFORREADCYCL(@PROCESS_READ);{ Ja immer, falls ein Dummy erstellt wird,
   und dann sofort gelscht wird...knnte immer noch ein ungnstig
   Aufgerufener Task drauf zugreifen. So geht es jedoch nicht, und wir
   knnen unbesorgt lschen ! }
  IF PROCESS^.CHILD<>NIL THEN RELEASEMEM(PROCESS,SIZEOF(TPROCESS));
 END;
END;
PROCEDURE DESTROYTASK(TASK:PTASK;CB:POINTER);
VAR S:PTASK;
    U:PPROCESS;
BEGIN
 GETLOCK(@PROCESS_LOCK);
 S:=GETTASKHANDLE;
 IF S=TASK THEN
 BEGIN
  GETLOCK(@HELPTASK_LOCK);
  CLEARINTERRUPTFLAG {<- Wegen HELPTSS-Zone->no sched !}
 END
 ELSE
 BEGIN
  WHILE NOT TRYTOSETDWORD(@TASK^.RUNNING) DO SCHEDULE;
  WAITUNTILTSSNOTBUSY(TASK^.DESCRIPTOR);
 END;
 U:=TASK^.PROCESS;
 IF TASK^.LAST<>NIL THEN TASK^.LAST^.NEXT:=TASK^.NEXT ELSE U^.TASKS:=TASK^.NEXT;
 IF TASK^.NEXT<>NIL THEN TASK^.NEXT^.LAST:=TASK^.LAST;
 IF CB<>NIL THEN PDWORD(CB)^:=0;
 IF S=TASK THEN
 BEGIN
  FREELOCK(@PROCESS_LOCK); 
  TASKSDELETETASK:=TASK;
  ENABLETASK(TASKSTASK);
  HELPTASK.SCHED:=0;
  ASM    
    MOV EAX,[HELPTASK.DESCRIPTOR]
    MOV ESI,[GDTTABLE]
   @LP:
    BT WORD [ESI+4+EAX],9
    JC @LP
    LTR AX
  END;
  SCHEDULE;
 END
 ELSE
 BEGIN
  WAITFORREADCYCL(@PROCESS_READ);
  FREELOCK(@PROCESS_LOCK);
  RELEASEMEM(TASK,TASK^.SIZE);
 END;
END;
PROCEDURE SWITCHTOTASK(P:PTASK);ASSEMBLER;
ASM
  MOV EDI,P
  MOV EAX,[EDI+TTASK.DESCRIPTOR]
  MOV ESI,[GDTTABLE]
 @LP:
  BT WORD [ESI+4+EAX],9
  JC @LP
  PUSH EAX
  PUSH EAX
  DB 0FFh,02Ch,024h
  ADD ESP,8
END;
PROCEDURE INITIALRUN;
BEGIN
 IF FIRSTPROCESS=NIL THEN EXIT;
 HELPTASK.TSS_IO:=104 SHL 16;   
 HELPTASK.PROCESS:=NIL;
 HELPTASK.DESCRIPTOR:=GDT_ADDTSS(@HELPTASK,104);
 ASM
   MOV EDI,[HELPTASK.DESCRIPTOR]
   LTR DI
 END;
 SCHEDULE;
END;
FUNCTION CREATEV86TASK(PROCESS:PPROCESS;OFS:POINTER;PRIO:DWORD;DESC:STRING;PORTSON:BOOLEAN):PTASK;
VAR P:PTASK;   
BEGIN
 { Wie sieht es aus, wenn der Process gerade gelscht wird ? -> To do }
 P:=ALLOCMEM(SIZEOF(TTASK)+8193);
 IF PORTSON THEN FILLCHAR(P^,SIZEOF(TTASK)+8192,0) ELSE
 BEGIN
  FILLCHAR(P^,SIZEOF(TTASK),0);
  FILLCHAR((POINTER(P)+SIZEOF(TTASK))^,8192,$FF);
 END;
 BYTE((POINTER(P)+SIZEOF(TTASK)+8192)^):=$FF;
 P^.DESC:=DESC;
 P^.SIZE:=SIZEOF(TTASK)+8193;
 P^.STACK_START:=ALLOCMEM(STARTSTACKSIZE);
 P^.STACK_SIZE:=STARTSTACKSIZE;
 P^.PROCESS:=PROCESS;
 P^.TSS_EIP:=DWORD(OFS);
 P^.TSS_CS:=$8;
 P^.TSS_ES:=$10;
 P^.TSS_SS:=$10;
 P^.TSS_SS0:=$10;
 P^.TSS_DS:=$10;
 P^.TSS_FS:=$10;
 P^.TSS_GS:=$10;
 P^.TSS_CR3:=DWORD(PROCESS^.PAGEDIR);
 P^.TSS_ESP:=DWORD(P^.STACK_START)+P^.STACK_SIZE;
 P^.TSS_ESP0:=P^.TSS_ESP;
 P^.TSS_IO:=SIZEOF(TTASK) SHL 16;
 P^.TSS_LDT:=GDT_ADDLDT(NIL,7);
 IF PROCESS^.MAXIMUMPRIO<PRIO THEN PRIO:=PROCESS^.MAXIMUMPRIO;
 P^.PRIO:=PRIO;
 P^.ENABLECOUNT:=1;
 P^.SENABLECOUNT:=1;
 P^.DESCRIPTOR:=GDT_ADDTSS(P,SIZEOF(TTASK)+8193);
 P^.LAST:=NIL;
 GETLOCK(@PROCESS^.TASK_LOCK);
 P^.NEXT:=PROCESS^.TASKS;
 IF P^.NEXT<>NIL THEN P^.NEXT^.LAST:=P;
 PROCESS^.TASKS:=P;
 FREELOCK(@PROCESS^.TASK_LOCK);
 CREATEV86TASK:=P;
END;
FUNCTION CREATETASK(PROCESS:PPROCESS;OFS:POINTER;PRIO:DWORD;DESC:STRING):PTASK;
VAR P:PTASK;   
BEGIN
 { Wie sieht es aus, wenn der Process gerade gelscht wird ? -> To do }
 CREATETASK:=NIL;
 P:=ALLOCMEM(SIZEOF(TTASK));
 IF P=NIL THEN EXIT;
 FILLCHAR(P^,SIZEOF(TTASK),0);
 P^.DESC:=DESC;
 P^.SIZE:=SIZEOF(TTASK);
 P^.STACK_START:=ALLOCMEM(STARTSTACKSIZE);
 IF P^.STACK_START=NIL THEN EXIT;
 P^.STACK_SIZE:=STARTSTACKSIZE;
 P^.PROCESS:=PROCESS;
 P^.TSS_EIP:=DWORD(OFS);
 P^.TSS_CS:=$8;
 P^.TSS_ES:=$10;
 P^.TSS_SS:=$10;
 P^.TSS_SS0:=$10;
 P^.TSS_DS:=$10;
 P^.TSS_FS:=$10;
 P^.TSS_GS:=$10;
 P^.TSS_CR3:=DWORD(PROCESS^.PAGEDIR);
 P^.TSS_ESP:=DWORD(P^.STACK_START)+P^.STACK_SIZE;
 P^.TSS_ESP0:=P^.TSS_ESP;
 P^.TSS_IO:=104 SHL 16;
 P^.TSS_LDT:=GDT_ADDLDT(NIL,7);
 IF P^.TSS_LDT=0 THEN EXIT; {RRR}
 IF PROCESS^.MAXIMUMPRIO<PRIO THEN PRIO:=PROCESS^.MAXIMUMPRIO;
 P^.PRIO:=PRIO;
 P^.ENABLECOUNT:=1;
 P^.SENABLECOUNT:=1;
 P^.DESCRIPTOR:=GDT_ADDTSS(P,104);
 IF P^.DESCRIPTOR=0 THEN EXIT; {RRR}
 P^.LAST:=NIL;
 GETLOCK(@PROCESS^.TASK_LOCK);
 P^.NEXT:=PROCESS^.TASKS;
 IF P^.NEXT<>NIL THEN P^.NEXT^.LAST:=P;
 PROCESS^.TASKS:=P;
 FREELOCK(@PROCESS^.TASK_LOCK);
 CREATETASK:=P;
END;
FUNCTION CREATEPROCESS(FATHER:PPROCESS;MAXP:DWORD;DESC:STRING):PPROCESS;
VAR P:PPROCESS;
BEGIN 
 P:=ALLOCMEM(SIZEOF(TPROCESS));
 GETLOCK(@PROCESS_LOCK);
 P^.DESC:=DESC;
 RESETATOM(@P^.TASK_LOCK);
 RESETREAD(@P^.TASK_READ);
 P^.TASKS:=NIL;
 P^.PAGEDIR:=SYSTEMPAGEDIR;
 P^.HASOWNPAGEDIR:=FALSE;
 IF (FATHER<>NIL) AND (FATHER^.MAXIMUMPRIO<MAXP) THEN MAXP:=FATHER^.MAXIMUMPRIO;
 P^.MAXIMUMPRIO:=MAXP;
 P^.LAST:=NIL;
 P^.FATHER:=FATHER;
 P^.CHILD:=NIL;
 IF FATHER<>NIL THEN
 BEGIN
  P^.NEXT:=FATHER^.CHILD;
  IF P^.NEXT<>NIL THEN P^.NEXT^.LAST:=P;
  FATHER^.CHILD:=P;
 END ELSE P^.NEXT:=NIL;
 P^.GLOBALNEXT:=FIRSTPROCESS;
 P^.GLOBALLAST:=NIL;
 IF FIRSTPROCESS<>NIL THEN FIRSTPROCESS^.GLOBALLAST:=P;
 FIRSTPROCESS:=P;
 FREELOCK(@PROCESS_LOCK);
 CREATEPROCESS:=P;
END;
FUNCTION GETFIRSTPROCESS:PPROCESS;
BEGIN
 GETFIRSTPROCESS:=FIRSTPROCESS;
END;
PROCEDURE DEINITIALIZETASKSDRV;
BEGIN
 SIGNALSHUTDOWNOK;
 DESTROYPROCESS(GETPROCESSHANDLE(),NIL);
END;
PROCEDURE FREETASKSPROT(NR:DWORD);
BEGIN
END;
CONST DRVTASKS_PROT0:ARRAY[0..1] OF POINTER=(
       @DEINITIALIZETASKSDRV,
       @FREETASKSPROT);
PROCEDURE CHANGEPROCESSDESC(P:PPROCESS;DESC:STRING);
BEGIN
 P^.DESC:=DESC;
END;
PROCEDURE CHANGETASKDESC(P:PTASK;DESC:STRING);
BEGIN
 P^.DESC:=DESC;
END;
FUNCTION GETSYSTEMPROCESS:PPROCESS;
BEGIN
 GETSYSTEMPROCESS:=TASKSPROCESS;
END;
CONST DRVTASKS_PROT1:ARRAY[0..16] OF POINTER=(
       @SCHEDULE,
       @CREATEPROCESS,
       @CREATETASK,
       @DESTROYPROCESS,
       @DESTROYTASK,
       @GETPROCESSHANDLE,
       @GETTASKHANDLE,
       @SETTASKPRIO,
       @ENABLETASK,
       @DISABLETASK,
       @DESTROYDRIVER,
       @SENABLETASK,
       @SDISABLETASK,
       @CHANGEPROCESSDESC,
       @CHANGETASKDESC,
       @GETSYSTEMPROCESS,
       @DESTROYDRIVERTASK);
FUNCTION GETFIRSTTASK(P:PPROCESS):PTASK;
BEGIN
 GETFIRSTTASK:=P^.TASKS;
END;
FUNCTION GETNEXTTASK(T:PTASK):PTASK;
BEGIN
 GETNEXTTASK:=T^.NEXT;
END;
FUNCTION GETTASKTSS(T:PTASK):DWORD;
BEGIN
 GETTASKTSS:=T^.DESCRIPTOR;
END;
FUNCTION GETTASKDESC(T:PTASK):STRING;
BEGIN
 GETTASKDESC:=T^.DESC;
END;
FUNCTION GETPROCESSDESC(P:PPROCESS):STRING;
BEGIN
 GETPROCESSDESC:=P^.DESC;
END;
CONST DRVTASKS_PROT2:ARRAY[0..13] OF POINTER=(
       @STARTREADPROCESS,
       @STOPREADPROCESS,
       @GETFIRSTPROCESS,
       @GETNEXTPROCESS,
       @GETTASKENABLE,
       @ENTERSCHEDULER,
       @LEAVESCHEDULER,
       @GETFIRSTTASK,
       @GETNEXTTASK,
       @GETTASKTSS,
       @GETTASKDESC,
       @GETPROCESSDESC,
       @STARTREADTASKS,
       @STOPREADTASKS);
FUNCTION DOCK_TASKS(PR:DWORD):POINTER;
BEGIN
 CASE PR OF
  0:DOCK_TASKS:=@DRVTASKS_PROT0;
  1:DOCK_TASKS:=@DRVTASKS_PROT1;
  2:DOCK_TASKS:=@DRVTASKS_PROT2;
  ELSE DOCK_TASKS:=NIL;
 END;
END;
CONST DRVTASKS:TDRIVER=(NEXT:NIL;LAST:NIL;TYP:1;ID:0;GETPROT:@DOCK_TASKS;
                        DESC:'Kernel32 - Tasks driver (1)');
INITIALIZATION 
 TASKSPROCESS:=CREATEPROCESS(NIL,$FFFFFFFF,'System process');
 TASKSTASK:=CREATETASK(TASKSPROCESS,@TASKSTASKPROC,$7FFFFFFF,'Kernel32 Task/Process delete help');
 TASKSTASK^.ENABLECOUNT:=0;
 SCHEDULER:=@DEFAULTSCHED;
 ADDDRIVER(@DRVTASKS);
END.
