UNIT X86;
INTERFACE
USES DEBUG,DRIVERS,TASKS;
IMPLEMENTATION
VAR REALMODE_BUFSIZE:DWORD;
    REALMODE_BUFFER:POINTER;
    REALMODE_CMD:POINTER;
    REALMODE_EXEC:POINTER;
    REALMODE_STACK:POINTER;
    REALMODE_LOCK:TLOCK;
    REALMODE_SEGMENT:DWORD;
    BUFLOCK:DWORD;
PROCEDURE GETREALMODEENV;
BEGIN
 GETLOCK(@REALMODE_LOCK);
END;
PROCEDURE FREEREALMODEENV;
BEGIN
 FREELOCK(@REALMODE_LOCK);
END;
FUNCTION GETV86PROC:POINTER;
BEGIN
 GETV86PROC:=REALMODE_EXEC;
END;
FUNCTION GETKERNEL16SEG:DWORD;
BEGIN
 GETKERNEL16SEG:=REALMODE_SEGMENT;
END;
FUNCTION GETCMDBLOCK:POINTER;
BEGIN
 GETCMDBLOCK:=REALMODE_CMD;
END;
FUNCTION GETREALMODEBUFFER(SIZE:DWORD):POINTER;
BEGIN
 IF (SIZE<=REALMODE_BUFSIZE) AND TRYTOSETDWORD(@BUFLOCK) THEN
 BEGIN
  GETREALMODEBUFFER:=REALMODE_BUFFER;
 END ELSE GETREALMODEBUFFER:=NIL;
END;
PROCEDURE RELEASEREALMODEBUFFER(P:POINTER;SIZE:DWORD);
BEGIN
 BUFLOCK:=0;
END;
CONST REALMODE_PROT1:ARRAY[0..7] OF POINTER=(
       @GETREALMODEENV,
       @FREEREALMODEENV,
       @CREATEV86TASK,
       @GETV86PROC,
       @GETKERNEL16SEG,
       @GETCMDBLOCK,
       @GETREALMODEBUFFER,
       @RELEASEREALMODEBUFFER);
PROCEDURE DEINITIALIZEREALMODEDRV;
BEGIN
 SIGNALSHUTDOWNOK;
 DESTROYPROCESS(GETPROCESSHANDLE(),NIL);
END;
PROCEDURE FREEREALMODEPROT;
BEGIN
END;
CONST REALMODE_PROT0:ARRAY[0..1] OF POINTER=(
       @DEINITIALIZEREALMODEDRV,
       @FREEREALMODEPROT);
FUNCTION DOCK_REALMODE(NR:DWORD):POINTER;
BEGIN
 CASE NR OF
  1:DOCK_REALMODE:=@REALMODE_PROT1;
  0:DOCK_REALMODE:=@REALMODE_PROT0;
  ELSE DOCK_REALMODE:=NIL;
 END;
END;
CONST REALMODEDRV:TDRIVER=(NEXT:NIL;LAST:NIL;TYP:$C;ID:0;GETPROT:@DOCK_REALMODE;
                           DESC:'Kernel32 - Virtual 80386 Realmode driver (1)');
INITIALIZATION
 REALMODE_BUFSIZE:=REALMODEDESC^[0];
 DWORD(REALMODE_BUFFER):=REALMODEDESC^[1];
 DWORD(REALMODE_CMD):=REALMODEDESC^[2];
 DWORD(REALMODE_EXEC):=REALMODEDESC^[3];
 DWORD(REALMODE_STACK):=REALMODEDESC^[4];
 DWORD(REALMODE_SEGMENT):=REALMODEDESC^[5];
 ADDDRIVER(@REALMODEDRV);
END.
